--[[
##################
PsychoUI: keivamp#
##################
]]--
local PsychoUI = LibStub("AceAddon-3.0"):NewAddon("PsychoUI", "AceEvent-3.0", "LibAboutPanel-2.0", "AceConsole-3.0")
local Dialog = LibStub("AceConfigDialog-3.0")

local db
local defaults = {
    char = {
		Draggables = {},
		lockframes = true,
        enabled = false,
		ResetBox = false,
		UsePsychoUIXP = true,
		XPMoveY = -10,
		XPMoveX = -230,
		XPWidth = 350,
		XPHeight = 15,
		ShowRested = true,
		ShowMaxXP = true,
		ShowMinXP = true,
		XPStatusBar = "Smooth",
		XPCustomFont = true,
		XPFontKey = "ThisFont",
		XPFontOutline = 4,
		XPFontSize = 12,
		XPTextY = 0,
		UseVertXP = false,
		UsePsychoUIRep = true,
		RepMoveY = -10,
		RepMoveX = 230,
		RepWidth = 350,
		RepHeight = 15,
		ShowFactionName = true,
		ShowMaxRep = true,
		ShowMinRep = true,
		RepStatusBar = "Smooth",
		RepCustomFont = true,
		RepFontKey = "ThisFont",
		RepFontOutline = 4,
		RepFontSize = 12,
		RepTextY = 0,
		UseVertRep = false,
		UsePsychoUIAze = true,
		AzeMoveY = -35,
		AzeMoveX = -230,
		AzeWidth = 350,
		AzeHeight = 15,
		AzeritePower = true,
		ShowMaxAze = true,
		ShowMinAze = true,
		AzeCustomFont = true,
		AzeStatusBar = "Smooth",
		AzeFontKey = "ThisFont",
		AzeFontOutline = 4,
		AzeFontSize = 12,
		AzeTextY = 0,
		UseVertAze = false,
		MicroScale = 1,
		MicroDisable = false,
		BagDisable = false,

		BagsScale = 1,
		OnlyMainBag = false,
		BagsBlackBorder = false,
		BagsNoBorder = false,
		BagsBorderSize = 6,
		BagsBorderPadding = 0,
		
		-- ABDisable = false,
		-- AB1ButtonSize = 40,
		-- AB1ButtonSpacing = 5,
		-- AB2ButtonSize = 40,
		-- AB2ButtonSpacing = 5,
		-- AB3ButtonSize = 40,
		-- AB3ButtonSpacing = 5,
		-- AB4ButtonSize = 40,
		-- AB4ButtonSpacing = 5,
		-- AB5ButtonSize = 40,
		-- AB5ButtonSpacing = 5,
		-- ABPetButtonSize = 28,
		-- ABPetButtonSpacing = 5,
		-- ABStanceButtonSize = 28,
		-- ABStanceButtonSpacing = 5,
		-- ABBlackBorder = false,
		-- ABNoBorder = false,
		-- ABBorderSize = 8,
		-- ABBorderPadding = 1,
		
		MMDisable = false,
		MMBlackBorder = false,
		MMNoBorder = false,
		MMBorderSize = 8,
		MMBorderPadding = 2,
		MiniMapHeight = 175,
		MiniMapWidth = 175,
		ZonefontFontKey = "ThisFont",
		ZoneFontOutline = 4,
		ZoneFontSize = 15,
		ZoneTextY = 0,
		TimefontFontKey = "ThisFont",
		TimeFontOutline = 4,
		TimeFontSize = 18,
		TimeY = -30,
		AutoVender = true,
		AutoRepair = true,
		DisablePlates = false,
		NPStatusBar = "Smooth",
		NPFontKey = "Numbers",
		NPFontOutline = 3,
		NPFontSize = 9,
		NPLevelFont = "Numbers",
		NPLevelFontOutline = 3,
		NPLevelFontSize = 9,
		NPHealthFont = "Numbers",
		NPHealthFontOutline = 3,
		NPHealthFontSize = 9,
		NPDisableAuras = false,
		ShowName = true,
		ShowLevel = true,
		ShowElite = true,
		ShowFloatingCombatText = true,
		NPBlackBorder = false,
		NPNoBorder = false,
		NPBorderSize = 8,
		NPBorderPadding = 2,
		QuestFrame = true,
		QuestFontKey = "ThisFont",
		QuestFontOutline = 4,
		QuestFontSize = 16,
		ComabatAlert = true,
		AFK = true,
		ShowGold = true,
		GoldFontKey = "ThisFont",
		GoldFontOutline = 3,
		GoldFontSize = 14,
		ShowDura = true,

		DuraFontKey = "ThisFont",
		DuraFontOutline = 3,
		DuraFontSize = 14,
		PFDisable = false,
		PFDisableAuras = false,
		PFDisablePortrait = false,
		PFDisableHealthPercent = false,
		PFDisableHealth = false,
		HealthFont = "Numbers",
		HealthFontOutline = 3,
		HealthFontSize = 11,
		PFDisableManaPercent = false,
		PFDisableMana = false,
		ManaFont = "Numbers",
		ManaFontOutline = 3,
		ManaFontSize = 11,
		PFDisableLevel = false,
		LevelFont = "Numbers",
		LevelFontOutline = 3,
		LevelFontSize = 12,
		PFDisableName = false,
		NameFont = "Dialog",
		NameFontOutline = 3,
		NameFontSize = 14,
		PFDisablePortraitBG = false,
		PortraitBGBlackOut = false,
		PFBlackBorder = false,
		PFNoBorder = false,
		PFBorderSize = 8,
		PFBorderPadding = 2,
		PFStatusBarHealth = "Smooth",
		PFStatusBarPower = "Smooth",
		PFDisableCB = false,
		PFStatusBarCB = "Smooth",
		PFStatusBarAltPower = "Smooth",
		PFScale = 1,
		PFStatusBarClassPower = "Smooth",
		PFCFNameFont = "Numbers",
		PFCFNameFontOutline = 3,
		PFCFNameFontSize = 18,
		PlayerFloatingCombatText = true,
		PFPetDisable = false,
		PFPetDisableAuras = false,
		PFPetDisablePortraitBG = false,
		PFPetDisableHealthPercent = false,
		PFPetDisableHealth = false,
		PetHealthFont = "Numbers",
		PetHealthFontOutline = 3,
		PetHealthFontSize = 9,
		PFPetDisableManaPercent = false,
		PFPetDisableMana = false,
		PetManaFont = "Numbers",
		PetManaFontOutline = 3,
		PetManaFontSize = 8,
		PFPetDisableLevel = false,
		PetLevelFont = "Numbers",
		PetLevelFontOutline = 3,
		PetLevelFontSize = 11,
		PFPetDisableName = false,
		PetNameFont = "Dialog",
		PetNameFontOutline = 3,
		PetNameFontSize = 12,
		PFPetDisablePortrait = false,
		PetPortraitBGBlackOut = false,
		PFPetBlackBorder = false,
		PFPetNoBorder = false,
		PFPetBorderSize = 8,
		PFPetBorderPadding = 2,
		PFPetStatusBarHealth = "Smooth",
		PFPetStatusBarPower = "Smooth",
		PFPetDisableCB = false,
		PFPetStatusBarCB = "Smooth",
		PFPetScale = 1,
		
		TargetFrameFCFNameFont = "Numbers",
		TargetFrameFCFNameFontOutline = 3,
		TargetFrameFCFNameFontSize = 18,
		TargetFrameFloatingCombatText = true,
		TargetFrameDisable = false,
		TargetFrameDisableAuras = false,
		TargetFrameDisableHealthPercent = false,
		TargetFrameDisableHealth = false,
		TargetFrameHealthFont = "Numbers",
		TargetFrameHealthFontOutline = 3,
		TargetFrameHealthFontSize = 11,
		TargetFrameDisableManaPercent = false,
		TargetFrameDisableMana = false,
		TargetFrameManaFont = "Numbers",
		TargetFrameManaFontOutline = 3,
		TargetFrameManaFontSize = 11,
		TargetFrameDisableLevel = false,
		TargetFrameLevelFont = "Numbers",
		TargetFrameLevelFontOutline = 3,
		TargetFrameLevelFontSize = 12,
		TargetFrameDisableName = false,
		TargetFrameNameFont = "Dialog",
		TargetFrameNameFontOutline = 3,
		TargetFrameNameFontSize = 14,
		TargetFrameDisablePortrait = false,
		TargetFrameNoBorder = false,
		TargetFrameBorderSize = 8,
		TargetFrameBorderPadding = 2,
		TargetFrameStatusBarHealth = "Smooth",
		TargetFrameStatusBarPower = "Smooth",
		TargetFrameDisableCB = false,
		TargetFrameStatusBarCB = "Smooth",
		TargetFrameScale = 1,
		
		ToTFrameDiable = false,
		ToTFrameScale = 1,
		ToTFrameNoBorder = false,
		ToTFrameBorderSize = 8,
		ToTFrameBorderPadding = 2,
		ToTFrameStatusBarHealth = "Smooth",
		ToTFrameStatusBarPower = "Smooth",
		ToTFrameDisableHealth = false,
		ToTFrameHealthFont = "Numbers",
		ToTFrameHealthFontOutline = 3,
		ToTFrameHealthFontSize = 10,
		ToTFrameDisableMana = false,
		ToTFrameManaFont = "Numbers",
		ToTFrameManaFontOutline = 3,
		ToTFrameManaFontSize = 10,
		ToTFrameDisableName = false,
		ToTFrameNameFont = "Dialog",
		ToTFrameNameFontOutline = 3,
		ToTFrameNameFontSize = 12,
		

		FocusFrameDisable = false,
		FocusFrameDisableAuras = false,
		FocusFrameDisableHealthPercent = false,
		FocusFrameDisableHealth = false,
		FocusFrameHealthFont = "Numbers",
		FocusFrameHealthFontOutline = 3,
		FocusFrameHealthFontSize = 11,
		FocusFrameDisableManaPercent = false,
		FocusFrameDisableMana = false,
		FocusFrameManaFont = "Numbers",
		FocusFrameManaFontOutline = 3,
		FocusFrameManaFontSize = 11,
		FocusFrameDisableLevel = false,
		FocusFrameLevelFont = "Numbers",
		FocusFrameLevelFontOutline = 3,
		FocusFrameLevelFontSize = 12,
		FocusFrameDisableName = false,
		FocusFrameNameFont = "Dialog",
		FocusFrameNameFontOutline = 3,
		FocusFrameNameFontSize = 14,
		FocusFrameDisablePortrait = false,
		FocusFrameNoBorder = false,
		FocusFrameBorderSize = 8,
		FocusFrameBorderPadding = 2,
		FocusFrameStatusBarHealth = "Smooth",
		FocusFrameStatusBarPower = "Smooth",
		FocusFrameDisableCB = false,
		FocusFrameStatusBarCB = "Smooth",
		FocusFrameScale = 1,
		
		FTFrameDiable = false,
		FTFrameScale = 1,
		FTFrameNoBorder = false,
		FTFrameBorderSize = 8,
		FTFrameBorderPadding = 2,
		FTFrameStatusBarHealth = "Smooth",
		FTFrameStatusBarPower = "Smooth",
		FTFrameDisableHealth = false,
		FTFrameHealthFont = "Numbers",
		FTFrameHealthFontOutline = 3,
		FTFrameHealthFontSize = 10,
		FTFrameDisableMana = false,
		FTFrameManaFont = "Numbers",
		FTFrameManaFontOutline = 3,
		FTFrameManaFontSize = 10,
		FTFrameDisableName = false,
		FTFrameNameFont = "Dialog",
		FTFrameNameFontOutline = 3,
		FTFrameNameFontSize = 12,
		
		EnableParty = true,
		EnableRaid = true,
		SoloParty = false,
		SoloRaid = false,
		
		ChatKey = "Dialog",
		ChatEditKey = "Dialog",
		ChatTabKey = "Numbers",		
		DuraX = -225,
		DuraY = -5,		
		GoldX = -285,
		GoldY = 5,		
		-- BagsX = -5,
		-- BagsY = 5,		
		-- MicroX = 10,
		-- MicroY = -10,		
		MiniMapX = -25,
		MiniMapY = -25,		
		VehicleX = 200,
		VehicleY = 0,		
		PlayerX = -235,
		PlayerY = -250,		
		TargetX = 35,
		TargetY = -250,		
		PetX = -390,
		PetY = -360,		
		TotX = 235,
		TotY = -335,		
		FocusX = -535,
		FocusY = 75,		
		FocusTX = -435,
		FocusTY = -35,		
		PartyX = 120,
		PartyY = -250,		
		RaidX = 30,
		RaidY = -120,
		
		-- AB1X = -80,
		-- AB1Y = 30,
		-- AB1Layout = 1,
		-- AB2X = -80,
		-- AB2Y = 75,
		-- AB2Layout = 1,
		-- AB3X = -80,
		-- AB3Y = 120,
		-- AB3Layout = 1,
		-- AB4X = -180,
		-- AB4Y = 0,
		-- AB4Layout = 6,
		-- AB5X = -360,
		-- AB5Y = 0,
		-- AB5Layout = 6,
		-- PetBarX = 0,
		-- PetBarY = 160,
		-- StanceX = -425,
		-- StanceY = 160,

	
    }
}

function PsychoUI:OnInitialize()
    self.db = LibStub("AceDB-3.0"):New("PsychoChar", defaults,true,true)
    self:SetEnabledState(self.db.char.enabled)
    db = self.db.char

   local Options = self:GetOptions() -- Options.lua
   
   Options.args.aboutTab = self:AboutOptionsTable("PsychoUI")
   Options.args.aboutTab.order = -1 -- -1 means "put it last"

   LibStub("AceConfig-3.0"):RegisterOptionsTable("PsychoUI", Options)
	self.optionsFrame = Dialog:AddToBlizOptions("PsychoUI", "PsychoUI")
	Dialog:SetDefaultSize("PsychoUI", 950, 650)
	--Dialog:Open("PsychoUI")
	--self.optionsFrame = Dialog:Open("PsychoUI")
	--self:RegisterChatCommand("PsychoUI", function() LibStub("AceConfigDialog-3.0"):Open("PsychoUI") end )
	--self:RegisterChatCommand("Crazy", function() LibStub("AceConfigDialog-3.0"):Open("PsychoUI") end )
	--self:RegisterChatCommand("Psycho", function() LibStub("AceConfigDialog-3.0"):Open("PsychoUI") end )
end
function PsychoUI:OnEnable()
--PsychoUI.db = defaults
end

function PsychoUI:OnDisable()
db = self.db.char
end

function PsychoUI:RefreshConfig()

end
	-- Basic Slash Command -- Ace not required --
	SLASH_PsychoUI1 = "/Psycho"
	SLASH_PsychoUI2 = "/psychoUI"
	SLASH_PsychoUI3 = "/crazy"
	_G.SlashCmdList.RELOADUI = ReloadUI
	SLASH_RELOADUI1 = "/rl"
	SLASH_RELOADUI2 = "/reload"
	SLASH_RELOADUI3 = "/reloadui"
	SlashCmdList["PsychoUI"] = function() 
	Dialog:Open("PsychoUI")
	--InterfaceOptionsFrame_OpenToCategory("PsychoUI")
	--InterfaceOptionsFrame_OpenToCategory("PsychoUI")
	--InterfaceOptionsFrame_OpenToCategory("PsychoUI")
	end