--[[
##################
PsychoUI: keivamp#
##################
]]--
local PsychoUI = LibStub("AceAddon-3.0"):GetAddon("PsychoUI")
local InCombatLockdown      = _G.InCombatLockdown;
local Bartender = IsAddOnLoaded("Bartender4")
local Dominos = IsAddOnLoaded("Dominos")
local Neuron = IsAddOnLoaded("Neuron")
if Bartender or Dominos or Neuron then return end


		local ButtonSize = 32
		local MySpacing = 5
		local BorderSize = 10
		local BorderPadding = 3
			
local playerColor = RAID_CLASS_COLORS[select(2, UnitClass('player'))]

local function CreateBackdrop(frame)
   frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
        insets = {top = -2, left = -2, bottom = -2, right = -2}})
		frame:SetBackdropColor(0,0.55,0.95,0.45)
		frame:SetBackdropBorderColor(0,0,0,1)
end

	local MoverAB1 = CreateFrame("Frame","AB1Drag",UIParent)
	MoverAB1:SetSize(ButtonSize,ButtonSize)
	MoverAB1:SetPoint("CENTER", UIParent,"BOTTOM",-80, 30)
	MoverAB1:SetClampedToScreen(true)
	MoverAB1:SetClampRectInsets(0, 0, 0,0)
	local MoverAB1Text  = MoverAB1:CreateFontString(nil, "OVERLAY")
	MoverAB1Text:SetFont("Interface\\Addons\\PsychoUI\\Fonts\\Dialog.TTF", 13, "OUTLINE")
	MoverAB1Text:SetPoint("CENTER",MoverAB1,"CENTER", 0,0); 
	MoverAB1Text:SetText("")
	local MoverAB2 = CreateFrame("Frame","AB2Drag",UIParent)
	MoverAB2:SetSize(ButtonSize,ButtonSize)
	MoverAB2:SetPoint("CENTER", UIParent,"BOTTOM",-80, 80)
	MoverAB2:SetClampedToScreen(true)
	MoverAB2:SetClampRectInsets(0, 0, 0,0)
	local MoverAB2Text  = MoverAB2:CreateFontString(nil, "OVERLAY")
	MoverAB2Text:SetFont("Interface\\Addons\\PsychoUI\\Fonts\\Dialog.TTF", 13, "OUTLINE")
	MoverAB2Text:SetPoint("CENTER",MoverAB2,"CENTER", 0,0); 
	MoverAB2Text:SetText("")
	local MoverAB3 = CreateFrame("Frame","AB3Drag",UIParent)
	MoverAB3:SetSize(ButtonSize,ButtonSize)
	MoverAB3:SetPoint("CENTER", UIParent,"BOTTOM",-80, 80)
	MoverAB3:SetClampedToScreen(true)
	MoverAB3:SetClampRectInsets(0, 0, 0,0)
	local MoverAB3Text  = MoverAB3:CreateFontString(nil, "OVERLAY")
	MoverAB3Text:SetFont("Interface\\Addons\\PsychoUI\\Fonts\\Dialog.TTF", 13, "OUTLINE")
	MoverAB3Text:SetPoint("CENTER",MoverAB3,"CENTER", 0,0); 
	MoverAB3Text:SetText("")
	local MoverAB4 = CreateFrame("Frame","AB4Drag",UIParent)
	MoverAB4:SetSize(ButtonSize,ButtonSize)
	MoverAB4:SetPoint("CENTER", UIParent,"BOTTOM",0, 30)
	MoverAB4:SetClampedToScreen(true)
	MoverAB4:SetClampRectInsets(0, 0, 0,0)
	local MoverAB4Text  = MoverAB4:CreateFontString(nil, "OVERLAY")
	MoverAB4Text:SetFont("Interface\\Addons\\PsychoUI\\Fonts\\Dialog.TTF", 13, "OUTLINE")
	MoverAB4Text:SetPoint("CENTER",MoverAB4,"CENTER", 0,0); 
	MoverAB4Text:SetText("")
	local MoverAB5 = CreateFrame("Frame","AB5Drag",UIParent)
	MoverAB5:SetSize(ButtonSize,ButtonSize)
	MoverAB5:SetPoint("CENTER", UIParent,"BOTTOM",0, 30)
	MoverAB5:SetClampedToScreen(true)
	MoverAB5:SetClampRectInsets(0, 0, 0,0)
	local MoverAB5Text  = MoverAB5:CreateFontString(nil, "OVERLAY")
	MoverAB5Text:SetFont("Interface\\Addons\\PsychoUI\\Fonts\\Dialog.TTF", 13, "OUTLINE")
	MoverAB5Text:SetPoint("CENTER",MoverAB5,"CENTER", 0,0); 
	MoverAB5Text:SetText("")
	local MoverPetBar = CreateFrame("Frame","PetBarDrag",UIParent)
	MoverPetBar:SetSize(ButtonSize,ButtonSize)
	MoverPetBar:SetPoint("CENTER",UIParent,"BOTTOM",0, 160)
	MoverPetBar:SetClampedToScreen(true)
	MoverPetBar:SetClampRectInsets(0, 0, 0,0)
	local MoverPetBarText  = MoverPetBar:CreateFontString(nil, "OVERLAY")
	MoverPetBarText:SetFont("Interface\\Addons\\PsychoUI\\Fonts\\Dialog.TTF", 13, "OUTLINE")
	MoverPetBarText:SetPoint("CENTER",MoverPetBar,"CENTER", 0,0); 
	MoverPetBarText:SetText("")
	local MoverStanceBar = CreateFrame("Frame","StanceBarDrag",UIParent)
	MoverStanceBar:SetSize(ButtonSize,ButtonSize)
	MoverStanceBar:SetPoint("CENTER",UIParent,"BOTTOM",0, 160)
	MoverStanceBar:SetClampedToScreen(true)
	MoverStanceBar:SetClampRectInsets(0, 0, 0,0)
	local MoverStanceBarText  = MoverStanceBar:CreateFontString(nil, "OVERLAY")
	MoverStanceBarText:SetFont("Interface\\Addons\\PsychoUI\\Fonts\\Dialog.TTF", 13, "OUTLINE")
	MoverStanceBarText:SetPoint("CENTER",MoverStanceBar,"CENTER", 0,0); 
	MoverStanceBarText:SetText("")
	
	local AB1X = -80
	local AB1Y = 30
	local AB2X = -80
	local AB2Y = 80
	local AB3X = -80
	local AB3Y = 130
	local AB4X = -125
	local AB4Y = 30
	local AB5X = -250
	local AB5Y = 30
	local PetBarX = -250
	local PetBarY = 0
	local StanceX = -425
	local StanceY = 160

	local function Setup(self, event)
	if PsychoUI.db.char.ABDisable == true then return end
	
	AB1X = PsychoUI.db.char.AB1X
	AB1Y = PsychoUI.db.char.AB1Y
	AB2X = PsychoUI.db.char.AB2X
	AB2Y = PsychoUI.db.char.AB2Y
	AB3X = PsychoUI.db.char.AB3X
	AB3Y = PsychoUI.db.char.AB3Y
	AB4X = PsychoUI.db.char.AB4X
	AB4Y = PsychoUI.db.char.AB4Y
	AB5X = PsychoUI.db.char.AB5X
	AB5Y = PsychoUI.db.char.AB5Y
	PetBarX = PsychoUI.db.char.PetBarX
	PetBarY = PsychoUI.db.char.PetBarY
	StanceX = PsychoUI.db.char.StanceX
	StanceY = PsychoUI.db.char.StanceY
	
	 BorderPadding = PsychoUI.db.char.ABBorderPadding
	 
		for i = 1, 12 do
			if ActionButton1:IsVisible() then
				local Holder = CreateFrame("Frame",nil,UIParent)
					Holder:SetWidth(PsychoUI.db.char.AB1ButtonSize) -- Set these to whatever height/width is needed 
					Holder:SetHeight(PsychoUI.db.char.AB1ButtonSize) -- for your Texture
					Holder:SetPoint("CENTER", _G["ActionButton"..i],"CENTER",0, 0)
					Holder:CreateBeautyBorder(BorderSize)
					Holder:SetBeautyBorderPadding(BorderPadding)
					Holder:SetBeautyBorderTexture("white")
					if PsychoUI.db.char.ABNoBorder == true then
					 Holder:SetBeautyBorderColor(0, 0, 0,0)
					else
						if PsychoUI.db.char.ABBlackBorder == true then
							Holder:SetBeautyBorderColor(0, 0, 0,1)
						else
							Holder:SetBeautyBorderColor(playerColor.r, playerColor.g, playerColor.b)
						end
					end
			end
		end
		for i = 1, 12 do
			if MultiBarBottomLeftButton1:IsVisible() then
				local Holder = CreateFrame("Frame",nil,UIParent)
					Holder:SetWidth(PsychoUI.db.char.AB2ButtonSize) -- Set these to whatever height/width is needed 
					Holder:SetHeight(PsychoUI.db.char.AB2ButtonSize) -- for your Texture
					Holder:SetPoint("CENTER", _G["MultiBarBottomLeftButton"..i],"CENTER",0, 0)
					Holder:CreateBeautyBorder(BorderSize)
					Holder:SetBeautyBorderPadding(BorderPadding)
					Holder:SetBeautyBorderTexture("white")
					if PsychoUI.db.char.ABNoBorder == true then
					 Holder:SetBeautyBorderColor(0, 0, 0,0)
					else
						if PsychoUI.db.char.ABBlackBorder == true then
							Holder:SetBeautyBorderColor(0, 0, 0,1)
						else
							Holder:SetBeautyBorderColor(playerColor.r, playerColor.g, playerColor.b)
						end
					end
			end	
		end
		for i = 1, 12 do
			if  MultiBarBottomRightButton1:IsVisible() then
				local Holder = CreateFrame("Frame",nil,UIParent)
					Holder:SetWidth(PsychoUI.db.char.AB3ButtonSize) -- Set these to whatever height/width is needed 
					Holder:SetHeight(PsychoUI.db.char.AB3ButtonSize) -- for your Texture
					Holder:SetPoint("CENTER", _G["MultiBarBottomRightButton"..i],"CENTER",0, 0)
					Holder:CreateBeautyBorder(BorderSize)
					Holder:SetBeautyBorderPadding(BorderPadding)
					Holder:SetBeautyBorderTexture("white")
					if PsychoUI.db.char.ABNoBorder == true then
					 Holder:SetBeautyBorderColor(0, 0, 0,0)
					else
						if PsychoUI.db.char.ABBlackBorder == true then
							Holder:SetBeautyBorderColor(0, 0, 0,1)
						else
							Holder:SetBeautyBorderColor(playerColor.r, playerColor.g, playerColor.b)
						end
					end
			end
		end
		for i = 1, 12 do
			if  MultiBarLeftButton1:IsVisible() then
				local Holder = CreateFrame("Frame",nil,UIParent)
					Holder:SetWidth(PsychoUI.db.char.AB4ButtonSize) -- Set these to whatever height/width is needed 
					Holder:SetHeight(PsychoUI.db.char.AB4ButtonSize) -- for your Texture
					Holder:SetPoint("CENTER", _G["MultiBarLeftButton"..i],"CENTER",0, 0)
					Holder:CreateBeautyBorder(BorderSize)
					Holder:SetBeautyBorderPadding(BorderPadding)
					Holder:SetBeautyBorderTexture("white")
					if PsychoUI.db.char.ABNoBorder == true then
					 Holder:SetBeautyBorderColor(0, 0, 0,0)
					else
						if PsychoUI.db.char.ABBlackBorder == true then
							Holder:SetBeautyBorderColor(0, 0, 0,1)
						else
							Holder:SetBeautyBorderColor(playerColor.r, playerColor.g, playerColor.b)
						end
					end
			end
		end
		for i = 1, 12 do
			if MultiBarRightButton1:IsVisible() then
				local Holder = CreateFrame("Frame",nil,UIParent)
					Holder:SetWidth(PsychoUI.db.char.AB5ButtonSize) -- Set these to whatever height/width is needed 
					Holder:SetHeight(PsychoUI.db.char.AB5ButtonSize) -- for your Texture
					Holder:SetPoint("CENTER", _G["MultiBarRightButton"..i],"CENTER",0, 0)
					Holder:CreateBeautyBorder(BorderSize)
					Holder:SetBeautyBorderPadding(BorderPadding)
					Holder:SetBeautyBorderTexture("white")
					if PsychoUI.db.char.ABNoBorder == true then
					 Holder:SetBeautyBorderColor(0, 0, 0,0)
					else
						if PsychoUI.db.char.ABBlackBorder == true then
							Holder:SetBeautyBorderColor(0, 0, 0,1)
						else
							Holder:SetBeautyBorderColor(playerColor.r, playerColor.g, playerColor.b)
						end
					end
			end
		end
	--ActionButton1:ignoreFramePositionManager(true)
	
	ActionButton1:SetParent(UIParent)
	--print( ActionButton1:GetParent():GetName())
 	ActionButton1:ClearAllPoints();
	--ActionButton1:SetPoint("CENTER", UIParent,"BOTTOM",-80, ((PsychoUI.db.char.AB1ButtonSize+PsychoUI.db.char.AB1ButtonSpacing)*0.5)+15)
	ActionButton1:SetPoint("CENTER", UIParent,"BOTTOM",AB1X, AB1Y)

	PetActionButton1:ClearAllPoints();
	PetActionButton1:SetPoint("CENTER",  UIParent,"BOTTOM",PetBarX, PetBarY)
	
	StanceButton1:ClearAllPoints();
	StanceButton1:SetPoint("CENTER", UIParent,"BOTTOM", StanceX, StanceY)

	for i=1, NUM_STANCE_SLOTS do
		_G["StanceButton"..i]:SetWidth(PsychoUI.db.char.ABStanceButtonSize)
		_G["StanceButton"..i]:SetHeight(PsychoUI.db.char.ABStanceButtonSize)
		_G["StanceButton"..i]:CreateBeautyBorder(BorderSize)
		_G["StanceButton"..i]:SetBeautyBorderPadding(BorderPadding)
		_G["StanceButton"..i]:SetBeautyBorderTexture("white")
			if PsychoUI.db.char.ABNoBorder == true then
				_G["StanceButton"..i]:SetBeautyBorderColor(0, 0, 0,0)
				else
					if PsychoUI.db.char.ABBlackBorder == true then
						_G["StanceButton"..i]:SetBeautyBorderColor(0, 0, 0,1)
					else
						_G["StanceButton"..i]:SetBeautyBorderColor(playerColor.r, playerColor.g, playerColor.b)
					end
				end

    end
	 for i=1, NUM_PET_ACTION_SLOTS do
		_G["PetActionButton"..i]:SetWidth(PsychoUI.db.char.ABPetButtonSize)
		_G["PetActionButton"..i]:SetHeight(PsychoUI.db.char.ABPetButtonSize) 
		_G["PetActionButton"..i]:CreateBeautyBorder(BorderSize)
		_G["PetActionButton"..i]:SetBeautyBorderPadding(BorderPadding)
		_G["PetActionButton"..i]:SetBeautyBorderTexture("white")
			if PsychoUI.db.char.ABNoBorder == true then
				_G["PetActionButton"..i]:SetBeautyBorderColor(0, 0, 0,0)
				else
					if PsychoUI.db.char.ABBlackBorder == true then
						_G["PetActionButton"..i]:SetBeautyBorderColor(0, 0, 0,1)
					else
						_G["PetActionButton"..i]:SetBeautyBorderColor(playerColor.r, playerColor.g, playerColor.b)
					end
			end
    end

	for i = 1, 12 do
	_G["ActionButton"..i]:SetWidth(PsychoUI.db.char.AB1ButtonSize)
	_G["ActionButton"..i]:SetHeight(PsychoUI.db.char.AB1ButtonSize)
	_G["ActionButton"..i]:CreateBeautyBorder(BorderSize)
	_G["ActionButton"..i]:SetBeautyBorderPadding(BorderPadding)
	_G["ActionButton"..i]:SetBeautyBorderTexture("white")
			if PsychoUI.db.char.ABNoBorder == true then
				_G["ActionButton"..i]:SetBeautyBorderColor(0, 0, 0,0)
				else
					if PsychoUI.db.char.ABBlackBorder == true then
						_G["ActionButton"..i]:SetBeautyBorderColor(0, 0, 0,1)
					else
						_G["ActionButton"..i]:SetBeautyBorderColor(playerColor.r, playerColor.g, playerColor.b)
					end
			end

	_G["MultiBarBottomLeftButton"..i]:SetWidth(PsychoUI.db.char.AB2ButtonSize)
	_G["MultiBarBottomLeftButton"..i]:SetHeight(PsychoUI.db.char.AB2ButtonSize)
	_G["MultiBarBottomLeftButton"..i]:CreateBeautyBorder(BorderSize)
	_G["MultiBarBottomLeftButton"..i]:SetBeautyBorderPadding(BorderPadding)
	_G["MultiBarBottomLeftButton"..i]:SetBeautyBorderTexture("white")
			if PsychoUI.db.char.ABNoBorder == true then
				_G["MultiBarBottomLeftButton"..i]:SetBeautyBorderColor(0, 0, 0,0)
				else
					if PsychoUI.db.char.ABBlackBorder == true then
						_G["MultiBarBottomLeftButton"..i]:SetBeautyBorderColor(0, 0, 0,1)
					else
						_G["MultiBarBottomLeftButton"..i]:SetBeautyBorderColor(playerColor.r, playerColor.g, playerColor.b)
					end
			end
	_G["MultiBarBottomRightButton"..i]:SetWidth(PsychoUI.db.char.AB3ButtonSize)
	_G["MultiBarBottomRightButton"..i]:SetHeight(PsychoUI.db.char.AB3ButtonSize)
	_G["MultiBarBottomRightButton"..i]:CreateBeautyBorder(BorderSize)
	_G["MultiBarBottomRightButton"..i]:SetBeautyBorderPadding(BorderPadding)
	_G["MultiBarBottomRightButton"..i]:SetBeautyBorderTexture("white")
			if PsychoUI.db.char.ABNoBorder == true then
				_G["MultiBarBottomRightButton"..i]:SetBeautyBorderColor(0, 0, 0,0)
				else
					if PsychoUI.db.char.ABBlackBorder == true then
						_G["MultiBarBottomRightButton"..i]:SetBeautyBorderColor(0, 0, 0,1)
					else
						_G["MultiBarBottomRightButton"..i]:SetBeautyBorderColor(playerColor.r, playerColor.g, playerColor.b)
					end
			end
	_G["MultiBarLeftButton"..i]:SetWidth(PsychoUI.db.char.AB4ButtonSize)
	_G["MultiBarLeftButton"..i]:SetHeight(PsychoUI.db.char.AB4ButtonSize)
	_G["MultiBarLeftButton"..i]:CreateBeautyBorder(BorderSize)
	_G["MultiBarLeftButton"..i]:SetBeautyBorderPadding(BorderPadding)
	_G["MultiBarLeftButton"..i]:SetBeautyBorderTexture("white")
			if PsychoUI.db.char.ABNoBorder == true then
				_G["MultiBarLeftButton"..i]:SetBeautyBorderColor(0, 0, 0,0)
				else
					if PsychoUI.db.char.ABBlackBorder == true then
						_G["MultiBarLeftButton"..i]:SetBeautyBorderColor(0, 0, 0,1)
					else
						_G["MultiBarLeftButton"..i]:SetBeautyBorderColor(playerColor.r, playerColor.g, playerColor.b)
					end
			end
	_G["MultiBarRightButton"..i]:SetWidth(PsychoUI.db.char.AB5ButtonSize)
	_G["MultiBarRightButton"..i]:SetHeight(PsychoUI.db.char.AB5ButtonSize)
	_G["MultiBarRightButton"..i]:CreateBeautyBorder(BorderSize)
	_G["MultiBarRightButton"..i]:SetBeautyBorderPadding(BorderPadding)
	_G["MultiBarRightButton"..i]:SetBeautyBorderTexture("white")
			if PsychoUI.db.char.ABNoBorder == true then
				_G["MultiBarRightButton"..i]:SetBeautyBorderColor(0, 0, 0,0)
				else
					if PsychoUI.db.char.ABBlackBorder == true then
						_G["MultiBarRightButton"..i]:SetBeautyBorderColor(0, 0, 0,1)
					else
						_G["MultiBarRightButton"..i]:SetBeautyBorderColor(playerColor.r, playerColor.g, playerColor.b)
					end
			end
	end
	
	for i = 2, 12 do
	--action bar 2 & 3
		_G["ActionButton"..i]:ClearAllPoints();
		_G["ActionButton"..i]:SetPoint("CENTER", _G["ActionButton"..i-1],"CENTER",PsychoUI.db.char.AB1ButtonSize+PsychoUI.db.char.AB1ButtonSpacing, 0)
		_G["MultiBarBottomLeftButton"..i]:ClearAllPoints();
		_G["MultiBarBottomLeftButton"..i]:SetPoint("CENTER", _G["MultiBarBottomLeftButton"..i-1],"CENTER",PsychoUI.db.char.AB2ButtonSize+PsychoUI.db.char.AB2ButtonSpacing, 0)
		_G["MultiBarBottomRightButton"..i]:ClearAllPoints();
		_G["MultiBarBottomRightButton"..i]:SetPoint("CENTER", _G["MultiBarBottomRightButton"..i-1],"CENTER",PsychoUI.db.char.AB3ButtonSize+PsychoUI.db.char.AB3ButtonSpacing, 0)

	end
	for i = 1, 12 do
		
		_G["MultiBarLeftButton"..i]:ClearAllPoints();
		_G["MultiBarLeftButton"..i]:SetPoint("CENTER", _G["MultiBarLeftButton"..i-1],"CENTER",0, PsychoUI.db.char.AB4ButtonSize+PsychoUI.db.char.AB4ButtonSpacing)
		_G["MultiBarRightButton"..i]:ClearAllPoints();
		_G["MultiBarRightButton"..i]:SetPoint("CENTER", _G["MultiBarRightButton"..i-1],"CENTER",0, PsychoUI.db.char.AB5ButtonSize+PsychoUI.db.char.AB5ButtonSpacing)
	end
	
	--MultiBarBottomLeftButton1:SetParent(UIParent)
	MultiBarBottomLeftButton1:ClearAllPoints();
	MultiBarBottomLeftButton1:SetPoint("CENTER", UIParent,"BOTTOM",AB2X, AB2Y)	
	
	MultiBarBottomRightButton1:ClearAllPoints();
	MultiBarBottomRightButton1:SetPoint("CENTER", UIParent,"BOTTOM",AB3X, AB3Y)	
	
	MultiBarRightButton1:ClearAllPoints();
	MultiBarRightButton1:SetPoint("CENTER", ActionButton1,"BOTTOM",AB4X, AB4Y)	
	
	MultiBarLeftButton1:ClearAllPoints();
	MultiBarLeftButton1:SetPoint("CENTER", ActionButton1,"BOTTOM",AB5X, AB5Y)	
	--AB1 Layout
	if PsychoUI.db.char.AB1Layout == 1 then
	-- 1 x 12
	ActionButton1:ClearAllPoints();
	ActionButton1:SetPoint("CENTER", UIParent,"BOTTOM",AB1X, AB1Y)	
	elseif PsychoUI.db.char.AB1Layout == 2 then
	-- 2 x 6
		ActionButton1:ClearAllPoints();
		ActionButton7:ClearAllPoints();
		ActionButton7:SetPoint("CENTER", ActionButton1,"CENTER",0, PsychoUI.db.char.AB1ButtonSize+PsychoUI.db.char.AB1ButtonSpacing)
		ActionBarUpButton:SetPoint("LEFT", ActionButton6,"RIGHT",4,6)
		ActionBarDownButton:ClearAllPoints();
		ActionBarDownButton:SetPoint("LEFT", ActionButton6,"RIGHT",5,-14)
	elseif PsychoUI.db.char.AB1Layout == 3 then
	-- 3 x 4
		ActionButton1:ClearAllPoints();
		ActionButton5:ClearAllPoints();
		ActionButton5:SetPoint("CENTER", ActionButton1,"CENTER",0, PsychoUI.db.char.AB1ButtonSize+PsychoUI.db.char.AB1ButtonSpacing)
		ActionButton9:ClearAllPoints();
		ActionButton9:SetPoint("CENTER", ActionButton5,"CENTER",0, PsychoUI.db.char.AB1ButtonSize+PsychoUI.db.char.AB1ButtonSpacing)
		ActionBarUpButton:ClearAllPoints();
		ActionBarUpButton:SetPoint("CENTER", ActionButton4,"CENTER",PsychoUI.db.char.AB1ButtonSize,10)
		ActionBarDownButton:ClearAllPoints();
		ActionBarDownButton:SetPoint("CENTER", ActionButton4,"CENTER",PsychoUI.db.char.AB1ButtonSize,-10)

	elseif PsychoUI.db.char.AB1Layout == 4 then
	-- 12 x 1
		ActionButton1:ClearAllPoints();
		ActionButton1:SetPoint("CENTER", UIParent,"BOTTOM",AB1X, AB1Y)
		ActionButton2:ClearAllPoints();
		ActionButton2:SetPoint("CENTER", ActionButton1,"CENTER",0, PsychoUI.db.char.AB1ButtonSize+PsychoUI.db.char.AB1ButtonSpacing)
		ActionButton3:ClearAllPoints();
		ActionButton3:SetPoint("CENTER", ActionButton2,"CENTER",0, PsychoUI.db.char.AB1ButtonSize+PsychoUI.db.char.AB1ButtonSpacing)
		ActionButton4:ClearAllPoints();
		ActionButton4:SetPoint("CENTER", ActionButton3,"CENTER",0, PsychoUI.db.char.AB1ButtonSize+PsychoUI.db.char.AB1ButtonSpacing)
		ActionButton5:ClearAllPoints();
		ActionButton5:SetPoint("CENTER", ActionButton4,"CENTER",0, PsychoUI.db.char.AB1ButtonSize+PsychoUI.db.char.AB1ButtonSpacing)
		ActionButton6:ClearAllPoints();
		ActionButton6:SetPoint("CENTER", ActionButton5,"CENTER",0, PsychoUI.db.char.AB1ButtonSize+PsychoUI.db.char.AB1ButtonSpacing)
		ActionButton7:ClearAllPoints();
		ActionButton7:SetPoint("CENTER", ActionButton6,"CENTER",0, PsychoUI.db.char.AB1ButtonSize+PsychoUI.db.char.AB1ButtonSpacing)
		ActionButton8:ClearAllPoints();
		ActionButton8:SetPoint("CENTER", ActionButton7,"CENTER",0, PsychoUI.db.char.AB1ButtonSize+PsychoUI.db.char.AB1ButtonSpacing)
		ActionButton9:ClearAllPoints();
		ActionButton9:SetPoint("CENTER", ActionButton8,"CENTER",0, PsychoUI.db.char.AB1ButtonSize+PsychoUI.db.char.AB1ButtonSpacing)
		ActionButton10:ClearAllPoints();
		ActionButton10:SetPoint("CENTER", ActionButton9,"CENTER",0, PsychoUI.db.char.AB1ButtonSize+PsychoUI.db.char.AB1ButtonSpacing)
		ActionButton11:ClearAllPoints();
		ActionButton11:SetPoint("CENTER", ActionButton10,"CENTER",0, PsychoUI.db.char.AB1ButtonSize+PsychoUI.db.char.AB1ButtonSpacing)
		ActionButton12:ClearAllPoints();
		ActionButton12:SetPoint("CENTER", ActionButton11,"CENTER",0, PsychoUI.db.char.AB1ButtonSize+PsychoUI.db.char.AB1ButtonSpacing)
		ActionBarUpButton:ClearAllPoints();
		ActionBarUpButton:SetPoint("CENTER", ActionButton1,"CENTER",PsychoUI.db.char.AB1ButtonSize,10)
		ActionBarDownButton:ClearAllPoints();
		ActionBarDownButton:SetPoint("CENTER", ActionButton1,"CENTER",PsychoUI.db.char.AB1ButtonSize,-10)	
	elseif PsychoUI.db.char.AB1Layout == 5 then
		-- 6 x 2
		ActionButton1:ClearAllPoints();
		ActionButton1:SetPoint("CENTER", UIParent,"BOTTOM",AB1X, AB1Y)
		ActionButton3:ClearAllPoints();
		ActionButton3:SetPoint("CENTER", ActionButton1,"CENTER",0, PsychoUI.db.char.AB1ButtonSize+PsychoUI.db.char.AB1ButtonSpacing)
		ActionButton5:ClearAllPoints();
		ActionButton5:SetPoint("CENTER", ActionButton3,"CENTER",0, PsychoUI.db.char.AB1ButtonSize+PsychoUI.db.char.AB1ButtonSpacing)
		ActionButton7:ClearAllPoints();
		ActionButton7:SetPoint("CENTER", ActionButton1,"CENTER",0, (PsychoUI.db.char.AB1ButtonSize+PsychoUI.db.char.AB1ButtonSpacing)*3)
		ActionButton9:ClearAllPoints();
		ActionButton9:SetPoint("CENTER", ActionButton7,"CENTER",0, PsychoUI.db.char.AB1ButtonSize+PsychoUI.db.char.AB1ButtonSpacing)
		ActionButton11:ClearAllPoints();
		ActionButton11:SetPoint("CENTER", ActionButton9,"CENTER",0, PsychoUI.db.char.AB1ButtonSize+PsychoUI.db.char.AB1ButtonSpacing)
		ActionBarUpButton:ClearAllPoints();
		ActionBarUpButton:SetPoint("CENTER", ActionButton2,"CENTER",PsychoUI.db.char.AB1ButtonSize,10)
		ActionBarDownButton:ClearAllPoints();
		ActionBarDownButton:SetPoint("CENTER", ActionButton2,"CENTER",PsychoUI.db.char.AB1ButtonSize,-10)
	
	elseif PsychoUI.db.char.AB1Layout == 6 then
	-- 4 x 3
		ActionButton1:ClearAllPoints();
		ActionButton4:ClearAllPoints();
		ActionButton4:SetPoint("CENTER", ActionButton1,"CENTER",0, PsychoUI.db.char.AB1ButtonSize+PsychoUI.db.char.AB1ButtonSpacing)
		ActionButton7:ClearAllPoints();
		ActionButton7:SetPoint("CENTER", ActionButton4,"CENTER",0, PsychoUI.db.char.AB1ButtonSize+PsychoUI.db.char.AB1ButtonSpacing)
		ActionButton10:ClearAllPoints();
		ActionButton10:SetPoint("CENTER", ActionButton7,"CENTER",0, PsychoUI.db.char.AB1ButtonSize+PsychoUI.db.char.AB1ButtonSpacing)
		ActionBarUpButton:ClearAllPoints();
		ActionBarUpButton:SetPoint("CENTER", ActionButton3,"CENTER",PsychoUI.db.char.AB1ButtonSize,10)
		ActionBarDownButton:ClearAllPoints();
		ActionBarDownButton:SetPoint("CENTER", ActionButton3,"CENTER",PsychoUI.db.char.AB1ButtonSize,-10)		

	end
	--AB2 Layout
	if PsychoUI.db.char.AB2Layout == 1 then
	-- 1 x 12
	MultiBarBottomLeftButton1:ClearAllPoints();
	MultiBarBottomLeftButton1:SetPoint("CENTER", UIParent,"BOTTOM",AB2X, AB2Y)	
	elseif PsychoUI.db.char.AB2Layout == 2 then
	-- 2 x 6
		MultiBarBottomLeftButton1:ClearAllPoints();
		MultiBarBottomLeftButton1:SetPoint("CENTER", UIParent,"BOTTOM",AB2X, AB2Y)	
		MultiBarBottomLeftButton7:ClearAllPoints();
		MultiBarBottomLeftButton7:SetPoint("CENTER", MultiBarBottomLeftButton1,"CENTER",0, PsychoUI.db.char.AB2ButtonSize+PsychoUI.db.char.AB2ButtonSpacing)
		
	elseif PsychoUI.db.char.AB2Layout == 3 then
	-- 3 x 4
		MultiBarBottomLeftButton1:ClearAllPoints();
		MultiBarBottomLeftButton1:SetPoint("CENTER", UIParent,"BOTTOM",AB2X, AB2Y)	
		MultiBarBottomLeftButton5:ClearAllPoints();
		MultiBarBottomLeftButton5:SetPoint("CENTER", MultiBarBottomLeftButton1,"CENTER",0, PsychoUI.db.char.AB2ButtonSize+PsychoUI.db.char.AB2ButtonSpacing)
		MultiBarBottomLeftButton9:ClearAllPoints();
		MultiBarBottomLeftButton9:SetPoint("CENTER", MultiBarBottomLeftButton5,"CENTER",0, PsychoUI.db.char.AB2ButtonSize+PsychoUI.db.char.AB2ButtonSpacing)
	elseif PsychoUI.db.char.AB2Layout == 4 then
	-- 12 x 1
		MultiBarBottomLeftButton1:ClearAllPoints();
		MultiBarBottomLeftButton1:SetPoint("CENTER", UIParent,"BOTTOM",AB2X, AB2Y)	
		MultiBarBottomLeftButton2:ClearAllPoints();
		MultiBarBottomLeftButton2:SetPoint("CENTER",MultiBarBottomLeftButton1,"CENTER",0, PsychoUI.db.char.AB2ButtonSize+PsychoUI.db.char.AB2ButtonSpacing)
		MultiBarBottomLeftButton3:ClearAllPoints();
		MultiBarBottomLeftButton3:SetPoint("CENTER", MultiBarBottomLeftButton2,"CENTER",0, PsychoUI.db.char.AB2ButtonSize+PsychoUI.db.char.AB2ButtonSpacing)
		MultiBarBottomLeftButton4:ClearAllPoints();
		MultiBarBottomLeftButton4:SetPoint("CENTER", MultiBarBottomLeftButton3,"CENTER",0, PsychoUI.db.char.AB2ButtonSize+PsychoUI.db.char.AB2ButtonSpacing)
		MultiBarBottomLeftButton5:ClearAllPoints();
		MultiBarBottomLeftButton5:SetPoint("CENTER", MultiBarBottomLeftButton4,"CENTER",0, PsychoUI.db.char.AB2ButtonSize+PsychoUI.db.char.AB2ButtonSpacing)
		MultiBarBottomLeftButton6:ClearAllPoints();
		MultiBarBottomLeftButton6:SetPoint("CENTER", MultiBarBottomLeftButton5,"CENTER",0, PsychoUI.db.char.AB2ButtonSize+PsychoUI.db.char.AB2ButtonSpacing)
		MultiBarBottomLeftButton7:ClearAllPoints();
		MultiBarBottomLeftButton7:SetPoint("CENTER", MultiBarBottomLeftButton6,"CENTER",0, PsychoUI.db.char.AB2ButtonSize+PsychoUI.db.char.AB2ButtonSpacing)
		MultiBarBottomLeftButton8:ClearAllPoints();
		MultiBarBottomLeftButton8:SetPoint("CENTER", MultiBarBottomLeftButton7,"CENTER",0, PsychoUI.db.char.AB2ButtonSize+PsychoUI.db.char.AB2ButtonSpacing)
		MultiBarBottomLeftButton9:ClearAllPoints();
		MultiBarBottomLeftButton9:SetPoint("CENTER", MultiBarBottomLeftButton8,"CENTER",0, PsychoUI.db.char.AB2ButtonSize+PsychoUI.db.char.AB2ButtonSpacing)
		MultiBarBottomLeftButton10:ClearAllPoints();
		MultiBarBottomLeftButton10:SetPoint("CENTER", MultiBarBottomLeftButton9,"CENTER",0, PsychoUI.db.char.AB2ButtonSize+PsychoUI.db.char.AB2ButtonSpacing)
		MultiBarBottomLeftButton11:ClearAllPoints();
		MultiBarBottomLeftButton11:SetPoint("CENTER", MultiBarBottomLeftButton10,"CENTER",0, PsychoUI.db.char.AB2ButtonSize+PsychoUI.db.char.AB2ButtonSpacing)
		MultiBarBottomLeftButton12:ClearAllPoints();
		MultiBarBottomLeftButton12:SetPoint("CENTER", MultiBarBottomLeftButton11,"CENTER",0, PsychoUI.db.char.AB2ButtonSize+PsychoUI.db.char.AB2ButtonSpacing)
	
	elseif PsychoUI.db.char.AB2Layout == 5 then
		-- 6 x 2
		MultiBarBottomLeftButton1:ClearAllPoints();
		MultiBarBottomLeftButton1:SetPoint("CENTER", UIParent,"BOTTOM",AB2X, AB2Y)	
		MultiBarBottomLeftButton3:ClearAllPoints();
		MultiBarBottomLeftButton3:SetPoint("CENTER", MultiBarBottomLeftButton1,"CENTER",0, PsychoUI.db.char.AB2ButtonSize+PsychoUI.db.char.AB2ButtonSpacing)
		MultiBarBottomLeftButton5:ClearAllPoints();
		MultiBarBottomLeftButton5:SetPoint("CENTER", MultiBarBottomLeftButton3,"CENTER",0, PsychoUI.db.char.AB2ButtonSize+PsychoUI.db.char.AB2ButtonSpacing)
		MultiBarBottomLeftButton7:ClearAllPoints();
		MultiBarBottomLeftButton7:SetPoint("CENTER", MultiBarBottomLeftButton1,"CENTER",0, (PsychoUI.db.char.AB2ButtonSize+PsychoUI.db.char.AB2ButtonSpacing)*3)
		MultiBarBottomLeftButton9:ClearAllPoints();
		MultiBarBottomLeftButton9:SetPoint("CENTER", MultiBarBottomLeftButton7,"CENTER",0, PsychoUI.db.char.AB2ButtonSize+PsychoUI.db.char.AB2ButtonSpacing)
		MultiBarBottomLeftButton11:ClearAllPoints();
		MultiBarBottomLeftButton11:SetPoint("CENTER", MultiBarBottomLeftButton9,"CENTER",0, PsychoUI.db.char.AB2ButtonSize+PsychoUI.db.char.AB2ButtonSpacing)
		
	
	elseif PsychoUI.db.char.AB2Layout == 6 then
	-- 4 x 3
		MultiBarBottomLeftButton1:ClearAllPoints();
		MultiBarBottomLeftButton1:SetPoint("CENTER", UIParent,"BOTTOM",AB2X, AB2Y)	
		MultiBarBottomLeftButton4:ClearAllPoints();
		MultiBarBottomLeftButton4:SetPoint("CENTER", MultiBarBottomLeftButton1,"CENTER",0, PsychoUI.db.char.AB2ButtonSize+PsychoUI.db.char.AB2ButtonSpacing)
		MultiBarBottomLeftButton7:ClearAllPoints();
		MultiBarBottomLeftButton7:SetPoint("CENTER", MultiBarBottomLeftButton4,"CENTER",0, PsychoUI.db.char.AB2ButtonSize+PsychoUI.db.char.AB2ButtonSpacing)
		MultiBarBottomLeftButton10:ClearAllPoints();
		MultiBarBottomLeftButton10:SetPoint("CENTER", MultiBarBottomLeftButton7,"CENTER",0, PsychoUI.db.char.AB2ButtonSize+PsychoUI.db.char.AB2ButtonSpacing)
			

	end
	--AB3 Layout
	if PsychoUI.db.char.AB3Layout == 1 then
	-- 1 x 12
	MultiBarBottomRightButton1:ClearAllPoints();
	MultiBarBottomRightButton1:SetPoint("CENTER", UIParent,"BOTTOM",AB3X, AB3Y)	
	elseif PsychoUI.db.char.AB3Layout == 2 then
	-- 2 x 6
		MultiBarBottomRightButton1:ClearAllPoints();
		MultiBarBottomRightButton1:SetPoint("CENTER", UIParent,"BOTTOM",AB3X, AB3Y)	
		MultiBarBottomRightButton7:ClearAllPoints();
		MultiBarBottomRightButton7:SetPoint("CENTER", MultiBarBottomRightButton1,"CENTER",0, PsychoUI.db.char.AB3ButtonSize+PsychoUI.db.char.AB3ButtonSpacing)
		
	elseif PsychoUI.db.char.AB3Layout == 3 then
	-- 3 x 4
		MultiBarBottomRightButton1:ClearAllPoints();
		MultiBarBottomRightButton1:SetPoint("CENTER", UIParent,"BOTTOM",AB3X, AB3Y)	
		MultiBarBottomRightButton5:ClearAllPoints();
		MultiBarBottomRightButton5:SetPoint("CENTER", MultiBarBottomRightButton1,"CENTER",0, PsychoUI.db.char.AB3ButtonSize+PsychoUI.db.char.AB3ButtonSpacing)
		MultiBarBottomRightButton9:ClearAllPoints();
		MultiBarBottomRightButton9:SetPoint("CENTER", MultiBarBottomRightButton5,"CENTER",0, PsychoUI.db.char.AB3ButtonSize+PsychoUI.db.char.AB3ButtonSpacing)
	elseif PsychoUI.db.char.AB3Layout == 4 then
	-- 12 x 1
		MultiBarBottomRightButton1:ClearAllPoints();
		MultiBarBottomRightButton1:SetPoint("CENTER", UIParent,"BOTTOM",AB3X, AB3Y)	
		MultiBarBottomRightButton2:ClearAllPoints();
		MultiBarBottomRightButton2:SetPoint("CENTER",MultiBarBottomRightButton1,"CENTER",0, PsychoUI.db.char.AB3ButtonSize+PsychoUI.db.char.AB3ButtonSpacing)
		MultiBarBottomRightButton3:ClearAllPoints();
		MultiBarBottomRightButton3:SetPoint("CENTER", MultiBarBottomRightButton2,"CENTER",0, PsychoUI.db.char.AB3ButtonSize+PsychoUI.db.char.AB3ButtonSpacing)
		MultiBarBottomRightButton4:ClearAllPoints();
		MultiBarBottomRightButton4:SetPoint("CENTER", MultiBarBottomRightButton3,"CENTER",0, PsychoUI.db.char.AB3ButtonSize+PsychoUI.db.char.AB3ButtonSpacing)
		MultiBarBottomRightButton5:ClearAllPoints();
		MultiBarBottomRightButton5:SetPoint("CENTER", MultiBarBottomRightButton4,"CENTER",0, PsychoUI.db.char.AB3ButtonSize+PsychoUI.db.char.AB3ButtonSpacing)
		MultiBarBottomRightButton6:ClearAllPoints();
		MultiBarBottomRightButton6:SetPoint("CENTER", MultiBarBottomRightButton5,"CENTER",0, PsychoUI.db.char.AB3ButtonSize+PsychoUI.db.char.AB3ButtonSpacing)
		MultiBarBottomRightButton7:ClearAllPoints();
		MultiBarBottomRightButton7:SetPoint("CENTER", MultiBarBottomRightButton6,"CENTER",0, PsychoUI.db.char.AB3ButtonSize+PsychoUI.db.char.AB3ButtonSpacing)
		MultiBarBottomRightButton8:ClearAllPoints();
		MultiBarBottomRightButton8:SetPoint("CENTER", MultiBarBottomRightButton7,"CENTER",0, PsychoUI.db.char.AB3ButtonSize+PsychoUI.db.char.AB3ButtonSpacing)
		MultiBarBottomRightButton9:ClearAllPoints();
		MultiBarBottomRightButton9:SetPoint("CENTER", MultiBarBottomRightButton8,"CENTER",0, PsychoUI.db.char.AB3ButtonSize+PsychoUI.db.char.AB3ButtonSpacing)
		MultiBarBottomRightButton10:ClearAllPoints();
		MultiBarBottomRightButton10:SetPoint("CENTER", MultiBarBottomRightButton9,"CENTER",0, PsychoUI.db.char.AB3ButtonSize+PsychoUI.db.char.AB3ButtonSpacing)
		MultiBarBottomRightButton11:ClearAllPoints();
		MultiBarBottomRightButton11:SetPoint("CENTER", MultiBarBottomRightButton10,"CENTER",0, PsychoUI.db.char.AB3ButtonSize+PsychoUI.db.char.AB3ButtonSpacing)
		MultiBarBottomRightButton12:ClearAllPoints();
		MultiBarBottomRightButton12:SetPoint("CENTER", MultiBarBottomRightButton11,"CENTER",0, PsychoUI.db.char.AB3ButtonSize+PsychoUI.db.char.AB3ButtonSpacing)
	
	elseif PsychoUI.db.char.AB3Layout == 5 then
		-- 6 x 2
		MultiBarBottomRightButton1:ClearAllPoints();
		MultiBarBottomRightButton1:SetPoint("CENTER", UIParent,"BOTTOM",AB3X, AB3Y)	
		MultiBarBottomRightButton3:ClearAllPoints();
		MultiBarBottomRightButton3:SetPoint("CENTER", MultiBarBottomRightButton1,"CENTER",0, PsychoUI.db.char.AB3ButtonSize+PsychoUI.db.char.AB3ButtonSpacing)
		MultiBarBottomRightButton5:ClearAllPoints();
		MultiBarBottomRightButton5:SetPoint("CENTER", MultiBarBottomRightButton3,"CENTER",0, PsychoUI.db.char.AB3ButtonSize+PsychoUI.db.char.AB3ButtonSpacing)
		MultiBarBottomRightButton7:ClearAllPoints();
		MultiBarBottomRightButton7:SetPoint("CENTER", MultiBarBottomRightButton1,"CENTER",0, (PsychoUI.db.char.AB3ButtonSize+PsychoUI.db.char.AB3ButtonSpacing)*3)
		MultiBarBottomRightButton9:ClearAllPoints();
		MultiBarBottomRightButton9:SetPoint("CENTER", MultiBarBottomRightButton7,"CENTER",0, PsychoUI.db.char.AB3ButtonSize+PsychoUI.db.char.AB3ButtonSpacing)
		MultiBarBottomRightButton11:ClearAllPoints();
		MultiBarBottomRightButton11:SetPoint("CENTER", MultiBarBottomRightButton9,"CENTER",0, PsychoUI.db.char.AB3ButtonSize+PsychoUI.db.char.AB3ButtonSpacing)
		
	
	elseif PsychoUI.db.char.AB3Layout == 6 then
	-- 4 x 3
		MultiBarBottomRightButton1:ClearAllPoints();
		MultiBarBottomRightButton1:SetPoint("CENTER", UIParent,"BOTTOM",AB3X, AB3Y)	
		MultiBarBottomRightButton4:ClearAllPoints();
		MultiBarBottomRightButton4:SetPoint("CENTER", MultiBarBottomRightButton1,"CENTER",0, PsychoUI.db.char.AB3ButtonSize+PsychoUI.db.char.AB3ButtonSpacing)
		MultiBarBottomRightButton7:ClearAllPoints();
		MultiBarBottomRightButton7:SetPoint("CENTER", MultiBarBottomRightButton4,"CENTER",0, PsychoUI.db.char.AB3ButtonSize+PsychoUI.db.char.AB3ButtonSpacing)
		MultiBarBottomRightButton10:ClearAllPoints();
		MultiBarBottomRightButton10:SetPoint("CENTER", MultiBarBottomRightButton7,"CENTER",0, PsychoUI.db.char.AB3ButtonSize+PsychoUI.db.char.AB3ButtonSpacing)
			

	end
	--AB4 Layout
	if PsychoUI.db.char.AB4Layout == 1 then
	-- 1 x 12
	MultiBarRightButton1:ClearAllPoints();
		MultiBarRightButton1:SetPoint("CENTER", ActionButton1,"CENTER",AB4X, AB4Y)	
		MultiBarRightButton2:ClearAllPoints();
		MultiBarRightButton2:SetPoint("CENTER", MultiBarRightButton1,"CENTER",PsychoUI.db.char.AB4ButtonSize+PsychoUI.db.char.AB4ButtonSpacing, 0)
		MultiBarRightButton3:ClearAllPoints();
		MultiBarRightButton3:SetPoint("CENTER", MultiBarRightButton2,"CENTER",PsychoUI.db.char.AB4ButtonSize+PsychoUI.db.char.AB4ButtonSpacing, 0)
		MultiBarRightButton4:ClearAllPoints();
		MultiBarRightButton4:SetPoint("CENTER", MultiBarRightButton3,"CENTER",PsychoUI.db.char.AB4ButtonSize+PsychoUI.db.char.AB4ButtonSpacing, 0)
		MultiBarRightButton5:ClearAllPoints();
		MultiBarRightButton5:SetPoint("CENTER", MultiBarRightButton4,"CENTER",PsychoUI.db.char.AB4ButtonSize+PsychoUI.db.char.AB4ButtonSpacing, 0)
		MultiBarRightButton6:ClearAllPoints();
		MultiBarRightButton6:SetPoint("CENTER", MultiBarRightButton5,"CENTER",PsychoUI.db.char.AB4ButtonSize+PsychoUI.db.char.AB4ButtonSpacing, 0)
		MultiBarRightButton7:ClearAllPoints();
		MultiBarRightButton7:SetPoint("CENTER", MultiBarRightButton6,"CENTER",PsychoUI.db.char.AB4ButtonSize+PsychoUI.db.char.AB4ButtonSpacing, 0)
		MultiBarRightButton8:ClearAllPoints();
		MultiBarRightButton8:SetPoint("CENTER", MultiBarRightButton7,"CENTER",PsychoUI.db.char.AB4ButtonSize+PsychoUI.db.char.AB4ButtonSpacing, 0)
		MultiBarRightButton9:ClearAllPoints();
		MultiBarRightButton9:SetPoint("CENTER", MultiBarRightButton8,"CENTER",PsychoUI.db.char.AB4ButtonSize+PsychoUI.db.char.AB4ButtonSpacing, 0)
		MultiBarRightButton10:ClearAllPoints();
		MultiBarRightButton10:SetPoint("CENTER", MultiBarRightButton9,"CENTER",PsychoUI.db.char.AB4ButtonSize+PsychoUI.db.char.AB4ButtonSpacing, 0)
		MultiBarRightButton11:ClearAllPoints();
		MultiBarRightButton11:SetPoint("CENTER", MultiBarRightButton10,"CENTER",PsychoUI.db.char.AB4ButtonSize+PsychoUI.db.char.AB4ButtonSpacing,0)
		MultiBarRightButton12:ClearAllPoints();
		MultiBarRightButton12:SetPoint("CENTER", MultiBarRightButton11,"CENTER",PsychoUI.db.char.AB4ButtonSize+PsychoUI.db.char.AB4ButtonSpacing,0)
	
	elseif PsychoUI.db.char.AB4Layout == 2 then
	-- 2 x 6
		MultiBarRightButton1:ClearAllPoints();
		MultiBarRightButton1:SetPoint("CENTER", ActionButton1,"CENTER",AB4X, AB4Y)	
		MultiBarRightButton3:ClearAllPoints();
		MultiBarRightButton3:SetPoint("CENTER", MultiBarRightButton1,"CENTER",PsychoUI.db.char.AB4ButtonSize+PsychoUI.db.char.AB4ButtonSpacing, 0)
		MultiBarRightButton5:ClearAllPoints();
		MultiBarRightButton5:SetPoint("CENTER", MultiBarRightButton3,"CENTER",PsychoUI.db.char.AB4ButtonSize+PsychoUI.db.char.AB4ButtonSpacing, 0)
		MultiBarRightButton7:ClearAllPoints();
		MultiBarRightButton7:SetPoint("CENTER", MultiBarRightButton1,"CENTER",(PsychoUI.db.char.AB4ButtonSize+PsychoUI.db.char.AB4ButtonSpacing)*3,0 )
		MultiBarRightButton9:ClearAllPoints();
		MultiBarRightButton9:SetPoint("CENTER", MultiBarRightButton7,"CENTER",PsychoUI.db.char.AB4ButtonSize+PsychoUI.db.char.AB4ButtonSpacing, 0)
		MultiBarRightButton11:ClearAllPoints();
		MultiBarRightButton11:SetPoint("CENTER", MultiBarRightButton9,"CENTER",PsychoUI.db.char.AB4ButtonSize+PsychoUI.db.char.AB4ButtonSpacing, 0)
		
	elseif PsychoUI.db.char.AB4Layout == 3 then
	-- 3 x 4
		MultiBarRightButton1:ClearAllPoints();
		MultiBarRightButton1:SetPoint("CENTER", ActionButton1,"CENTER",AB4X, AB4Y)	
		MultiBarRightButton5:ClearAllPoints();
		MultiBarRightButton5:SetPoint("CENTER", MultiBarRightButton1,"CENTER",PsychoUI.db.char.AB4ButtonSize+PsychoUI.db.char.AB4ButtonSpacing, 0)
		MultiBarRightButton9:ClearAllPoints();
		MultiBarRightButton9:SetPoint("CENTER", MultiBarRightButton5,"CENTER",PsychoUI.db.char.AB4ButtonSize+PsychoUI.db.char.AB4ButtonSpacing, 0)
	elseif PsychoUI.db.char.AB4Layout == 4 then
	-- 12 x 1
		MultiBarRightButton1:ClearAllPoints();
		MultiBarRightButton1:SetPoint("CENTER", ActionButton1,"CENTER",AB4X, AB4Y)	
	
	elseif PsychoUI.db.char.AB4Layout == 5 then
		-- 6 x 2
		
		MultiBarRightButton1:ClearAllPoints();
		MultiBarRightButton1:SetPoint("CENTER", ActionButton1,"CENTER",AB4X, AB4Y)	
		MultiBarRightButton7:ClearAllPoints();
		MultiBarRightButton7:SetPoint("CENTER", MultiBarRightButton1,"CENTER",PsychoUI.db.char.AB4ButtonSize+PsychoUI.db.char.AB4ButtonSpacing, 0)
		
	
	elseif PsychoUI.db.char.AB4Layout == 6 then
	-- 4 x 3
		MultiBarRightButton1:ClearAllPoints();
		MultiBarRightButton1:SetPoint("CENTER", ActionButton1,"CENTER",AB4X, AB4Y)
		MultiBarRightButton4:ClearAllPoints();
		MultiBarRightButton4:SetPoint("CENTER", MultiBarRightButton1,"CENTER",PsychoUI.db.char.AB4ButtonSize+PsychoUI.db.char.AB4ButtonSpacing, 0)
		MultiBarRightButton7:ClearAllPoints();
		MultiBarRightButton7:SetPoint("CENTER", MultiBarRightButton4,"CENTER",PsychoUI.db.char.AB4ButtonSize+PsychoUI.db.char.AB4ButtonSpacing, 0)
		MultiBarRightButton10:ClearAllPoints();
		MultiBarRightButton10:SetPoint("CENTER", MultiBarRightButton7,"CENTER",PsychoUI.db.char.AB4ButtonSize+PsychoUI.db.char.AB4ButtonSpacing, 0)
			

	end
	
--AB5 Layout
	if PsychoUI.db.char.AB5Layout == 1 then
	-- 1 x 12
	MultiBarLeftButton1:ClearAllPoints();
		MultiBarLeftButton1:SetPoint("CENTER", ActionButton1,"CENTER",AB5X, AB5Y)	
		MultiBarLeftButton2:ClearAllPoints();
		MultiBarLeftButton2:SetPoint("CENTER", MultiBarLeftButton1,"CENTER",PsychoUI.db.char.AB5ButtonSize+PsychoUI.db.char.AB5ButtonSpacing, 0)
		MultiBarLeftButton3:ClearAllPoints();
		MultiBarLeftButton3:SetPoint("CENTER", MultiBarLeftButton2,"CENTER",PsychoUI.db.char.AB5ButtonSize+PsychoUI.db.char.AB5ButtonSpacing, 0)
		MultiBarLeftButton4:ClearAllPoints();
		MultiBarLeftButton4:SetPoint("CENTER", MultiBarLeftButton3,"CENTER",PsychoUI.db.char.AB5ButtonSize+PsychoUI.db.char.AB5ButtonSpacing, 0)
		MultiBarLeftButton5:ClearAllPoints();
		MultiBarLeftButton5:SetPoint("CENTER", MultiBarLeftButton4,"CENTER",PsychoUI.db.char.AB5ButtonSize+PsychoUI.db.char.AB5ButtonSpacing, 0)
		MultiBarLeftButton6:ClearAllPoints();
		MultiBarLeftButton6:SetPoint("CENTER", MultiBarLeftButton5,"CENTER",PsychoUI.db.char.AB5ButtonSize+PsychoUI.db.char.AB5ButtonSpacing, 0)
		MultiBarLeftButton7:ClearAllPoints();
		MultiBarLeftButton7:SetPoint("CENTER", MultiBarLeftButton6,"CENTER",PsychoUI.db.char.AB5ButtonSize+PsychoUI.db.char.AB5ButtonSpacing, 0)
		MultiBarLeftButton8:ClearAllPoints();
		MultiBarLeftButton8:SetPoint("CENTER", MultiBarLeftButton7,"CENTER",PsychoUI.db.char.AB5ButtonSize+PsychoUI.db.char.AB5ButtonSpacing, 0)
		MultiBarLeftButton9:ClearAllPoints();
		MultiBarLeftButton9:SetPoint("CENTER", MultiBarLeftButton8,"CENTER",PsychoUI.db.char.AB5ButtonSize+PsychoUI.db.char.AB5ButtonSpacing, 0)
		MultiBarLeftButton10:ClearAllPoints();
		MultiBarLeftButton10:SetPoint("CENTER", MultiBarLeftButton9,"CENTER",PsychoUI.db.char.AB5ButtonSize+PsychoUI.db.char.AB5ButtonSpacing, 0)
		MultiBarLeftButton11:ClearAllPoints();
		MultiBarLeftButton11:SetPoint("CENTER", MultiBarLeftButton10,"CENTER",PsychoUI.db.char.AB5ButtonSize+PsychoUI.db.char.AB5ButtonSpacing,0)
		MultiBarLeftButton12:ClearAllPoints();
		MultiBarLeftButton12:SetPoint("CENTER", MultiBarLeftButton11,"CENTER",PsychoUI.db.char.AB5ButtonSize+PsychoUI.db.char.AB5ButtonSpacing,0)
	
	elseif PsychoUI.db.char.AB5Layout == 2 then
	-- 2 x 6
		MultiBarLeftButton1:ClearAllPoints();
		MultiBarLeftButton1:SetPoint("CENTER", ActionButton1,"CENTER",AB5X, AB5Y)	
		MultiBarLeftButton3:ClearAllPoints();
		MultiBarLeftButton3:SetPoint("CENTER", MultiBarLeftButton1,"CENTER",PsychoUI.db.char.AB5ButtonSize+PsychoUI.db.char.AB5ButtonSpacing, 0)
		MultiBarLeftButton5:ClearAllPoints();
		MultiBarLeftButton5:SetPoint("CENTER", MultiBarLeftButton3,"CENTER",PsychoUI.db.char.AB5ButtonSize+PsychoUI.db.char.AB5ButtonSpacing, 0)
		MultiBarLeftButton7:ClearAllPoints();
		MultiBarLeftButton7:SetPoint("CENTER", MultiBarLeftButton1,"CENTER",(PsychoUI.db.char.AB5ButtonSize+PsychoUI.db.char.AB5ButtonSpacing)*3,0 )
		MultiBarLeftButton9:ClearAllPoints();
		MultiBarLeftButton9:SetPoint("CENTER", MultiBarLeftButton7,"CENTER",PsychoUI.db.char.AB5ButtonSize+PsychoUI.db.char.AB5ButtonSpacing, 0)
		MultiBarLeftButton11:ClearAllPoints();
		MultiBarLeftButton11:SetPoint("CENTER", MultiBarLeftButton9,"CENTER",PsychoUI.db.char.AB5ButtonSize+PsychoUI.db.char.AB5ButtonSpacing, 0)
		
	elseif PsychoUI.db.char.AB5Layout == 3 then
	-- 3 x 4
		MultiBarLeftButton1:ClearAllPoints();
		MultiBarLeftButton1:SetPoint("CENTER", ActionButton1,"CENTER",AB5X, AB5Y)	
		MultiBarLeftButton5:ClearAllPoints();
		MultiBarLeftButton5:SetPoint("CENTER", MultiBarLeftButton1,"CENTER",PsychoUI.db.char.AB5ButtonSize+PsychoUI.db.char.AB5ButtonSpacing, 0)
		MultiBarLeftButton9:ClearAllPoints();
		MultiBarLeftButton9:SetPoint("CENTER", MultiBarLeftButton5,"CENTER",PsychoUI.db.char.AB5ButtonSize+PsychoUI.db.char.AB5ButtonSpacing, 0)
	elseif PsychoUI.db.char.AB5Layout == 4 then
	-- 12 x 1
		MultiBarLeftButton1:ClearAllPoints();
		MultiBarLeftButton1:SetPoint("CENTER", ActionButton1,"CENTER",AB5X, AB5Y)	
	
	elseif PsychoUI.db.char.AB5Layout == 5 then
		-- 6 x 2
		
		MultiBarLeftButton1:ClearAllPoints();
		MultiBarLeftButton1:SetPoint("CENTER", ActionButton1,"CENTER",AB5X, AB5Y)	
		MultiBarLeftButton7:ClearAllPoints();
		MultiBarLeftButton7:SetPoint("CENTER", MultiBarLeftButton1,"CENTER",PsychoUI.db.char.AB5ButtonSize+PsychoUI.db.char.AB5ButtonSpacing, 0)
		
	
	elseif PsychoUI.db.char.AB5Layout == 6 then
	-- 4 x 3
		MultiBarLeftButton1:ClearAllPoints();
		MultiBarLeftButton1:SetPoint("CENTER", ActionButton1,"CENTER",AB5X, AB5Y)
		MultiBarLeftButton4:ClearAllPoints();
		MultiBarLeftButton4:SetPoint("CENTER", MultiBarLeftButton1,"CENTER",PsychoUI.db.char.AB5ButtonSize+PsychoUI.db.char.AB5ButtonSpacing, 0)
		MultiBarLeftButton7:ClearAllPoints();
		MultiBarLeftButton7:SetPoint("CENTER", MultiBarLeftButton4,"CENTER",PsychoUI.db.char.AB5ButtonSize+PsychoUI.db.char.AB5ButtonSpacing, 0)
		MultiBarLeftButton10:ClearAllPoints();
		MultiBarLeftButton10:SetPoint("CENTER", MultiBarLeftButton7,"CENTER",PsychoUI.db.char.AB5ButtonSize+PsychoUI.db.char.AB5ButtonSpacing, 0)
			

	end

	end
	local function DatabaseCheck()
		if PsychoUI.db.char.lockframes == false then 
			AB1X = PsychoUI.db.char.AB1X
			AB1Y = PsychoUI.db.char.AB1Y
			AB2X = PsychoUI.db.char.AB2X
			AB2Y = PsychoUI.db.char.AB2Y
			AB3X = PsychoUI.db.char.AB3X
			AB3Y = PsychoUI.db.char.AB3Y
			AB4X = PsychoUI.db.char.AB4X
			AB4Y = PsychoUI.db.char.AB4Y
			AB5X = PsychoUI.db.char.AB5X
			AB5Y = PsychoUI.db.char.AB5Y
			StanceX = PsychoUI.db.char.StanceX
			StanceY = PsychoUI.db.char.StanceY
			PetBarX = PsychoUI.db.char.PetBarX
			PetBarY = PsychoUI.db.char.PetBarY
			MoverAB1:SetFrameLevel(50)
			MoverAB1Text:SetText("AB1")
			MoverAB1:SetPoint("CENTER", UIParent,"BOTTOM",AB1X, AB1Y)
			CreateBackdrop(MoverAB1)
			MoverAB2:SetFrameLevel(100)
			MoverAB2Text:SetText("AB2")
			MoverAB2:SetPoint("CENTER",  UIParent,"BOTTOM",AB2X, AB2Y)
			CreateBackdrop(MoverAB2)
			MoverAB3:SetFrameLevel(150)
			MoverAB3Text:SetText("AB3")
			MoverAB3:SetPoint("CENTER",  UIParent,"BOTTOM",AB3X, AB3Y)
			CreateBackdrop(MoverAB3)
			MoverAB4:SetFrameLevel(200)
			MoverAB4Text:SetText("AB4")
			MoverAB4:SetPoint("CENTER",  ActionButton1,"CENTER",AB4X, AB4Y)
			CreateBackdrop(MoverAB4)
			MoverAB5:SetFrameLevel(250)
			MoverAB5Text:SetText("AB5")
			MoverAB5:SetPoint("CENTER",  ActionButton1,"CENTER",AB5X, AB5Y)
			CreateBackdrop(MoverAB5)
			MoverPetBar:SetFrameLevel(350)
			MoverPetBarText:SetText("Pet Bar")
			MoverPetBar:SetPoint("CENTER",UIParent,"BOTTOM",PetBarX, PetBarY)
			CreateBackdrop(MoverPetBar)
			MoverStanceBar:SetFrameLevel(450)
			MoverStanceBarText:SetText("Stance Bar")
			MoverStanceBar:SetPoint("CENTER",UIParent,"BOTTOM",StanceX, StanceY)
			CreateBackdrop(MoverStanceBar)
	
		end
		if PsychoUI.db.char.ResetBox == true then 
			AB1X = -80
			AB1Y = 30

			MoverAB1:ClearAllPoints()
			MoverAB1:SetPoint("CENTER", UIParent,"BOTTOM",-80, 30)
			MoverAB2:ClearAllPoints()
			MoverAB2:SetPoint("CENTER", UIParent,"BOTTOM",-80, 75)
			MoverAB3:ClearAllPoints()
			MoverAB3:SetPoint("CENTER", UIParent,"BOTTOM",-80, 120)
			MoverAB4:ClearAllPoints()
			MoverAB4:SetPoint("CENTER", ActionButton1,"CENTER",-180, 0)
			MoverAB5:ClearAllPoints()
			MoverAB5:SetPoint("CENTER", ActionButton1,"CENTER",-360, 0)
			MoverPetBar:ClearAllPoints()
			MoverPetBar:SetPoint("CENTER",UIParent,"BOTTOM",0, 160)
			MoverStanceBar:ClearAllPoints()
			MoverStanceBar:SetPoint("CENTER",UIParent,"BOTTOM",-425, 160)
		end

	end
local DB_Check_Frame = CreateFrame("Frame")	
DB_Check_Frame:HookScript("OnUpdate", DatabaseCheck)

	local events = CreateFrame('Frame')
	events:RegisterEvent('PLAYER_LOGIN')
	events:RegisterEvent('PLAYER_SPECIALIZATION_CHANGED')

	events:SetScript('OnEvent', Setup)
