--[[
##################
PsychoUI: keivamp#
##################
]]--
local PsychoUI = LibStub("AceAddon-3.0"):GetAddon("PsychoUI")
local LSM = LibStub and LibStub:GetLibrary("LibSharedMedia-3.0", true)
if (UnitLevel("player") == 60) then return end
	local MyXPWidth = 350
	local MyXPHeight = 15
	local XPX = -230
	local XPY = -10
	local TextYbump = 0
	local XPframe = CreateFrame("Frame", nil, UIParent, BackdropTemplateMixin and "BackdropTemplate")
	local MyXPSettingsFrame = CreateFrame("Frame")
	
	local function CreateBackdrop(frame)
		frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
		insets = {top = 0, left = 0, bottom = 0, right = 0}})
		frame:SetBackdropColor(0,0,0,0.75)
		frame:SetBackdropBorderColor(0,0,0,1)
	end
	
	XPframe:EnableMouse(true)

	XPframe.bar = CreateFrame("StatusBar", nil, XPframe, BackdropTemplateMixin and "BackdropTemplate")
	XPframe.bar:SetFrameLevel(2)
	XPframe.bar:SetPoint("TOPLEFT", 0, 0)
	XPframe.bar:SetPoint("TOPRIGHT", 0, 0)

	XPframe.barR = CreateFrame("StatusBar", nil, XPframe, BackdropTemplateMixin and "BackdropTemplate")
	XPframe.barR:SetFrameLevel(1)
	XPframe.barR:SetPoint("TOPLEFT", 0, 0)
	XPframe.barR:SetPoint("TOPRIGHT", 0, 0)
	
	local XPText = XPframe.bar:CreateFontString(nil, "OVERLAY", "SystemFont_Med1")
			XPText:SetPoint("LEFT", 2, 0)
		
	local XPMaxText = XPframe.bar:CreateFontString(nil, "OVERLAY", "SystemFont_Med1")
			XPMaxText:SetPoint("RIGHT", -2, 0)

	local XPRestedText = XPframe.bar:CreateFontString(nil, "OVERLAY", "SystemFont_Med1")
			XPRestedText:SetPoint("CENTER", 0, 0)
			
	local function XPMe()
	if PsychoUI.db.char.UsePsychoUIXP == false then return end
	TextYbump = PsychoUI.db.char.XPTextY
	--print(LSM:Fetch("statusbar", PsychoUI.db.char.XPStatusBar))
	--print(LSM:Fetch("font", PsychoUI.db.char.XPFontKey))
	
	--Fonts--
	
	local TheFontOutline = "NONE"
	if PsychoUI.db.char.XPFontOutline == 1 then
	TheFontOutline = "NONE"
	elseif PsychoUI.db.char.XPFontOutline == 2 then
	TheFontOutline = "MONOCHROMEOUTLINE"
	elseif PsychoUI.db.char.XPFontOutline == 3 then
	TheFontOutline = "THINOUTLINE"
	elseif PsychoUI.db.char.XPFontOutline == 4 then
	TheFontOutline = "THICKOUTLINE"
	end
	
	XPText:SetPoint("LEFT", 2, 0+TextYbump)
	XPMaxText:SetPoint("RIGHT", -2, 0+TextYbump)
	XPRestedText:SetPoint("CENTER", 0, 0+TextYbump)

	--end fonts --

	local MyXPWidth = PsychoUI.db.char.XPWidth
	local MyXPHeight = PsychoUI.db.char.XPHeight
	local XPX = PsychoUI.db.char.XPMoveX
	local XPY = PsychoUI.db.char.XPMoveY
	
	XPframe:SetClampedToScreen(true)
	XPframe:SetClampRectInsets(0, 0, 0,0)

	XPframe:SetHeight(MyXPHeight)
	XPframe:SetWidth(MyXPWidth)

	XPframe:ClearAllPoints()
	XPframe:SetPoint("TOP", UIParent, "TOP", XPX,XPY)
		
	XPframe:CreateBeautyBorder(4)
	XPframe:SetBeautyBorderPadding(1)
	XPframe:SetBeautyBorderTexture("white")
	
	CreateBackdrop(XPframe)
	
	if PsychoUI.db.char.UseVertXP == true then
		XPframe.bar:SetOrientation("VERTICAL")
		XPframe.barR:SetOrientation("VERTICAL")
		PsychoUI.db.char.ShowRested = false
		PsychoUI.db.char.ShowMaxXP = false
		PsychoUI.db.char.ShowMinXP = false	
	else
		XPframe.bar:SetOrientation("HORIZONTAL")
		XPframe.barR:SetOrientation("HORIZONTAL")
	end
	
	XPframe.bar:SetHeight(MyXPHeight)
	XPframe.barR:SetHeight(MyXPHeight)
	XPframe.bar:SetStatusBarTexture(LSM:Fetch("statusbar", PsychoUI.db.char.XPStatusBar))
	XPframe.bar:GetStatusBarTexture():SetHorizTile(false)
	XPframe.bar:GetStatusBarTexture():SetVertTile(false)
	XPframe.bar:SetStatusBarColor(.41,.60,.95)
	XPframe:SetBeautyBorderColor(.41,.60,.95,0.75)
	XPframe.barR:SetStatusBarTexture(LSM:Fetch("statusbar", PsychoUI.db.char.XPStatusBar))
	XPframe.barR:GetStatusBarTexture():SetHorizTile(false)
	XPframe.barR:GetStatusBarTexture():SetVertTile(false)
	XPframe.barR:SetStatusBarColor(.6,.2,.8,1)
	if PsychoUI.db.char.XPCustomFont == false then 
	XPText:SetFont("SystemFont_Med1", MyXPHeight-4, "OUTLINE")
	XPText:SetTextColor(1, 1, 1, 1);
	XPMaxText:SetFont("SystemFont_Med1", MyXPHeight-4, "OUTLINE")
	XPMaxText:SetTextColor(1, 1, 1, 1);
	XPRestedText:SetFont("SystemFont_Med1", MyXPHeight-4, "OUTLINE")	
	XPRestedText:SetTextColor(1, 1, 1, 1);
	else
	XPText:SetFont(LSM:Fetch("font", PsychoUI.db.char.XPFontKey), PsychoUI.db.char.XPFontSize, TheFontOutline)	
	XPMaxText:SetFont(LSM:Fetch("font", PsychoUI.db.char.XPFontKey), PsychoUI.db.char.XPFontSize, TheFontOutline)	
	XPRestedText:SetFont(LSM:Fetch("font", PsychoUI.db.char.XPFontKey), PsychoUI.db.char.XPFontSize, TheFontOutline)		
	end	

end	
	MyXPSettingsFrame:HookScript("OnUpdate",XPMe) 
function truncate(number, decimals)
    return number - (number % (0.1 ^ decimals))
end
local function UpdateXP()
	if PsychoUI.db.char.UsePsychoUIXP == false then return end
		XPframe.bar:SetMinMaxValues(0, UnitXPMax("player"))
		XPframe.bar:SetValue(UnitXP("player"))	
		local rested = GetXPExhaustion()
		if rested ~= nil then		
		local restedPerc = math.floor(rested / UnitXPMax("player") * 100 + 0.5)
		if PsychoUI.db.char.ShowMinXP == true then 
			if UnitXP("player") > 1000 then
			XPText:SetText(truncate(UnitXP("player")/1000,1).."K")
			else
			XPText:SetText(UnitXP("player"))
			end
		else
		XPText:SetText("")
		end
		if PsychoUI.db.char.ShowMaxXP == true then 
			if UnitXPMax("player") > 1000 then
				XPMaxText:SetText(truncate(UnitXPMax("player")/1000,1).."K")
			else
				XPMaxText:SetText(UnitXPMax("player"))
			end
		else
		XPMaxText:SetText("")
		end	
		if PsychoUI.db.char.ShowRested == true then 
		XPRestedText:SetText(restedPerc.."% Rested")
		else
		XPRestedText:SetText("")
		end
		XPframe.barR:SetMinMaxValues(0, UnitXPMax("player"))
		XPframe.barR:SetValue(UnitXP("player")+rested)
		end
		if rested == nil then
		if UnitXP("player") > 1000 then
			XPText:SetText(truncate(UnitXP("player")/1000,1).."K")
			else
			XPText:SetText(UnitXP("player"))
			end
		if UnitXPMax("player") > 1000 then
				XPMaxText:SetText(truncate(UnitXPMax("player")/1000,1).."K")
			else
				XPMaxText:SetText(UnitXPMax("player"))
			end
		XPRestedText:SetText("")
		XPframe.barR:SetStatusBarColor(0,0,0,0)
		end
		--OnEvent()
		
end
	local function OnEvent(self)
		if PsychoUI.db.char.UsePsychoUIXP == false then return end
		self:SetScript("OnEnter", function()
			
			local rested = GetXPExhaustion()
			
			GameTooltip:SetOwner(self, "ANCHOR_BOTTOM", 0, -10)
			GameTooltip:ClearAllPoints()
			GameTooltip:SetPoint("BOTTOM", self, "TOP", 0, 1)
			GameTooltip:ClearLines()

			GameTooltip:AddDoubleLine("Experience")
			GameTooltip:AddLine(" ")
			GameTooltip:AddDoubleLine(UnitXP("player") .. "  /  " .. UnitXPMax("player"))
			if rested ~= nil then		
				local restedPerc = math.floor(rested / UnitXPMax("player") * 100 + 0.5)
				GameTooltip:AddLine(" ")
				GameTooltip:AddDoubleLine(restedPerc .. "% : Rested XP")
			end
			GameTooltip:Show()
		end)		
		self:SetScript("OnLeave", function() GameTooltip:Hide() end)
		end

		XPframe:SetScript("OnEvent", OnEvent)
		XPframe:HookScript("OnUpdate", OnEvent)
		
		XPframe.UpdateFrame = CreateFrame("Frame", nil, UIParent);

XPframe.UpdateFrame:HookScript("OnUpdate", UpdateXP)