--[[
##################
PsychoUI: keivamp#
##################
]]--
local PsychoUI = LibStub("AceAddon-3.0"):GetAddon("PsychoUI")
local LSM = LibStub("LibSharedMedia-3.0")
local InCombatLockdown      = _G.InCombatLockdown;
local playerColor = RAID_CLASS_COLORS[select(2, UnitClass('player'))]
	

	local MiniMapHeight = 175
	local MiniMapWidth = 175
	local MiniMapX = -25
	local MiniMapY = -25
	local BorderSize = 8
	local BorderPadding = 2
	local ZoneTextYbump = 0
	local TimeY = -30
	
	local zoneTextFrame = CreateFrame("Frame", nil, UIParent)
	zoneTextFrame:SetPoint("TOP", Minimap, "TOP", -100, 24)	
	zoneTextFrame:SetSize(400,20)

	MinimapZoneText:SetParent(zoneTextFrame)
	MinimapZoneText:ClearAllPoints()
	MinimapZoneText:SetSize(400,25)
	MinimapZoneText:SetPoint("BOTTOM", zoneTextFrame, "BOTTOM", 0, -2)
	MinimapZoneText:SetJustifyH("RIGHT")
	
	local CheckDB = CreateFrame("Frame")
	CheckDB:RegisterEvent("PLAYER_ENTERING_WORLD")
	CheckDB:SetScript("OnEvent", function()
	
	if PsychoUI.db.char.MMDisable == true then return end
			
	local minimapShape = GetMinimapShape and GetMinimapShape() or "ROUND"
	MiniMapX = PsychoUI.db.char.MiniMapX
	MiniMapY = PsychoUI.db.char.MiniMapY
	Minimap:ClearAllPoints()
	Minimap:SetPoint("TOPRIGHT", UIParent, MiniMapX, MiniMapY)
		
	MinimapCluster:EnableMouse(false)

	Minimap:SetMaskTexture('Interface\\ChatFrame\\ChatFrameBackground')
	
	Minimap:SetScale(1.25)
	MinimapBorder:Hide()
	MinimapBorderTop:Hide()

	MinimapZoomIn:ClearAllPoints()
	MinimapZoomIn:SetPoint("RIGHT", Minimap, 25, 0)

	MinimapZoomOut:ClearAllPoints()
	MinimapZoomOut:SetPoint("RIGHT", Minimap, 25, -25)

	GarrisonLandingPageMinimapButton:ClearAllPoints()
	GarrisonLandingPageMinimapButton:SetPoint("BOTTOMRIGHT", Minimap, 25, -25)

	GameTimeFrame:ClearAllPoints()
	GameTimeFrame:SetPoint("TOPRIGHT", Minimap, 25, -5)

	MinimapNorthTag:ClearAllPoints()
	MinimapNorthTag:SetPoint("TOP", Minimap, 0, 3)
	MinimapNorthTag:SetScale(1.25)
	
	MiniMapWorldMapButton:ClearAllPoints()
	MiniMapWorldMapButton:SetPoint("RIGHT", Minimap, 28, -70)
	MiniMapWorldMapButton:SetScale(0.75)
	 local blah1,blah2,blah3 = MiniMapWorldMapButton:GetRegions()
		 blah1:SetTexture("")
		 blah2:SetTexture("")
		 blah3:SetTexture("")
	local MMWMBFrame = CreateFrame("Frame",nil,MiniMapWorldMapButton)
	MMWMBFrame:SetFrameLevel(10)
	MMWMBFrame:SetAllPoints()
	
	local MMWMBFrameFrametex = MMWMBFrame:CreateTexture(nil, "BACKGROUND")
	MMWMBFrameFrametex:SetTexture("Interface\\Addons\\PsychoUI\\Textures\\Map\\AzerothWorldMap")
	MMWMBFrameFrametex:SetAllPoints()
	
	local mmt = MiniMapTracking
	mmt:ClearAllPoints()
	mmt:SetPoint("TOPLEFT", Minimap, -30, 10)
	
	MiniMapTrackingBackground:SetAlpha(0)
	MiniMapTrackingButton:SetAlpha(0)

	local mm = MiniMapMailFrame
	mm:ClearAllPoints()
	mm:SetPoint("TOPLEFT", Minimap, -30, -55)
	mm:SetScale(1)	
	
	local QSMB = QueueStatusMinimapButton
	QSMB:ClearAllPoints()
	QSMB:SetPoint("BOTTOMLEFT", Minimap, -30, -7)
	QSMB:SetScale(1.3)	

	Minimap:EnableMouseWheel(true)
	Minimap:SetScript("OnMouseWheel", function(self, d)
		if d > 0 then
			_G.MinimapZoomIn:Click()
		elseif d < 0 then
			_G.MinimapZoomOut:Click()
		end
	end)
		
	end)

	local function DatabaseCheck()
	if PsychoUI.db.char.MMDisable == true then return end
		BuffFrame:ClearAllPoints() 
		BuffFrame:SetPoint("TOPLEFT",Minimap,-80,-10)

		BorderSize = PsychoUI.db.char.MMBorderSize
		BorderPadding = MMBorderPadding
		MiniMapHeight = PsychoUI.db.char.MiniMapHeight
		MiniMapWidth = PsychoUI.db.char.MiniMapWidth
		ZoneTextYbump = PsychoUI.db.char.ZoneTextY
		TimeY = PsychoUI.db.char.TimeY
			
		Minimap:SetSize(MiniMapWidth,MiniMapHeight)
		
		
		Minimap:CreateBeautyBorder(BorderSize)
		Minimap:SetBeautyBorderPadding(BorderPadding)
		Minimap:SetBeautyBorderTexture("white")
		if PsychoUI.db.char.MMNoBorder == true then
			Minimap:SetBeautyBorderColor(0, 0, 0, 0)
		else
			if PsychoUI.db.char.MMBlackBorder == true then
				Minimap:SetBeautyBorderColor(0, 0, 0, 1)
			else
				Minimap:SetBeautyBorderColor(playerColor.r, playerColor.g, playerColor.b)
			end
		end

	local TheFontOutline = "NONE"
	if PsychoUI.db.char.ZoneFontOutline == 1 then
	TheFontOutline = "NONE"
	elseif PsychoUI.db.char.ZoneFontOutline == 2 then
	TheFontOutline = "MONOCHROMEOUTLINE"
	elseif PsychoUI.db.char.ZoneFontOutline == 3 then
	TheFontOutline = "THINOUTLINE"
	elseif PsychoUI.db.char.ZoneFontOutline == 4 then
	TheFontOutline = "THICKOUTLINE"
	end
		if PsychoUI.db.char.ZonefontFontKey == "Folkard" then
			MinimapZoneText:SetPoint("BOTTOM", zoneTextFrame, "BOTTOM", 0, -2+ZoneTextYbump)
		elseif PsychoUI.db.char.ZonefontFontKey == "Atari" then
			MinimapZoneText:SetPoint("BOTTOM", zoneTextFrame, "BOTTOM", 0, -2+ZoneTextYbump)
		else
			MinimapZoneText:SetPoint("BOTTOM", zoneTextFrame, "BOTTOM", 0, -2+ZoneTextYbump)
		end

		MinimapZoneText:SetFont(LSM:Fetch("font", PsychoUI.db.char.ZonefontFontKey), PsychoUI.db.char.ZoneFontSize, TheFontOutline)

	local TheTimeFontOutline = "NONE"
	if PsychoUI.db.char.TimeFontOutline == 1 then
	TheTimeFontOutline = "NONE"
	elseif PsychoUI.db.char.TimeFontOutline == 2 then
	TheTimeFontOutline = "MONOCHROMEOUTLINE"
	elseif PsychoUI.db.char.TimeFontOutline == 3 then
	TheTimeFontOutline = "THINOUTLINE"
	elseif PsychoUI.db.char.TimeFontOutline == 4 then
	TheTimeFontOutline = "THICKOUTLINE"
	end
		LoadAddOn('Blizzard_TimeManager')
	local clockFrame, clockTime = TimeManagerClockButton:GetRegions()
	clockFrame:Hide()
	clockTime:Show()
	clockTime:SetSize(100,50)
	clockTime:SetFont(LSM:Fetch("font", PsychoUI.db.char.TimefontFontKey), PsychoUI.db.char.TimeFontSize,TheTimeFontOutline)
	clockTime:SetTextColor(1, 1, 1)
	TimeManagerClockButton:SetPoint("BOTTOM", Minimap, "BOTTOM", 0, TimeY)
		
		 Minimap:SetClampedToScreen(true)
		 Minimap:SetClampRectInsets(0, 0, 0,0)
		
		if PsychoUI.db.char.lockframes == false then 
		
		MiniMapX = PsychoUI.db.char.MiniMapX
		MiniMapY = PsychoUI.db.char.MiniMapY
		Minimap:ClearAllPoints()
		Minimap:SetPoint("TOPRIGHT", UIParent, MiniMapX, MiniMapY)
			
		end
		if PsychoUI.db.char.ResetBox == true then 
			Minimap:ClearAllPoints()
		Minimap:SetPoint("TOPRIGHT", UIParent, -25, -25)
		end

	end
	local DB_Check_Frame = CreateFrame("Frame")	
	DB_Check_Frame:HookScript("OnUpdate", DatabaseCheck)

	
	