--[[
##################
PsychoUI: keivamp#
##################
]]--
local PsychoUI = LibStub("AceAddon-3.0"):GetAddon("PsychoUI")
local LSM = LibStub("LibSharedMedia-3.0")
local _, ns = ...
local oUF = ns.oUF
local addonName, addon = ...
local playerColor = RAID_CLASS_COLORS[select(2, UnitClass('player'))]

local function CreateBackdrop(frame)
   frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
        insets = {top = -2, left = -2, bottom = -2, right = -2}})
		frame:SetBackdropColor(0,0,0,0.75)
		frame:SetBackdropBorderColor(0,0,0,1)
end
local function ColorObject(Object)
	MyObject = CreateFrame("Frame", nil, Object, BackdropTemplateMixin and "BackdropTemplate")
	MyObject:SetAllPoints(Object)
	MyObject:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
        insets = {top = -2, left = -2, bottom = -2, right = -2}})
	MyObject:SetBackdropColor(0,0,0,0.75)
	MyObject:SetBackdropBorderColor(0,0,0,1)
end

local UnitSpecific = {
	player = function(self)
		-- Player specific layout code.
	end,
        
        party = function(self)
		-- Party specific layout code.         
        end,
}

local Shared = function(self, unit)
	-- Shared layout code.

	if(UnitSpecific[unit]) then
		return UnitSpecific[unit](self)
	end
end

oUF:RegisterStyle("PsychoStyle", function(frame, unit)
if PsychoUI.db.char.DisablePlates == true then return end

	-----------------
	--  Mouse Code --
	-----------------
	frame:SetScript('OnEnter', UnitFrame_OnEnter)
	frame:SetScript('OnLeave', UnitFrame_OnLeave)

	frame:RegisterForClicks'AnyUp'
	
	frame:SetSize(88, 10)
        frame:SetPoint("CENTER", 0, 0)
	
	local TheFontOutline = "NONE"
	if PsychoUI.db.char.NPFontOutline == 1 then
	TheFontOutline = "NONE"
	elseif PsychoUI.db.char.NPFontOutline == 2 then
	TheFontOutline = "MONOCHROMEOUTLINE"
	elseif PsychoUI.db.char.NPFontOutline == 3 then
	TheFontOutline = "THINOUTLINE"
	elseif PsychoUI.db.char.NPFontOutline == 4 then
	TheFontOutline = "THICKOUTLINE"
	end
	local TheLevelFontOutline = "NONE"
	if PsychoUI.db.char.NPLevelFontOutline == 1 then
	TheLevelFontOutline = "NONE"
	elseif PsychoUI.db.char.NPLevelFontOutline == 2 then
	TheLevelFontOutline = "MONOCHROMEOUTLINE"
	elseif PsychoUI.db.char.NPLevelFontOutline == 3 then
	TheLevelFontOutline = "THINOUTLINE"
	elseif PsychoUI.db.char.NPLevelFontOutline == 4 then
	TheLevelFontOutline = "THICKOUTLINE"
	end
	local TheHealthFontOutline = "NONE"
	if PsychoUI.db.char.NPHealthFontOutline == 1 then
	TheHealthFontOutline = "NONE"
	elseif PsychoUI.db.char.NPHealthFontOutline == 2 then
	TheHealthFontOutline = "MONOCHROMEOUTLINE"
	elseif PsychoUI.db.char.NPHealthFontOutline == 3 then
	TheHealthFontOutline = "THINOUTLINE"
	elseif PsychoUI.db.char.NPHealthFontOutline == 4 then
	TheHealthFontOutline = "THICKOUTLINE"
	end
 
    if unit == "player" then
        -- your player-specific code here
    elseif unit == "boss1" then
        -- your boss1-specific code here
    elseif unit:match("nameplate") then
	

        -- health bar
        local health = CreateFrame("StatusBar", nil, frame, BackdropTemplateMixin and "BackdropTemplate")
        health:SetAllPoints()
        health:SetStatusBarTexture(LSM:Fetch("statusbar", PsychoUI.db.char.NPStatusBar))
		health:GetStatusBarTexture():SetHorizTile(false)
		health:GetStatusBarTexture():SetVertTile(false)
        health.colorHealth = true
        health.colorTapping = true
		health.colorSmooth = true
		health.frequentUpdates = true
        health.colorDisconnected = true
		health.colorReaction = true
        frame.Health = health
		frame.Health:SetFrameLevel(1)
		
		
		health:CreateBeautyBorder(PsychoUI.db.char.NPBorderSize)
		health:SetBeautyBorderPadding(PsychoUI.db.char.NPBorderPadding)
		health:SetBeautyBorderTexture("white")
		if PsychoUI.db.char.NPNoBorder == true then
					 health:SetBeautyBorderColor(0, 0, 0,0)
				else
					if PsychoUI.db.char.NPBlackBorder == true then
						health:SetBeautyBorderColor(0, 0, 0,1)
					else
						health:SetBeautyBorderColor(playerColor.r*0.75, playerColor.g*0.75, playerColor.b*0.75,1)
					end
				end
		
		
		CreateBackdrop(health)
		
        -- set size and points
        


		------------------
		--   Name Text --
		------------------
		local NameText = frame:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		NameText:SetPoint("TOPLEFT", frame, 0,14) -- but anchor to the base element so it doesn't wiggle
		NameText:SetFont(LSM:Fetch("font", PsychoUI.db.char.NPFontKey), PsychoUI.db.char.NPFontSize, TheFontOutline)
		NameText:SetJustifyH("LEFT")
		NameText:SetWidth(400)
		if PsychoUI.db.char.ShowName == true then
		frame:Tag(NameText, "[name]")
		else
		NameText:SetText("")
		end
		
		------------------
		--   Level Text --
		------------------
		local LevelText = frame:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		LevelText:SetPoint("LEFT", frame, -25,0) -- but anchor to the base element so it doesn't wiggle
		LevelText:SetFont(LSM:Fetch("font", PsychoUI.db.char.NPLevelFont),PsychoUI.db.char.NPLevelFontSize,TheLevelFontOutline)
		LevelText:SetJustifyH("LEFT")
		if PsychoUI.db.char.ShowLevel == true then
		frame:Tag(LevelText, "[level]") 
		else
		LevelText:SetText("")
		end
		
		------------------
		--   Health Text --
		------------------
		local HealthText = frame:CreateFontString(nil, "OVERLAY", "TextStatusBarText")
		--HealthText:SetFrameLevel(12)		-- parent to last child to make sure it's on top
		HealthText:SetPoint("CENTER", frame, 0,0) -- but anchor to the base element so it doesn't wiggle
		HealthText:SetFont(LSM:Fetch("font", PsychoUI.db.char.NPHealthFont), PsychoUI.db.char.NPHealthFontSize, TheHealthFontOutline)
		HealthText:SetJustifyH("LEFT")
		frame:Tag(HealthText, "[perhp]".." %")
		--------------
		-- Cast Bar --
		--------------
		local Castbar = CreateFrame("StatusBar", nil, frame, BackdropTemplateMixin and "BackdropTemplate")
		Castbar:SetStatusBarTexture(LSM:Fetch("statusbar", PsychoUI.db.char.NPStatusBar))
		Castbar:SetStatusBarColor(0.25, 0, 0.85, 0.85)
		Castbar:SetSize(88, 10)
		Castbar:SetPoint('BOTTOMLEFT', frame, 0, -16)
		Castbar:CreateBeautyBorder(PsychoUI.db.char.NPBorderSize)
		Castbar:SetBeautyBorderPadding(PsychoUI.db.char.NPBorderPadding)
		Castbar:SetBeautyBorderTexture("white")
		if PsychoUI.db.char.NPNoBorder == true then
					 Castbar:SetBeautyBorderColor(0, 0, 0,0)
				else
					if PsychoUI.db.char.NPBlackBorder == true then
						Castbar:SetBeautyBorderColor(0, 0, 0,1)
					else
						Castbar:SetBeautyBorderColor(playerColor.r*0.75, playerColor.g*0.75, playerColor.b*0.75,1)
					end
				end
		
		CreateBackdrop(Castbar)
		-- Add a spark
		local Spark = Castbar:CreateTexture(nil, "OVERLAY")
		Spark:SetSize(25, 8)
		Spark:SetBlendMode("ADD")

		-- Add a timer
		local Time = Castbar:CreateFontString(nil, "OVERLAY", "GameFontNormalSmall")
		Time:SetFont(LSM:Fetch("font", PsychoUI.db.char.NPFontKey), PsychoUI.db.char.NPFontSize, TheFontOutline)
		Time:SetTextColor(0.95, 0.95, 0.95)
		Time:SetPoint("RIGHT", Castbar, -3, 1)

		-- Add spell text
		local Text = Castbar:CreateFontString(nil, "OVERLAY", "GameFontNormalSmall")
		Text:SetFont(LSM:Fetch("font", PsychoUI.db.char.NPFontKey), PsychoUI.db.char.NPFontSize, TheFontOutline)
		Text:SetTextColor(0.95, 0.95, 0.95)
		Text:SetPoint("LEFT", Castbar, 3, 1)

		-- Add Shield
		local Shield = Castbar:CreateTexture(nil, "OVERLAY")
		Shield:SetSize(14, 14)
		Shield:SetPoint("CENTER", Castbar)

		local Icon = Castbar:CreateTexture(nil, 'OVERLAY')
		Icon:SetSize(14, 14)
		Icon:SetPoint('LEFT', Castbar, 'LEFT',-25,0)
		-- Add safezone
		local SafeZone = Castbar:CreateTexture(nil, "OVERLAY")

		-- Register it with oUF
		frame.Castbar = Castbar
		frame.Castbar.bg = Background
		frame.Castbar.Spark = Spark
		frame.Castbar.Time = Time
		frame.Castbar.Text = Text
		frame.Castbar.SafeZone = SafeZone
		frame.Castbar.Icon = Icon
			
		-----------
		-- Auras --
		-----------
		if PsychoUI.db.char.NPDisableAuras == false then
		local Auras = CreateFrame("Frame", nil, frame, BackdropTemplateMixin and "BackdropTemplate")
		Auras:SetPoint("BOTTOMLEFT", frame, "TOPLEFT", 0,15)
		Auras:SetPoint("BOTTOMRIGHT", frame, "TOPRIGHT", 128, 15)
		Auras:SetHeight(20 + 4)
		Auras.disableMouse = false

		Auras.size = 20
		Auras.onlyShowPlayer = false
		Auras.gap = 2
		Auras.spacing = 2
		Auras.showStealableAuras = true
		Auras.disableCooldown = false
		Auras.num = 32

		Auras.PostCreateIcon = Aura_PostCreateIcon
		frame.Auras = Auras
		end
		---------------------------
		-- Floating Combat Frame --
		---------------------------
		if PsychoUI.db.char.ShowFloatingCombatText == true then
		local fcf = CreateFrame("Frame", nil, frame, BackdropTemplateMixin and "BackdropTemplate")
		fcf:SetSize(32, 32)
		fcf:SetPoint("CENTER",0,50)
		for i = 1, 6 do
			fcf[i] = fcf:CreateFontString("$parentFCFText" .. i, "OVERLAY")
		end
		
		fcf.font = LSM:Fetch("font", PsychoUI.db.char.NPFontKey)
		fcf.fontHeight = PsychoUI.db.char.NPFontSize +4
		fcf.fontFlags = TheFontOutline

		frame.FloatingCombatFeedback = fcf
		end
			
		--------------------
		--  Elite Units   --
		--------------------
		local EliteText = frame:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		EliteText:SetWidth(50)
		EliteText:SetPoint("RIGHT", frame, 33,0) -- but anchor to the base element so it doesn't wiggle
		EliteText:SetFont(LSM:Fetch("font", PsychoUI.db.char.NPFontKey),PsychoUI.db.char.NPFontSize,TheFontOutline)
		EliteText:SetJustifyH("RIGHT")--classification
		if PsychoUI.db.char.ShowElite == true then
		frame:Tag(EliteText, "[classification]") 
		else
		EliteText:SetText("")
		end
		

    end
end)
oUF:Factory(function(self)
if PsychoUI.db.char.DisablePlates == true then return end
     self:SetActiveStyle("PsychoStyle")

   local cvars = {
    -- important, strongly recommend to set these to 1
    nameplateGlobalScale = 1,
    NamePlateHorizontalScale = 1,
    NamePlateVerticalScale = 1,
    -- optional, you may use any values
    nameplateLargerScale = 1,
    nameplateMaxScale = 1,
    nameplateMinScale = 1,
    nameplateSelectedScale = 1,
    nameplateSelfScale = 1,
}
 
oUF:SpawnNamePlates(nil, nil, cvars)
end)