--[[
##################
PsychoUI: keivamp#
##################
]]--
local PsychoUI = LibStub("AceAddon-3.0"):GetAddon("PsychoUI")
local LSM = LibStub("LibSharedMedia-3.0")
local addon, ns = ... 
local C, F, G = unpack(ns)
local InCombatLockdown      = _G.InCombatLockdown;
local panel = CreateFrame("Frame", nil, UIParent)

local function CreateBackdrop(frame)
   frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
        insets = {top = -2, left = -2, bottom = -2, right = -2}})
		frame:SetBackdropColor(0,0.55,0.95,0.45)
		frame:SetBackdropBorderColor(0,0,0,1)
end

local GoldX = -285
local GoldY = 5

local SILVER_AMOUNT_TEXTURE = "\124TInterface\\MoneyFrame\\UI-SilverIcon:%d:%d:1:0\124t";
local GOLD_AMOUNT_TEXTURE = "\124TInterface\\MoneyFrame\\UI-GoldIcon:%d:%d:1:0\124t";
local COPPER_AMOUNT_TEXTURE = "\124TInterface\\MoneyFrame\\UI-CopperIcon:%d:%d:1:0\124t";
local GoldIcon = format(GOLD_AMOUNT_TEXTURE)
local SilverIcon = format(SILVER_AMOUNT_TEXTURE)
local CopperIcon = format(COPPER_AMOUNT_TEXTURE)

	local Stat = CreateFrame("Frame","Gold",Mover)
	Stat:EnableMouse(true)
	Stat:SetFrameStrata("BACKGROUND")
	Stat:SetFrameLevel(3)
	Stat:SetSize(150,20)
	
	local Mover = CreateFrame("Frame","GoldDrag",UIParent)
	Mover:SetSize(150,20)
	Mover:SetPoint("BOTTOMRIGHT",UIParent,"BOTTOMRIGHT", -285,5)
	Mover:SetClampedToScreen(true)
	Mover:SetClampRectInsets(0, 0, 0,0)
	
	
	
	


	local Text  = panel:CreateFontString(nil, "OVERLAY")
	Text:SetFont("Interface\\Addons\\PsychoUI\\Fonts\\Dialog.TTF", 18, "OUTLINE")
	Text:SetPoint("CENTER",Mover,"CENTER", 0,0); 

	
	local CheckDB = CreateFrame("Frame")
		CheckDB:RegisterEvent("PLAYER_ENTERING_WORLD")
		CheckDB:SetScript("OnEvent", function()
		if PsychoUI.db.char.ShowGold == false then return end
		
		GoldX = PsychoUI.db.char.GoldX
		GoldY = PsychoUI.db.char.GoldY
		
		local TheFontOutline = "NONE"
		if PsychoUI.db.char.GoldFontOutline == 1 then
		TheFontOutline = "NONE"
		elseif PsychoUI.db.char.GoldFontOutline == 2 then
		TheFontOutline = "MONOCHROMEOUTLINE"
		elseif PsychoUI.db.char.GoldFontOutline == 3 then
		TheFontOutline = "THINOUTLINE"
		elseif PsychoUI.db.char.GoldFontOutline == 4 then
		TheFontOutline = "THICKOUTLINE"
		end
		Mover:ClearAllPoints()
		Mover:SetPoint("BOTTOMRIGHT",UIParent,"BOTTOMRIGHT",GoldX,GoldY)

		Text:SetFont(LSM:Fetch("font", PsychoUI.db.char.GoldFontKey), PsychoUI.db.char.GoldFontSize, TheFontOutline)
		Text:SetPoint("CENTER",Mover,"CENTER", 0,0);
		
				
	end)
	local function DatabaseCheck()
	if PsychoUI.db.char.ShowGold == false then return end
	GoldX = PsychoUI.db.char.GoldX
	GoldY = PsychoUI.db.char.GoldY

		if PsychoUI.db.char.lockframes == false then 
			Mover:SetPoint("BOTTOMRIGHT",UIParent,"BOTTOMRIGHT",GoldX,GoldY)
			local TheFontOutline = "NONE"
			if PsychoUI.db.char.GoldFontOutline == 1 then
			TheFontOutline = "NONE"
			elseif PsychoUI.db.char.GoldFontOutline == 2 then
			TheFontOutline = "MONOCHROMEOUTLINE"
			elseif PsychoUI.db.char.GoldFontOutline == 3 then
			TheFontOutline = "THINOUTLINE"
			elseif PsychoUI.db.char.GoldFontOutline == 4 then
			TheFontOutline = "THICKOUTLINE"
			end
			Text:SetFont(LSM:Fetch("font", PsychoUI.db.char.GoldFontKey), PsychoUI.db.char.GoldFontSize, TheFontOutline)
			Text:SetPoint("CENTER",Mover,"CENTER", 0,0);
		end
		if PsychoUI.db.char.ResetBox == true then 
			Mover:ClearAllPoints()
			Mover:SetPoint("BOTTOMRIGHT",UIParent,"BOTTOMRIGHT",-285,5)
		end
	end
local DB_Check_Frame = CreateFrame("Frame")	
DB_Check_Frame:HookScript("OnUpdate", DatabaseCheck)
	

	local Profit	= 0
	local Spent		= 0
	local OldMoney	= 0

	local function formatMoney(money)
	if PsychoUI.db.char.ShowGold == false then return end
		local gold = floor(math.abs(money) / 10000)
		local silver = mod(floor(math.abs(money) / 100), 100)
		local copper = mod(floor(math.abs(money)), 100)
		if gold ~= 0 then
			return format("%s"..GoldIcon.." %s"..SilverIcon.." %s"..CopperIcon, gold, silver, copper)
		elseif silver ~= 0 then
			return format("%s"..SilverIcon.." %s"..CopperIcon, silver, copper)
		else
			return format("%s"..CopperIcon, copper)
		end
	end
	
	local function formatTextMoney(money)
		if PsychoUI.db.char.ShowGold == false then return end
	
		local gold = floor(math.abs(money) / 10000)
		local silver = mod(floor(math.abs(money) / 100), 100)
		local copper = mod(floor(math.abs(money)), 100)
		if gold ~= 0 then
			return format("%s"..GoldIcon.." %s"..SilverIcon.." %s"..CopperIcon, gold, silver, copper)
		elseif silver ~= 0 then
			return format("%s"..SilverIcon.." %s"..CopperIcon, silver, copper)
		else
			return format("%s"..CopperIcon, copper)
		end

	end

	local function FormatTooltipMoney(money)
		local gold, silver, copper = abs(money / 10000), abs(mod(money / 100, 100)), abs(mod(money, 100))
		local cash = ""
		cash = format("%d"..GoldIcon.." %d"..SilverIcon.." %d"..CopperIcon, gold, silver, copper)		
		return cash
	end	

	local function OnEvent(self, event)
	if PsychoUI.db.char.ShowGold == false then return end
		if event == "PLAYER_ENTERING_WORLD" then
			OldMoney = GetMoney()
		end
		
		local NewMoney	= GetMoney()
		local Change = NewMoney-OldMoney -- Positive if we gain money
		
		if OldMoney > NewMoney then		-- Lost Money
			Spent = Spent - Change
		else							-- Gained Moeny
			Profit = Profit- Change
		end
		
		if OldMoney == NewMoney then		-- No Change 
			Profit = 0		
			else							-- Gained Moeny
			Profit = Profit + Change			
		end
		
		Text:SetText(formatTextMoney(NewMoney))
		-- Setup Money Tooltip
		self:SetAllPoints(Text)

		local myPlayerRealm = GetRealmName();
		local myPlayerName  = UnitName("player");				

	
		Stat:SetScript("OnLeave", function() GameTooltip:Hide() end)
		
		OldMoney = NewMoney
		
	end
	Stat:SetScript("OnMouseDown", function(self,button)
		
			ToggleAllBags()

	end)
	Stat:RegisterEvent("PLAYER_LOGIN")
	Stat:RegisterEvent("PLAYER_MONEY")
	Stat:RegisterEvent("SEND_MAIL_MONEY_CHANGED")
	Stat:RegisterEvent("SEND_MAIL_COD_CHANGED")
	Stat:RegisterEvent("PLAYER_TRADE_MONEY")
	Stat:RegisterEvent("TRADE_MONEY_CHANGED")
	Stat:RegisterEvent("PLAYER_ENTERING_WORLD")
	Stat:SetScript("OnEvent", OnEvent)