--[[
##################
PsychoUI: keivamp#
##################
]]--
local PsychoUI = LibStub("AceAddon-3.0"):GetAddon("PsychoUI")
local LSM = LibStub and LibStub:GetLibrary("LibSharedMedia-3.0", true)
local _, ns = ...
local oUF = ns.oUF
local addonName, addon = ...
local InCombatLockdown      = _G.InCombatLockdown;

local function CreateHealthBackdrop(frame)
    frame:SetBackdrop({bgFile = "Interface\\FocusingFrame\\UI-StatusBar"})
    frame:SetBackdropColor(0.35,0.1,0.1,0.85)
	frame:SetBackdropBorderColor(0,0,0,1)
end

local function CreatePowerBackdrop(frame)
      frame:SetBackdrop({bgFile = "Interface\\FocusingFrame\\UI-StatusBar"})
		frame:SetBackdropColor(0.25,0.25,0.75,0.75)
	frame:SetBackdropBorderColor(0,0,0,1)
end

local function CreateBackdrop(frame)
      frame:SetBackdrop({bgFile = "Interface\\FocusingFrame\\UI-StatusBar"})
		frame:SetBackdropColor(0,0,0,0.75)
		frame:SetBackdropBorderColor(0,0,0,0)
end
local function CreateMoverBackdrop(frame)
   frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
        insets = {top = -2, left = -2, bottom = -2, right = -2}})
		frame:SetBackdropColor(0,0.55,0.95,0.45)
		frame:SetBackdropBorderColor(0,0,0,1)
end
local Mover = CreateFrame("Frame","FocusDrag",UIParent, BackdropTemplateMixin and "BackdropTemplate")

	Mover:SetSize(123,55)
	Mover:SetPoint("CENTER",UIParent,"CENTER",-535,75)
	Mover:SetClampedToScreen(true)
	Mover:SetClampRectInsets(0, 0, 0,0)
	local MoverText  = Mover:CreateFontString(nil, "OVERLAY")
	MoverText:SetFont("Interface\\Addons\\PsychoUI\\Fonts\\Dialog.TTF", 18, "OUTLINE")
	MoverText:SetPoint("CENTER",Mover,"CENTER", 0,0); 
	MoverText:SetText("")
	
	local FocusX = 235
	local FocusY = -335

local UnitSpecific = {
	
	focus = function(self)
	if PsychoUI.db.char.FocusFrameDisable == true then return end
local function DatabaseCheck()
		if PsychoUI.db.char.lockframes == false then 
		
		FocusX = PsychoUI.db.char.FocusX
		FocusY = PsychoUI.db.char.FocusY
		
			Mover:SetPoint("CENTER",UIParent,"CENTER",FocusX,FocusY)
			Mover:Show()
			MoverText:SetText("Focus")
			CreateMoverBackdrop(Mover)
	
		end
		if PsychoUI.db.char.ResetBox == true then 
			FocusX = 235
			FocusY = -335
			Mover:ClearAllPoints()
			Mover:SetPoint("CENTER",UIParent,"CENTER",-535,75)
		end
	end
local DB_Check_Frame = CreateFrame("Frame")	
DB_Check_Frame:HookScript("OnUpdate", DatabaseCheck)

		--------------------
		--  Focus Set Up --
		--------------------
		local FocusWidth = 123;
		local FocusHeight = 55;
		local PortraitWidth = 55;
		local PortraitHeight = 58;
		self:SetSize(FocusWidth,FocusHeight)

		-------------------------------------
		--  Adjust Focus Health and Power --
		-------------------------------------

		self.Health:SetHeight(31)
		self.Power:SetHeight(22)

		-------------------------
		--  Focus Level Value --
		-------------------------
		local TheLevelFontOutline = "NONE"
		if PsychoUI.db.char.FocusFrameLevelFontOutline == 1 then
		TheLevelFontOutline = "NONE"
		elseif PsychoUI.db.char.FocusFrameLevelFontOutline == 2 then
		TheLevelFontOutline = "MONOCHROMEOUTLINE"
		elseif PsychoUI.db.char.FocusFrameLevelFontOutline == 3 then
		TheLevelFontOutline = "THINOUTLINE"
		elseif PsychoUI.db.char.FocusFrameLevelFontOutline == 4 then
		TheLevelFontOutline = "THICKOUTLINE"
		end

		local LevelText = self:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		if PsychoUI.db.char.FocusFrameDisablePortrait == true then
		LevelText:SetPoint("RIGHT", self, 60,0) 
		else
		LevelText:SetPoint("RIGHT", self, 114,20) 
		end
		LevelText:SetFont(LSM:Fetch("font", PsychoUI.db.char.FocusFrameLevelFont), PsychoUI.db.char.FocusFrameLevelFontSize, TheLevelFontOutline)
		LevelText:SetWidth(50)
		LevelText:SetJustifyH("LEFT")
		if PsychoUI.db.char.FocusFrameDisableLevel == false then
		self:Tag(LevelText, "[level]")
		end

		-------------------------
		--  Focus Name Value --
		-------------------------
		local TheNameFontOutline = "NONE"
		if PsychoUI.db.char.FocusFrameNameFontOutline == 1 then
		TheNameFontOutline = "NONE"
		elseif PsychoUI.db.char.FocusFrameNameFontOutline == 2 then
		TheNameFontOutline = "MONOCHROMEOUTLINE"
		elseif PsychoUI.db.char.FocusFrameNameFontOutline == 3 then
		TheNameFontOutline = "THINOUTLINE"
		elseif PsychoUI.db.char.FocusFrameNameFontOutline == 4 then
		TheNameFontOutline = "THICKOUTLINE"
		end

		local NameText = self:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		NameText:SetPoint("TOPLEFT", self, 0,20) -- but anchor to the base element so it doesn't wiggle
		NameText:SetJustifyH("LEFT")
		NameText:SetFont(LSM:Fetch("font", PsychoUI.db.char.FocusFrameNameFont), PsychoUI.db.char.FocusFrameNameFontSize, TheNameFontOutline)
		NameText:SetWidth(400)
		if PsychoUI.db.char.FocusFrameDisableName == false then
		self:Tag(NameText, "[name]")
		end 

		-------------------------
		--  Focus Power Value --
		-------------------------
		local ThePowerFontOutline = "NONE"
		if PsychoUI.db.char.FocusFrameManaFontOutline == 1 then
		ThePowerFontOutline = "NONE"
		elseif PsychoUI.db.char.FocusFrameManaFontOutline == 2 then
		ThePowerFontOutline = "MONOCHROMEOUTLINE"
		elseif PsychoUI.db.char.FocusFrameManaFontOutline == 3 then
		ThePowerFontOutline = "THINOUTLINE"
		elseif PsychoUI.db.char.FocusFrameManaFontOutline == 4 then
		ThePowerFontOutline = "THICKOUTLINE"
		end

		local PowerText = self:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		if PsychoUI.db.char.FocusFrameDisableMana == true then
			PowerText:SetPoint("CENTER", self, 0,-20)
			else
			PowerText:SetPoint("LEFT", self, 5,-20)
			end
		PowerText:SetFont(LSM:Fetch("font", PsychoUI.db.char.FocusFrameManaFont), PsychoUI.db.char.FocusFrameManaFontSize, ThePowerFontOutline)
		if PsychoUI.db.char.FocusFrameDisableManaPercent == false then
		self:Tag(PowerText, "[perpp]".." %")
		end


		local PowerText2 = self:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		if PsychoUI.db.char.FocusFrameDisableManaPercent == true then
			PowerText2:SetPoint("CENTER", self, 0,-20)
			else
			PowerText2:SetPoint("RIGHT", self, -2,-20)
			end
		PowerText2:SetFont(LSM:Fetch("font", PsychoUI.db.char.FocusFrameManaFont), PsychoUI.db.char.FocusFrameManaFontSize, ThePowerFontOutline)
		if PsychoUI.db.char.FocusFrameDisableMana == false then
		self:Tag(PowerText2, "[PsychoUI:MyPower]")
		end

		--------------------------
		--  Focus Health Value --
		--------------------------
		local TheHealthFontOutline = "NONE"
		if PsychoUI.db.char.FocusFrameHealthFontOutline == 1 then
		TheHealthFontOutline = "NONE"
		elseif PsychoUI.db.char.FocusFrameHealthFontOutline == 2 then
		TheHealthFontOutline = "MONOCHROMEOUTLINE"
		elseif PsychoUI.db.char.FocusFrameHealthFontOutline == 3 then
		TheHealthFontOutline = "THINOUTLINE"
		elseif PsychoUI.db.char.FocusFrameHealthFontOutline == 4 then
		TheHealthFontOutline = "THICKOUTLINE"
		end

		local HealthText = self:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		if PsychoUI.db.char.FocusFrameDisableHealth == true then
			HealthText:SetPoint("CENTER", self, 0,12)
			else
			HealthText:SetPoint("LEFT", self, 5,12)
			end
		
		HealthText:SetFont(LSM:Fetch("font", PsychoUI.db.char.FocusFrameHealthFont), PsychoUI.db.char.FocusFrameHealthFontSize, TheHealthFontOutline)
		if PsychoUI.db.char.FocusFrameDisableHealthPercent == false then
		self:Tag(HealthText, "[perhp]".." %")
		end

		local HealthText2 = self:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		if PsychoUI.db.char.FocusFrameDisableHealthPercent == true then
			HealthText2:SetPoint("CENTER", self, 0,12)
			else
			HealthText2:SetPoint("RIGHT", self, -5,12)
			end
		
		HealthText2:SetFont(LSM:Fetch("font", PsychoUI.db.char.FocusFrameHealthFont), PsychoUI.db.char.FocusFrameHealthFontSize, TheHealthFontOutline)
		if PsychoUI.db.char.FocusFrameDisableHealth == false then
		self:Tag(HealthText2, "[PsychoUI:MyHealth]")
		end

		----------------------
		--  Focus Portrait --
		----------------------
		if PsychoUI.db.char.FocusFrameDisablePortrait == false then
		self.Portrait:SetPoint('LEFT', self, 'RIGHT',5,-1)
		self.Portrait:SetSize(PortraitWidth, PortraitHeight)
		end
 
		-----------------------
		--  Focus Cast bar --
		-----------------------
		if PsychoUI.db.char.FocusFrameDisableCB == false then
		self.Castbar:SetSize(180, 20)
		self.Castbar:SetPoint('BOTTOMLEFT', self.Health, 2, -65)
		end

		-----------------------------
		-- Focus Auras
		-----------------------------
		if PsychoUI.db.char.FocusFrameDisableAuras == false then
		local Auras = CreateFrame("Frame", nil, self, BackdropTemplateMixin and "BackdropTemplate")
		Auras:SetPoint("BOTTOMLEFT", self, "TOPLEFT", 0,40)
		Auras:SetPoint("BOTTOMRIGHT", self, "TOPRIGHT", 60, 40)
		Auras:SetHeight(25)
		Auras:SetHeight(25 + 4)

		Auras.size = 25
		Auras.onlyShowPlayer = false
		Auras.gap = 2
		Auras.spacing = 2
		Auras.showStealableAuras = true
		Auras.disableCooldown = false
		Auras.num = 32

		Auras.PostCreateIcon = Aura_PostCreateIcon
		self.Auras = Auras
		end

		
	--------------
	-- Rez Icon --
	--------------

	-- Position and sizew
	local ResurrectIcon = self.Health:CreateTexture(nil, 'OVERLAY')
	ResurrectIcon:SetSize(24, 24)
	ResurrectIcon:SetPoint('LEFT', self,-28,-24)

	-- Register it with oUF
	self.ResurrectIcon = ResurrectIcon
	
	--------------------------
	-- Group Role Indicator --
	--------------------------
	
	  -- Position and size
    local GroupRoleIndicator = self:CreateTexture(nil, 'OVERLAY')
    GroupRoleIndicator:SetSize(24, 24)
    GroupRoleIndicator:SetPoint('LEFT', self,-28,24)

    -- Register it with oUF
    self.GroupRoleIndicator = GroupRoleIndicator

	----------------
	-- Raid icons --
	----------------

	-- Position and size
	local RaidFocusIndicator = self.Health:CreateTexture(nil, 'OVERLAY')
	RaidFocusIndicator:SetSize(24, 24)
	RaidFocusIndicator:SetPoint('LEFT', self,-28,0)

	-- Register it with oUF
	self.RaidFocusIndicator = RaidFocusIndicator

	end, -- End Focus
	
	
}
--	UnitSpecific.arena = UnitSpecific.boss

local Shared = function(self, unit)
if PsychoUI.db.char.FocusFrameDisable == true then return end
self:SetScale(PsychoUI.db.char.FocusFrameScale)
-- Shared layout code.
	-----------------
	--  Mouse Code --
	-----------------
	self:SetScript('OnEnter', UnitFrame_OnEnter)
	self:SetScript('OnLeave', UnitFrame_OnLeave)

	self:RegisterForClicks'AnyUp'
	------------------
	--  Health Bars --
	------------------

	local Health = CreateFrame("StatusBar", nil, self, BackdropTemplateMixin and "BackdropTemplate")
	Health:SetStatusBarTexture(LSM:Fetch("statusbar", PsychoUI.db.char.FocusFrameStatusBarHealth))
	Health:SetPoint('TOP')
	Health:SetPoint('LEFT')
	Health:SetPoint('RIGHT')
	Health:SetReverseFill(true);
	Health:SetFrameLevel(2)
	CreateHealthBackdrop(Health)

	-- Options
	--Health.frequentUpdates = true
	Health.colorTapping = true
	Health.colorDisconnected = true
	Health.colorClass = true
	Health.colorReaction = true
	Health.colorHealth = true
	-- Register it with oUF
	self.Health = Health
	--self.Health.bg = Healthbg
	if PsychoUI.db.char.FocusFrameNoBorder == false then
	Health:CreateBeautyBorder(PsychoUI.db.char.FocusFrameBorderSize)
	Health:SetBeautyBorderPadding(PsychoUI.db.char.FocusFrameBorderPadding)
	Health:SetBeautyBorderTexture("white")
	Health:SetBeautyBorderColor(0.45, 0.45, 0.45,1)
	end
		
    -----------------
	--  Power Bars --
	-----------------

	local Power = CreateFrame("StatusBar", nil, Health, BackdropTemplateMixin and "BackdropTemplate")
	Power:SetStatusBarTexture(LSM:Fetch("statusbar", PsychoUI.db.char.FocusFrameStatusBarPower))
	Power:SetPoint('BOTTOM',Health,'BOTTOM',0,-27)
	Power:SetPoint('LEFT')
	Power:SetPoint('RIGHT')
	Power:SetReverseFill(true);
	Power:SetFrameLevel(1)
	if PsychoUI.db.char.FocusFrameNoBorder == false then
	Power:CreateBeautyBorder(PsychoUI.db.char.FocusFrameBorderSize)
	Power:SetBeautyBorderPadding(PsychoUI.db.char.FocusFrameBorderPadding)
	Power:SetBeautyBorderTexture("white")
	Power:SetBeautyBorderColor(0.45, 0.45, 0.45,1)
	end
	
	CreatePowerBackdrop(Power)
	-- Options
	--Power.frequentUpdates = true
	Power.colorPower = true 
	Power.colorClassNPC = false 
	Power.colorClassPet = false 
	-- Register it with oUF
	self.Power = Power


	------------------
	--   Portrait --
	------------------
	if PsychoUI.db.char.FocusFrameDisablePortrait == false then
	-- 3D Portrait
	local Portrait = CreateFrame('PlayerModel', nil, self, BackdropTemplateMixin and "BackdropTemplate")

	CreateBackdrop(Portrait)
	Portrait:SetBackdrop({bgFile = "Interface\\Addons\\PsychoUI\\Textures\\Buttons\\UNIT-BG13",
    insets = {top = 0, left = 0, bottom = 0, right = 0}})
	Portrait:SetBackdropColor(0,0,0,1)
	if PsychoUI.db.char.FocusFrameNoBorder == false then
	Portrait:CreateBeautyBorder(PsychoUI.db.char.FocusFrameBorderSize)
	Portrait:SetBeautyBorderPadding(PsychoUI.db.char.FocusFrameBorderPadding)
	Portrait:SetBeautyBorderTexture("white")
	Portrait:SetBeautyBorderColor(0.45, 0.45, 0.45,1)
	end
		

	-- Register it with oUF
	self.Portrait = Portrait
	end

	--------------
	-- Cast Bar --
	--------------
if PsychoUI.db.char.FocusFrameDisableCB == false then	
	-- Position and size
	local Castbar = CreateFrame("StatusBar", nil, self, BackdropTemplateMixin and "BackdropTemplate")
	Castbar:SetStatusBarTexture(LSM:Fetch("statusbar", PsychoUI.db.char.FocusFrameStatusBarCB))
	Castbar:SetReverseFill(true);
	Castbar:SetStatusBarColor(0.95, 0.25, 0.25, 0.95)
	if PsychoUI.db.char.FocusFrameNoBorder == false then
	Castbar:CreateBeautyBorder(PsychoUI.db.char.FocusFrameBorderSize)
	Castbar:SetBeautyBorderPadding(PsychoUI.db.char.FocusFrameBorderPadding)
	Castbar:SetBeautyBorderTexture("white")
	Castbar:SetBeautyBorderColor(0.45, 0.45, 0.45,1)
	end
			
	
	-- Add a background
	CreateBackdrop(Castbar)
	-- Add a spark
	local Spark = Castbar:CreateTexture(nil, "OVERLAY")
	Spark:SetSize(40, 12)
	Spark:SetBlendMode("ADD")

	-- Add a timer
	local Time = Castbar:CreateFontString(nil, "OVERLAY", "GameFontNormalSmall")
	Time:SetFont("Interface\\Addons\\PsychoUI\\Fonts\\Dialog.TTF", 10, "OUTLINE")
	Time:SetTextColor(0.99, 0.99, 0.99)
	Time:SetPoint("LEFT", Castbar, 3, 1)

	-- Add spell text
	local Text = Castbar:CreateFontString(nil, "OVERLAY", "GameFontNormalSmall")
	Text:SetFont("Interface\\Addons\\PsychoUI\\Fonts\\Dialog.TTF", 11, "OUTLINE")
	Text:SetTextColor(0.99, 0.99, 0.99)
	Text:SetPoint("RIGHT", Castbar, -3, 1)

	-- Add Shield
	local Shield = Castbar:CreateTexture(nil, "OVERLAY")
	Shield:SetSize(25, 15)
	Shield:SetPoint("CENTER", Castbar)

	local Icon = Castbar:CreateTexture(nil, 'OVERLAY')
    Icon:SetSize(26, 26)
    Icon:SetPoint('LEFT', Castbar, 'RIGHT', 0,0)
	-- Add safezone
	local SafeZone = Castbar:CreateTexture(nil, "OVERLAY")

	-- Register it with oUF
	self.Castbar = Castbar
	self.Castbar.bg = Background
	self.Castbar.Spark = Spark
	self.Castbar.Time = Time
	self.Castbar.Text = Text
	self.Castbar.SafeZone = SafeZone
	self.Castbar.Icon = Icon


	end
	-----------------
	-- Smooth Bars --
	-----------------

	self.Health.Smooth = true
		if self.Power then
			self.Power.Smooth = true
		end


	if(UnitSpecific[unit]) then
		return UnitSpecific[unit](self)
	end
end

oUF:RegisterStyle("PsychoFocus", Shared)
oUF:Factory(function(self)
if PsychoUI.db.char.FocusFrameDisable == true then return end
	FocusX = PsychoUI.db.char.FocusX
	FocusY = PsychoUI.db.char.FocusY
	-----------------
	-- Unit Set Up --
	-----------------
	self:SetActiveStyle("PsychoFocus")
	self:Spawn("focus"):SetPoint("CENTER",UIParent,"CENTER",FocusX,FocusY);
	

end)
