--[[
##################
PsychoUI: keivamp#
##################
]]--
local PsychoUI = LibStub("AceAddon-3.0"):GetAddon("PsychoUI")
local LSM = LibStub and LibStub:GetLibrary("LibSharedMedia-3.0", true)

local _, ns = ...
local oUF = ns.oUF
local _, playerClass = UnitClass("player")
local addonName, addon = ...

	
	local function CreateMoverBackdrop(frame)
		frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
        insets = {top = -2, left = -2, bottom = -2, right = -2}})
		frame:SetBackdropColor(0,0.55,0.95,0.45)
		frame:SetBackdropBorderColor(0,0,0,1)
	end
	local Mover = CreateFrame("Frame","FTDrag",UIParent, BackdropTemplateMixin and "BackdropTemplate")
	
	Mover:SetSize(130,340)
	Mover:SetPoint('TOPLEFT', UIParent,'TOPLEFT', 120, -250)
	Mover:SetClampedToScreen(true)
	Mover:SetClampRectInsets(0, 0, 0,0)
	local MoverText  = Mover:CreateFontString(nil, "OVERLAY")
	MoverText:SetFont("Interface\\Addons\\PsychoUI\\Fonts\\Dialog.TTF", 13, "OUTLINE")
	MoverText:SetPoint("CENTER",Mover,"CENTER", 0,0); 
	MoverText:SetText("")
	--CreateMoverBackdrop(Mover)
	
	local PartyX = 120
	local PartyY = -250


-----------------------------
-- functions
-----------------------------
-- Backdrop function, this is also how we cheese borders on things
local function CreateBackdrop(frame)
   frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
        insets = {top = 0, left = 0, bottom = 0, right = 0}})
		frame:SetBackdropColor(0,0,0,0.75)
	
end
local function CreateRaidBackdrop(frame)
   frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
        insets = {top = -2, left = -2, bottom = -2, right = -2}})
		frame:SetBackdropColor(0,0,0,0.75)
		frame:SetBackdropBorderColor(0,0,0,1)
end
local function CreatePowerBackdrop(frame)
   frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
        insets = {top = 0, left = 0, bottom = 0, right = 0}})
		frame:SetBackdropColor(0.25,0.25,0.25,0.75)
	
end

local function DatabaseCheck()
		if PsychoUI.db.char.lockframes == false then 
			PartyX = PsychoUI.db.char.PartyX
			PartyY = PsychoUI.db.char.PartyY
		
			Mover:SetPoint('TOPLEFT', UIParent,'TOPLEFT',PartyX,PartyY)
			MoverText:SetText("Party")
			Mover:Show()
			CreateMoverBackdrop(Mover)
		
		end
		if PsychoUI.db.char.ResetBox == true then 
			PartyX = 120
			PartyY = -250
			Mover:ClearAllPoints()
			Mover:SetPoint('TOPLEFT', UIParent,'TOPLEFT',120,-250)
		end

	end
	local DB_Check_Frame = CreateFrame("Frame")	
	DB_Check_Frame:HookScript("OnUpdate", DatabaseCheck)



------------------------------------------------------------------
-- Shared settings
------------------------------------------------------------------------
local function Shared(self, unit, isSingle)
if PsychoUI.db.char.EnableParty == false then return end
local playerColor = RAID_CLASS_COLORS[select(2, UnitClass('player'))]

		
	unit = gsub(unit, "%d", "")

	self:SetScript('OnEnter', UnitFrame_OnEnter)
	self:SetScript('OnLeave', UnitFrame_OnLeave)

	self:RegisterForClicks'AnyUp'
	
	--self:SetWidth(120)
	--self:SetHeight(50)
	--CreateRaidBackdrop(self)

	
	local Health = CreateFrame("StatusBar", nil, self, BackdropTemplateMixin and "BackdropTemplate")
	Health:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar")
	

	Health:SetPoint('TOP')
	Health:SetPoint('LEFT')
	Health:SetPoint('RIGHT')
	Health:SetHeight(25)
	Health:CreateBeautyBorder(8)
	Health:SetBeautyBorderPadding(2)
	Health:SetBeautyBorderTexture("white")
	Health:SetBeautyBorderColor(0.45, 0.45,0.45,1)
	CreateBackdrop(Health)
	-- Options
	Health.frequentUpdates = true
	Health.colorTapping = true
	Health.colorDisconnected = true
	Health.colorClass = true
	Health.colorReaction = true
	Health.colorHealth = true
	-- Register it with oUF
	self.Health = Health
	
	--end
	 local Power = CreateFrame("StatusBar", nil, Health, BackdropTemplateMixin and "BackdropTemplate")
	Power:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar")
	Power:SetHeight(14)
	Power:SetPoint('BOTTOM',Health,'BOTTOM',0,-18)
	Power:SetPoint('LEFT')
	Power:SetPoint('RIGHT')
	Power:CreateBeautyBorder(8)
	Power:SetBeautyBorderPadding(2)
	Power:SetBeautyBorderTexture("white")
	Power:SetBeautyBorderColor(0.45, 0.45,0.45,1)
	
	CreatePowerBackdrop(Power)
	-- Options
	Power.frequentUpdates = true
	Power.colorPower = true -- powertype colored bar
	Power.colorClassNPC = false -- color power based on NPC 
	Power.colorClassPet = false -- color power based on pet type
	-- Register it with oUF
	self.Power = Power
	self.Power.bg = Powerbg
	
	-----------------------------
	local Auras = CreateFrame("Frame", nil, self, BackdropTemplateMixin and "BackdropTemplate")
		Auras:SetPoint("BOTTOMLEFT", self, "TOPLEFT", 110,-20)
		Auras:SetPoint("BOTTOMRIGHT", self, "TOPRIGHT", 190, -20)
		Auras:SetHeight(20 + 4)
		Auras.disableMouse = false

		Auras.size = 20
		Auras.onlyShowPlayer = false
		Auras.gap = 2
		Auras.spacing = 2
		Auras.showStealableAuras = true
		Auras.disableCooldown = false
		Auras.num = 32

		Auras.PostCreateIcon = Aura_PostCreateIcon
		self.Auras = Auras
	
	 -- 3D Portrait
    -- Position and size
    local Portrait = CreateFrame('PlayerModel', nil, self, BackdropTemplateMixin and "BackdropTemplate")
	Portrait:CreateBeautyBorder(8)
	Portrait:SetBeautyBorderPadding(2)
	Portrait:SetBeautyBorderTexture("white")
	Portrait:SetBeautyBorderColor(0.45, 0.45,0.45,1)		
	CreateBackdrop(Portrait)
	Portrait:SetBackdrop({bgFile = "Interface\\Addons\\PsychoUI\\Textures\\Backgrounds\\PsychoBam",
      insets = {top = 0, left = 0, bottom = 0, right = 0}})
	Portrait:SetBackdropColor(0.65, 0.65,0.65,0)
    Portrait:SetSize(43, 43)
    Portrait:SetPoint('RIGHT', self, 'LEFT',-5,-1)

    -- Register it with oUF
    self.Portrait = Portrait
	
	
	--Text

	--Name
	local NameText = Health:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
	NameText:SetPoint("TOP",Health,0,18) -- but anchor to the base element so it doesn't wiggle
	NameText:SetFont("Interface\\Addons\\PsychoUI\\Fonts\\Dialog.TTF", 14, "OUTLINE")
	NameText:SetJustifyH("CENTER")
	NameText:SetWidth(100)
	self:Tag(NameText, "[name]") -- oUF will automagically update it!
	Health.text = NameText
	--Health Percent
	local HealthText = Health:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
	HealthText:SetPoint("CENTER",Health,0,-2) -- but anchor to the base element so it doesn't wiggle
	HealthText:SetFont("Interface\\Addons\\PsychoUI\\Fonts\\Numbers.TTF", 12, "OUTLINE")
	HealthText:SetJustifyH("RIGHT")
	self:Tag(HealthText, "[perhp]".." %") 
	Health.text = HealthText

	local PowerText = Power:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
	PowerText:SetPoint("CENTER", Power, 0,0) -- but anchor to the base element so it doesn't wiggle
	PowerText:SetFont("Interface\\Addons\\PsychoUI\\Fonts\\Numbers.TTF", 11, "OUTLINE")
	PowerText:SetJustifyH("CENTER")
	self:Tag(PowerText, "[perpp]".." %")
	Power.text = PowerText
	
	local LevelText = Health:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
	LevelText:SetPoint('BOTTOM', Health, 'TOP',-80,5) -- but anchor to the base element so it doesn't wiggle
	LevelText:SetFont("Interface\\Addons\\PsychoUI\\Fonts\\Numbers.TTF",11,"OUTLINE")
	LevelText:SetJustifyH("LEFT")
	self:Tag(LevelText, "[level]") 
	Health.text = LevelText
	-----------------------------
		
	
	
	
	-- Rez Icon
	-- Position and sizew
	local ResurrectIcon = self.Health:CreateTexture(nil, 'OVERLAY')
	ResurrectIcon:SetSize(24, 24)
	ResurrectIcon:SetPoint('TOP', self, 'BOTTOM',40,-10)
   
	-- Register it with oUF
	self.ResurrectIcon = ResurrectIcon
	
	-----------------------------
	-- Raid icons
	-- Position and size
	local RaidTargetIndicator = self.Health:CreateTexture(nil, 'OVERLAY')
	RaidTargetIndicator:SetSize(24, 24)
	RaidTargetIndicator:SetPoint('RIGHT', self.Health,23,0)
	
	-- Register it with oUF
	self.RaidTargetIndicator = RaidTargetIndicator
	
	-----------------------------
	--Group roles
	 -- Position and size
    local GroupRoleIndicator = self:CreateTexture(nil, 'OVERLAY')
    GroupRoleIndicator:SetSize(24, 24)
    GroupRoleIndicator:SetPoint('RIGHT', self.Health,23,24)

    -- Register it with oUF
    self.GroupRoleIndicator = GroupRoleIndicator
	-- Raid Roles
	
	-- Position and size
	local RaidRoleIndicator = self.Health:CreateTexture(nil, 'OVERLAY')
	RaidRoleIndicator:SetSize(24, 24)
	RaidRoleIndicator:SetPoint('RIGHT', self.Health,23,-24)
   
	-- Register it with oUF
	self.RaidRoleIndicator = RaidRoleIndicator
	
	  -- Position and size
    local LeaderIndicator = self:CreateTexture(nil, 'OVERLAY')
    LeaderIndicator:SetSize(24, 24)
    LeaderIndicator:SetPoint('LEFT', self.Health,-73,24)
	

    -- Register it with oUF
    self.LeaderIndicator = LeaderIndicator
	
	    -- Position and size
    local ReadyCheckIndicator = self:CreateTexture(nil, 'OVERLAY')
    ReadyCheckIndicator:SetSize(24, 24)
    ReadyCheckIndicator:SetPoint('BOTTOM', self, 'TOP',-30,0)

    -- Register with oUF
    self.ReadyCheckIndicator = ReadyCheckIndicator
	
	
	
   	------------------------
	-- Plugin: oUF_Smooth --
	------------------------
	
		self.Health.Smooth = true
		if self.Power then
			self.Power.Smooth = true
		end
	
   
   	----------------------------
	-- Plugin: oUF_SpellRange --
	----------------------------
	
	self.SpellRange = {
			insideAlpha = 1,
			outsideAlpha = 0.5,
		}
	--Range
	if unit == "pet" or unit == "party" or unit == "partypet" then
		self.Range = {
			insideAlpha = 1,
			outsideAlpha = 0.5,
		}
	end
	----------------------------
	-- Plugin: oUF_RaidDebuff --
	----------------------------
	
	local dbh = self:CreateTexture(nil, "OVERLAY")
	dbh:SetAllPoints(self)
	dbh:SetTexture("cfg.statusbar_texture")
	dbh:SetBlendMode("ADD")
	dbh:SetVertexColor(0,0,0,0) -- set alpha to 0 to hide the texture
	self.DebuffHighlightBackdrop = true
	self.DebuffHighlight = dbh
	

	
end

--Spawn Frames
oUF:RegisterStyle('PsychoParty', Shared)
oUF:Factory(function(self)
if PsychoUI.db.char.EnableParty == false then return end
	self:SetActiveStyle'PsychoParty'
			
	local party = self:SpawnHeader(
    nil, nil, 'party,solo',
    'showParty', true,
	'showRaid', false,
    'showPlayer', true,
    'showSolo', PsychoUI.db.char.SoloParty ,
	'groupBy', 'ASSIGNEDROLE',
	'groupingOrder', 'TANK,HEALER,DAMAGER',
    'xOffset', 0,
    'yoffset', -5,
   'oUF-initialConfigFunction', [[
        self:SetHeight(40)
        self:SetWidth(100)
    ]],
    'maxColumns', 5,
    'unitsperColumn', 1,
    'columnSpacing', 35,
    'columnAnchorPoint', "TOP"
)
	PartyX = PsychoUI.db.char.PartyX
	PartyY = PsychoUI.db.char.PartyY
party:SetPoint('TOPLEFT', UIParent,'TOPLEFT', PartyX, PartyY)



end)