--[[
##################
PsychoUI: keivamp#
##################
]]--
local PsychoUI = LibStub("AceAddon-3.0"):GetAddon("PsychoUI")
local LSM = LibStub and LibStub:GetLibrary("LibSharedMedia-3.0", true)

local _, ns = ...
local oUF = ns.oUF
local addonName, addon = ...

local function CreateMoverBackdrop(frame)
   frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
        insets = {top = -2, left = -2, bottom = -2, right = -2}})
		frame:SetBackdropColor(0,0.55,0.95,0.45)
		frame:SetBackdropBorderColor(0,0,0,1)
end

local function CreateHealthBackdrop(frame)
    frame:SetBackdrop({bgFile = "Interface\\TargetingFrame\\UI-StatusBar"})
    frame:SetBackdropColor(0.35,0.1,0.1,0.85)
	frame:SetBackdropBorderColor(0,0,0,1)
end

local function CreatePowerBackdrop(frame)
      frame:SetBackdrop({bgFile = "Interface\\TargetingFrame\\UI-StatusBar"})
		frame:SetBackdropColor(0.25,0.25,0.75,0.75)
	frame:SetBackdropBorderColor(0,0,0,1)
end

local function CreateBackdrop(frame)
      frame:SetBackdrop({bgFile = "Interface\\TargetingFrame\\UI-StatusBar"})
		frame:SetBackdropColor(0,0,0,0.75)
		frame:SetBackdropBorderColor(0,0,0,0)
end

	local Mover = CreateFrame("Frame","PetDrag",UIParent, BackdropTemplateMixin and "BackdropTemplate")
	
	Mover:SetSize(95,35)
	Mover:SetPoint("CENTER",UIParent,"CENTER",-390,-360)
	Mover:SetClampedToScreen(true)
	Mover:SetClampRectInsets(0, 0, 0,0)
	local MoverText  = Mover:CreateFontString(nil, "OVERLAY")
	MoverText:SetFont("Interface\\Addons\\PsychoUI\\Fonts\\Dialog.TTF", 18, "OUTLINE")
	MoverText:SetPoint("CENTER",Mover,"CENTER", 0,0); 
	MoverText:SetText("")
	
	local PetX = -390
	local PetY = -360


local UnitSpecific = {

	pet = function(self)
		if PsychoUI.db.char.PFPetDisable == true then return end
			local function DatabaseCheck()
		if PsychoUI.db.char.lockframes == false then 
			PetX = PsychoUI.db.char.PetX
			PetY = PsychoUI.db.char.PetY
			Mover:SetPoint("CENTER",UIParent,"CENTER",PetX,PetY)
			Mover:Show()
			MoverText:SetText("Pet")
			CreateMoverBackdrop(Mover)
		else
		
		end
		if PsychoUI.db.char.ResetBox == true then 
			PetX = -390
			PetY = -360
			Mover:ClearAllPoints()
			Mover:SetPoint("CENTER",UIParent,"CENTER",-390,-360)
		end

	end
local DB_Check_Frame = CreateFrame("Frame")	
DB_Check_Frame:HookScript("OnUpdate", DatabaseCheck)
		-- pet specific stuff
		---------------------------
		--  Player Pet Set Up  --
		---------------------------
		local PetWidth = 95;
		local PetHeight = 35;
		self:SetSize(PetWidth,PetHeight)

		------------------------
		--  Player Pet Level  --
		------------------------
		local ThePetLevelFontOutline = "NONE"
		if PsychoUI.db.char.PetLevelFontOutline == 1 then
		ThePetLevelFontOutline = "NONE"
		elseif PsychoUI.db.char.PetLevelFontOutline == 2 then
		ThePetLevelFontOutline = "MONOCHROMEOUTLINE"
		elseif PsychoUI.db.char.PetLevelFontOutline == 3 then
		ThePetLevelFontOutline = "THINOUTLINE"
		elseif PsychoUI.db.char.PetLevelFontOutline == 4 then
		ThePetLevelFontOutline = "THICKOUTLINE"
		end

		local LevelText = self:CreateFontString(nil, "OVERLAY", "TextStatusBarText") 
		if PsychoUI.db.char.PFPetDisablePortrait == true then
		LevelText:SetPoint("TOPLEFT", self, -30,-15)
		else
		LevelText:SetPoint("TOPLEFT", self, -45,17)
		end
		LevelText:SetFont(LSM:Fetch("font", PsychoUI.db.char.PetLevelFont), PsychoUI.db.char.PetLevelFontSize, ThePetLevelFontOutline)
		if PsychoUI.db.char.PFPetDisableLevel == false then
		self:Tag(LevelText, "[level]")
		end

		---------------------------
		--  Player Pet Name  --
		---------------------------
		local ThePetNameFontOutline = "NONE"
		if PsychoUI.db.char.PetNameFontOutline == 1 then
		ThePetNameFontOutline = "NONE"
		elseif PsychoUI.db.char.PetNameFontOutline == 2 then
		ThePetNameFontOutline = "MONOCHROMEOUTLINE"
		elseif PsychoUI.db.char.PetNameFontOutline == 3 then
		ThePetNameFontOutline = "THINOUTLINE"
		elseif PsychoUI.db.char.PetNameFontOutline == 4 then
		ThePetNameFontOutline = "THICKOUTLINE"
		end

		local NameText = self:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		NameText:SetPoint("TOPLEFT", self, 0,17) -- but anchor to the base element so it doesn't wiggle
		NameText:SetJustifyH("LEFT")
		NameText:SetFont(LSM:Fetch("font", PsychoUI.db.char.PetNameFont), PsychoUI.db.char.PetNameFontSize, ThePetNameFontOutline)
		NameText:SetWidth(300)
		if PsychoUI.db.char.PFPetDisableName == false then
		self:Tag(NameText, "[name]")
		end

		-------------------------------
		--  Player Pet Power Values  --
		-------------------------------
		local ThePetPowerFontOutline = "NONE"
		if PsychoUI.db.char.PetManaFontOutline == 1 then
		ThePetPowerFontOutline = "NONE"
		elseif PsychoUI.db.char.PetManaFontOutline == 2 then
		ThePetPowerFontOutline = "MONOCHROMEOUTLINE"
		elseif PsychoUI.db.char.PetManaFontOutline == 3 then
		ThePetPowerFontOutline = "THINOUTLINE"
		elseif PsychoUI.db.char.PetManaFontOutline == 4 then
		ThePetPowerFontOutline = "THICKOUTLINE"
		end

		local PowerText = self:CreateFontString(nil, "OVERLAY", "TextStatusBarText") 
		if PsychoUI.db.char.PFPetDisableMana == true then
		PowerText:SetPoint("CENTER", self, 0,-16) 
		else
		PowerText:SetPoint("RIGHT", self, -5,-16) 
		end
		PowerText:SetFont(LSM:Fetch("font", PsychoUI.db.char.PetManaFont), PsychoUI.db.char.PetManaFontSize, ThePetPowerFontOutline)
		if PsychoUI.db.char.PFPetDisableManaPercent == false then
		self:Tag(PowerText, "[perpp]".." %") 
		end

		local PowerText2 = self:CreateFontString(nil, "OVERLAY", "TextStatusBarText") 
		if PsychoUI.db.char.PFPetDisableManaPercent == true then
		PowerText2:SetPoint("CENTER", self, 0,-16) 
		else
		PowerText2:SetPoint("LEFT", self, 5,-16) 
		end
		PowerText2:SetFont(LSM:Fetch("font", PsychoUI.db.char.PetManaFont), PsychoUI.db.char.PetManaFontSize, ThePetPowerFontOutline)
		if PsychoUI.db.char.PFPetDisableMana == false then
		self:Tag(PowerText2, "[PsychoUI:MyPower]") 
		end

		--------------------------------
		--  Player Pet Health Values  --
		--------------------------------
		local ThePetHealthFontOutline = "NONE"
		if PsychoUI.db.char.PetHealthFontOutline == 1 then
		ThePetHealthFontOutline = "NONE"
		elseif PsychoUI.db.char.PetHealthFontOutline == 2 then
		ThePetHealthFontOutline = "MONOCHROMEOUTLINE"
		elseif PsychoUI.db.char.PetHealthFontOutline == 3 then
		ThePetHealthFontOutline = "THINOUTLINE"
		elseif PsychoUI.db.char.PetHealthFontOutline == 4 then
		ThePetHealthFontOutline = "THICKOUTLINE"
		end

		local HealthText = self:CreateFontString(nil, "OVERLAY", "TextStatusBarText") 
		if PsychoUI.db.char.PFPetDisableHealth == true then
		HealthText:SetPoint("CENTER", self,0,7)
		else
		HealthText:SetPoint("RIGHT", self,-5,7) 
		end
		HealthText:SetFont(LSM:Fetch("font", PsychoUI.db.char.PetHealthFont), PsychoUI.db.char.PetHealthFontSize, ThePetHealthFontOutline)
		if PsychoUI.db.char.PFPetDisableHealthPercent == false then
		self:Tag(HealthText, "[perhp]".." %") 
		end

		local HealthText2 = self:CreateFontString(nil, "OVERLAY", "TextStatusBarText") 
		if PsychoUI.db.char.PFPetDisableHealthPercent == true then 
		HealthText2:SetPoint("CENTER", self, 0,7) 
		else
		HealthText2:SetPoint("LEFT", self, 5,7) 
		end
		HealthText2:SetFont(LSM:Fetch("font", PsychoUI.db.char.PetHealthFont), PsychoUI.db.char.PetHealthFontSize, ThePetHealthFontOutline)
		if PsychoUI.db.char.PFPetDisableHealth == false then
		self:Tag(HealthText2, "[PsychoUI:MyHealth]")
		end

		---------------------------
		--  Player Pet Portrait  --
		---------------------------
		if PsychoUI.db.char.PFPetDisablePortrait == false then
		self.Portrait:SetPoint('CENTER', self, 'LEFT', -25,-3)
		self.Portrait:SetSize(40, 41)
		end

		-----------------------------------------------
		--  Player Pet Health and Power Adjustments  --
		-----------------------------------------------

		self.Health:SetHeight(21)
		self.Power:SetHeight(15)


		------------------------------------------------------
		--  Player Pet Cast Bar (Not Availible in Classic)  --
		------------------------------------------------------
		if PsychoUI.db.char.PFPetDisableCB == false then
		self.Castbar:SetPoint('CENTER', self.Power, -22, -20)
		self.Castbar:SetSize(140, 10)
		end

		------------------------
		--  Player Pet Auras  --
		------------------------
		if PsychoUI.db.char.PFPetDisableAuras == false then
		local Auras = CreateFrame("Frame", nil, self, BackdropTemplateMixin and "BackdropTemplate")
			Auras:SetPoint("BOTTOMLEFT", self, "TOPLEFT", 0,25)
			Auras:SetPoint("BOTTOMRIGHT", self, "TOPRIGHT", 0, 25)
			Auras:SetHeight(20)
			Auras:SetHeight(20 + 4)

			Auras.size = 20
			Auras.onlyShowPlayer = false
			Auras.gap = 5
			Auras.spacing = 4
			Auras.showStealableAuras = true
			Auras.disableCooldown = false
			Auras.num = 16

			Auras.PostCreateIcon = Aura_PostCreateIcon
			self.Auras = Auras
			end


	end,-- End Pet
	

}
	--UnitSpecific.arena = UnitSpecific.boss

local Shared = function(self, unit)
	-- Shared layout code.
	if PsychoUI.db.char.PFPetDisable == true then return end
local playerColor = RAID_CLASS_COLORS[select(2, UnitClass('player'))]
self:SetScale(PsychoUI.db.char.PFPetScale)

	-----------------
	--  Mouse Code --
	-----------------
	self:SetScript('OnEnter', UnitFrame_OnEnter)
	self:SetScript('OnLeave', UnitFrame_OnLeave)

	self:RegisterForClicks'AnyUp'
	------------------
	--  Health Bars --
	------------------

	local Health = CreateFrame("StatusBar", nil, self, BackdropTemplateMixin and "BackdropTemplate")
	Health:SetStatusBarTexture(LSM:Fetch("statusbar", PsychoUI.db.char.PFPetStatusBarHealth))
	Health:SetPoint('TOP')
	Health:SetPoint('LEFT')
	Health:SetPoint('RIGHT')
	Health:SetFrameLevel(2)
	CreateHealthBackdrop(Health)
	if PsychoUI.db.char.PFPetNoBorder == false then
	Health:CreateBeautyBorder(PsychoUI.db.char.PFPetBorderSize)
	Health:SetBeautyBorderPadding(PsychoUI.db.char.PFPetBorderPadding)
	Health:SetBeautyBorderTexture("white")
		if PsychoUI.db.char.PFPetBlackBorder == true then
			Health:SetBeautyBorderColor(0, 0, 0, 1)
		else
			Health:SetBeautyBorderColor(playerColor.r, playerColor.g, playerColor.b)
		end
	end
	

	-- Options
	Health.frequentUpdates = true
	Health.colorTapping = true
	Health.colorDisconnected = true
	Health.colorClass = true
	Health.colorReaction = true
	Health.colorHealth = true
	-- Register it with oUF
	self.Health = Health
	self.Health.bg = Healthbg

   -------------------------
	--  Health Prediction --
	------------------------

   -- Register with oUF
		-- self.HealthPrediction = {
		-- myBar = myBar,
		-- otherBar = otherBar,
		-- absorbBar = absorbBar,
		-- healAbsorbBar = healAbsorbBar,
		-- maxOverflow = 1.05,
		-- frequentUpdates = true,
   -- }
    -----------------
	--  Power Bars --
	-----------------

	local Power = CreateFrame("StatusBar", nil, Health, BackdropTemplateMixin and "BackdropTemplate")
	Power:SetStatusBarTexture(LSM:Fetch("statusbar", PsychoUI.db.char.PFPetStatusBarPower))
	Power:SetPoint('BOTTOM',Health,'BOTTOM',0,-20)
	Power:SetPoint('LEFT')
	Power:SetPoint('RIGHT')
	Power:SetFrameLevel(1)
	CreatePowerBackdrop(Power)

	if PsychoUI.db.char.PFPetNoBorder == false then
	Power:CreateBeautyBorder(PsychoUI.db.char.PFPetBorderSize)
	Power:SetBeautyBorderPadding(PsychoUI.db.char.PFPetBorderPadding)
	Power:SetBeautyBorderTexture("white")
		if PsychoUI.db.char.PFPetBlackBorder == true then
			Power:SetBeautyBorderColor(0, 0, 0, 1)
		else
			Power:SetBeautyBorderColor(playerColor.r, playerColor.g, playerColor.b)
		end
	end

	-- Options
	Power.frequentUpdates = true
	Power.colorPower = true -- powertype colored bar
	Power.colorClassNPC = false -- color power based on NPC
	Power.colorClassPet = false -- color power based on pet type
	-- Register it with oUF
	self.Power = Power
	self.Power.bg = Powerbg

	------------------
	--   Portrait --
	------------------
	if PsychoUI.db.char.PFPetDisablePortrait == false then
	-- 3D Portrait
	local Portrait = CreateFrame('PlayerModel', nil, self, BackdropTemplateMixin and "BackdropTemplate")

	--CreateBackdrop(Portrait)
	if PsychoUI.db.char.PFPetNoBorder == false then
	Portrait:CreateBeautyBorder(PsychoUI.db.char.PFPetBorderSize)
	Portrait:SetBeautyBorderPadding(PsychoUI.db.char.PFPetBorderPadding)
	Portrait:SetBeautyBorderTexture("white")
		if PsychoUI.db.char.PFPetBlackBorder == true then
			Portrait:SetBeautyBorderColor(0, 0, 0, 1)
		else
			Portrait:SetBeautyBorderColor(playerColor.r, playerColor.g, playerColor.b)
		end
	end

	CreateBackdrop(Portrait)
	if PsychoUI.db.char.PFPetDisablePortraitBG  == false then
	Portrait:SetBackdrop({bgFile = "Interface\\BUTTONS\\WHITE8X8",
     insets = {top = 0, left = 0, bottom = 0, right = 0}})
		 if PsychoUI.db.char.PetPortraitBGBlackOut == true then
			Portrait:SetBackdropColor(0, 0, 0,1)
		 else
			Portrait:SetBackdropColor(playerColor.r, playerColor.g, playerColor.b,0.75)
		end
	end
	-- Register it with oUF
	self.Portrait = Portrait
	end

	--------------
	-- Cast Bar --
	--------------
	if PsychoUI.db.char.PFPetDisableCB == false then
	-- Position and size
	local Castbar = CreateFrame("StatusBar", nil, self, BackdropTemplateMixin and "BackdropTemplate")
	Castbar:SetStatusBarTexture(LSM:Fetch("statusbar", PsychoUI.db.char.PFPetStatusBarCB))
	if PsychoUI.db.char.PFPetNoBorder == false then
	Castbar:CreateBeautyBorder(PsychoUI.db.char.PFPetBorderSize)
	Castbar:SetBeautyBorderPadding(PsychoUI.db.char.PFPetBorderPadding)
	Castbar:SetBeautyBorderTexture("white")
		if PsychoUI.db.char.PFPetBlackBorder == true then
			Castbar:SetBeautyBorderColor(0, 0, 0, 1)
		else
			Castbar:SetBeautyBorderColor(playerColor.r*0.75, playerColor.g*0.75, playerColor.b*0.75,1)
		end
	end

	-- Add a background
	CreateBackdrop(Castbar)
	-- Add a spark
	local Spark = Castbar:CreateTexture(nil, "OVERLAY")
	Spark:SetSize(65, 8)
	Spark:SetBlendMode("ADD")

	-- Add a timer
	local Time = Castbar:CreateFontString(nil, "OVERLAY", "GameFontNormalSmall")
	Time:SetFont("Interface\\Addons\\PsychoUI\\Fonts\\Dialog.TTF", 10, "OUTLINE")
	Time:SetTextColor(0.95, 0.95, 0.95)
	Time:SetPoint("RIGHT", Castbar, -3, 1)

	-- Add spell text
	local Text = Castbar:CreateFontString(nil, "OVERLAY", "GameFontNormalSmall")
	Text:SetFont("Interface\\Addons\\PsychoUI\\Fonts\\Dialog.TTF", 11, "OUTLINE")
	Text:SetTextColor(0.95, 0.95, 0.95)
	Text:SetPoint("LEFT", Castbar, 3, 1)

	-- Add Shield
	local Shield = Castbar:CreateTexture(nil, "OVERLAY")
	Shield:SetSize(25, 15)
	Shield:SetPoint("CENTER", Castbar)

	local Icon = Castbar:CreateTexture(nil, 'OVERLAY')
    Icon:SetSize(16, 16)
    Icon:SetPoint('LEFT', Castbar, 'LEFT',-20,0)
	-- Add safezone
	local SafeZone = Castbar:CreateTexture(nil, "OVERLAY")

	-- Register it with oUF
	self.Castbar = Castbar
	self.Castbar.bg = Background
	self.Castbar.Spark = Spark
	self.Castbar.Time = Time
	self.Castbar.Text = Text
	self.Castbar.SafeZone = SafeZone
	self.Castbar.Icon = Icon
	end
	-----------------
	-- Smooth Bars --
	-----------------

	self.Health.Smooth = true
		if self.Power then
			self.Power.Smooth = true
		end



	if(UnitSpecific[unit]) then
		return UnitSpecific[unit](self)
	end
end

oUF:RegisterStyle("PsychoPet", Shared)
oUF:Factory(function(self)
	if PsychoUI.db.char.PFPetDisable == true then return end
	PetX = PsychoUI.db.char.PetX
	PetY = PsychoUI.db.char.PetY
	-----------------
	-- Unit Set Up --
	-----------------
     self:SetActiveStyle("PsychoPet")

	  self:Spawn("pet"):SetPoint("CENTER",UIParent,"CENTER",PetX,PetY)


end)
