--[[
##################
PsychoUI: keivamp#
##################
]]--
local PsychoUI = LibStub("AceAddon-3.0"):GetAddon("PsychoUI")
local LSM = LibStub and LibStub:GetLibrary("LibSharedMedia-3.0", true)
local _, ns = ...
local oUF = ns.oUF
local addonName, addon = ...
local InCombatLockdown      = _G.InCombatLockdown;
--LSM:Fetch("statusbar", PsychoUI.db.char.RepStatusBar)
	--LSM:Fetch("font", PsychoUI.db.char.RepFontKey)
local function CreateMoverBackdrop(frame)
   frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
        insets = {top = -2, left = -2, bottom = -2, right = -2}})
		frame:SetBackdropColor(0,0.55,0.95,0.45)
		frame:SetBackdropBorderColor(0,0,0,1)
end
	
local function CreateHealthBackdrop(frame)
    frame:SetBackdrop({bgFile = "Interface\\TargetingFrame\\UI-StatusBar"})
    frame:SetBackdropColor(0.25,0.1,0.1,0.85)
	frame:SetBackdropBorderColor(0,0,0,1)
end

local function CreatePowerBackdrop(frame)
      frame:SetBackdrop({bgFile = "Interface\\TargetingFrame\\UI-StatusBar",
	   insets = {top = -2, left = -2, bottom = -2, right = -2}})
		frame:SetBackdropColor(0,0,0,1)
	frame:SetBackdropBorderColor(0,0,0,1)
end

local function CreateBackdrop(frame)
      frame:SetBackdrop({bgFile = "Interface\\TargetingFrame\\UI-StatusBar"})
		frame:SetBackdropColor(0,0,0,0.75)
		frame:SetBackdropBorderColor(0,0,0,0)
end

local function CreateRuneBackdrop(frame)
     frame:SetBackdrop({bgFile = "Interface\\TargetingFrame\\UI-StatusBar"})
		frame:SetBackdropColor(0, 0, 0,1)
		frame:SetBackdropBorderColor(0,0,0,1)
end

	local Mover = CreateFrame("Frame","PlayerDrag",UIParent, BackdropTemplateMixin and "BackdropTemplate")
	Mover:SetSize(123,55)
	Mover:SetPoint("CENTER",UIParent,"CENTER",-235,-250)
	Mover:SetClampedToScreen(true)
	Mover:SetClampRectInsets(0, 0, 0,0)
	local MoverText  = Mover:CreateFontString(nil, "OVERLAY")
	MoverText:SetFont("Interface\\Addons\\PsychoUI\\Fonts\\Dialog.TTF", 18, "OUTLINE")
	MoverText:SetPoint("CENTER",Mover,"CENTER", 0,0); 
	MoverText:SetText("")
	
	local PlayerX = -235
	local PlayerY = -250

local UnitSpecific = {
	player = function(self)
	if PsychoUI.db.char.PFDisable == true then return end
	local function DatabaseCheck()
		if PsychoUI.db.char.lockframes == false then 
			PlayerX = PsychoUI.db.char.PlayerX
			PlayerY = PsychoUI.db.char.PlayerY
			Mover:SetPoint("CENTER",UIParent,"CENTER",PlayerX,PlayerY)
			MoverText:SetText("Player")
			CreateMoverBackdrop(Mover)
		else
		
		end
		if PsychoUI.db.char.ResetBox == true then 
			PlayerX = -235
			PlayerY = -250
			Mover:ClearAllPoints()
			Mover:SetPoint("CENTER",UIParent,"CENTER",-235,-250)
		end
	end
local DB_Check_Frame = CreateFrame("Frame")	
DB_Check_Frame:HookScript("OnUpdate", DatabaseCheck)

		--------------------
		--  Player Set Up --
		--------------------

		local PlayerWidth = 123;
		local PlayerHeight = 55;
		local PortraitWidth = 55;
		local PortraitHeight = 59;
		self:SetSize(PlayerWidth,PlayerHeight)

		----------------------
		--  Health and Power--
		----------------------
		self.Health:SetHeight(31)
		self.Power:SetHeight(22)

		----------------------
		--  Player Portrait --
		----------------------
		if PsychoUI.db.char.PFDisablePortrait == false then
		self.Portrait:SetPoint('RIGHT', self, 'LEFT',-6,-2)
		self.Portrait:SetSize(PortraitWidth, PortraitHeight)
		end
		----------------------
		--  Player Level --
		----------------------
		--LSM:Fetch("statusbar", PsychoUI.db.char.RepStatusBar)
		--LSM:Fetch("font", PsychoUI.db.char.RepFontKey)
		local TheLevelFontOutline = "NONE"
		if PsychoUI.db.char.LevelFontOutline == 1 then
		TheLevelFontOutline = "NONE"
		elseif PsychoUI.db.char.LevelFontOutline == 2 then
		TheLevelFontOutline = "MONOCHROMEOUTLINE"
		elseif PsychoUI.db.char.LevelFontOutline == 3 then
		TheLevelFontOutline = "THINOUTLINE"
		elseif PsychoUI.db.char.LevelFontOutline == 4 then
		TheLevelFontOutline = "THICKOUTLINE"
		end
		
		local LevelText = self:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		if PsychoUI.db.char.PFDisablePortrait == false then
		LevelText:SetPoint('BOTTOM', self, 'TOP',-105,5)
		else
		LevelText:SetPoint('BOTTOM', self, 'TOP',-80,-20)
		end
		LevelText:SetFont(LSM:Fetch("font", PsychoUI.db.char.LevelFont),PsychoUI.db.char.LevelFontSize,TheLevelFontOutline)
		LevelText:SetJustifyH("LEFT")
		if PsychoUI.db.char.PFDisableLevel == false then
		self:Tag(LevelText, "[level]")
		end
		
		------------------
		--  Player Name --
		------------------
		local TheNameFontOutline = "NONE"
		if PsychoUI.db.char.NameFontOutline == 1 then
		TheNameFontOutline = "NONE"
		elseif PsychoUI.db.char.NameFontOutline == 2 then
		TheNameFontOutline = "MONOCHROMEOUTLINE"
		elseif PsychoUI.db.char.NameFontOutline == 3 then
		TheNameFontOutline = "THINOUTLINE"
		elseif PsychoUI.db.char.NameFontOutline == 4 then
		TheNameFontOutline = "THICKOUTLINE"
		end
		local NameText = self:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		NameText:SetPoint('BOTTOM', self, 'TOP',37,5) -- but anchor to the base element so it doesn't wiggle
		NameText:SetFont(LSM:Fetch("font", PsychoUI.db.char.NameFont), PsychoUI.db.char.NameFontSize, TheNameFontOutline)
		NameText:SetJustifyH("LEFT")
		NameText:SetWidth(200)
		if PsychoUI.db.char.PFDisableName == false then
		self:Tag(NameText, "[name]")
		end
		
		---------------------------
		--  Player Health Values --
		---------------------------
		local TheHealthFontOutline = "NONE"
		if PsychoUI.db.char.HealthFontOutline == 1 then
		TheHealthFontOutline = "NONE"
		elseif PsychoUI.db.char.HealthFontOutline == 2 then
		TheHealthFontOutline = "MONOCHROMEOUTLINE"
		elseif PsychoUI.db.char.HealthFontOutline == 3 then
		TheHealthFontOutline = "THINOUTLINE"
		elseif PsychoUI.db.char.HealthFontOutline == 4 then
		TheHealthFontOutline = "THICKOUTLINE"
		end

		local HealthText = self:CreateFontString(nil, "OVERLAY", "TextStatusBarText") 
		if PsychoUI.db.char.PFDisableHealth == true then
			HealthText:SetPoint("CENTER", self, 0,12)
			else
			HealthText:SetPoint("RIGHT", self, -2,12) 
			end
		HealthText:SetFont(LSM:Fetch("font", PsychoUI.db.char.HealthFont), PsychoUI.db.char.HealthFontSize, TheHealthFontOutline)
		HealthText:SetJustifyH("RIGHT")
		if PsychoUI.db.char.PFDisableHealthPercent == false then
		self:Tag(HealthText, "[perhp]".." %") 
		end
		
		local HealthText2 = self:CreateFontString(nil, "OVERLAY", "TextStatusBarText") 
			if PsychoUI.db.char.PFDisableHealthPercent == true then
			HealthText2:SetPoint("CENTER", self, 0,12)
			else
			HealthText2:SetPoint("LEFT", self, 5,12)
			end
		HealthText2:SetFont(LSM:Fetch("font", PsychoUI.db.char.HealthFont), PsychoUI.db.char.HealthFontSize, TheHealthFontOutline)
		HealthText2:SetJustifyH("LEFT")
		if PsychoUI.db.char.PFDisableHealth == false then
		self:Tag(HealthText2, "[PsychoUI:MyHealth]")
		end

		--------------------------
		--  Player Power Values --
		--------------------------
		local ThePowerFontOutline = "NONE"
		if PsychoUI.db.char.ManaFontOutline == 1 then
		ThePowerFontOutline = "NONE"
		elseif PsychoUI.db.char.ManaFontOutline == 2 then
		ThePowerFontOutline = "MONOCHROMEOUTLINE"
		elseif PsychoUI.db.char.ManaFontOutline == 3 then
		ThePowerFontOutline = "THINOUTLINE"
		elseif PsychoUI.db.char.ManaFontOutline == 4 then
		ThePowerFontOutline = "THICKOUTLINE"
		end

		local PowerText = self:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		if PsychoUI.db.char.PFDisableMana == true then
			PowerText:SetPoint("CENTER", self, 0, -20) 
			else
			PowerText:SetPoint("RIGHT", self, -2, -20) 
			end
		PowerText:SetFont(LSM:Fetch("font", PsychoUI.db.char.ManaFont), PsychoUI.db.char.ManaFontSize, ThePowerFontOutline)
		PowerText:SetJustifyH("RIGHT")
		if PsychoUI.db.char.PFDisableManaPercent == false then
		self:Tag(PowerText, "[perpp]".." %")
		end
		
		local PowerText2 = self:CreateFontString(nil, "OVERLAY", "TextStatusBarText") 
		if PsychoUI.db.char.PFDisableManaPercent == true then
			PowerText2:SetPoint("CENTER", self, 0, -20) 
			else
			PowerText2:SetPoint("LEFT", self, 5, -20)
			end
		PowerText2:SetFont(LSM:Fetch("font", PsychoUI.db.char.ManaFont), PsychoUI.db.char.ManaFontSize, ThePowerFontOutline)
		PowerText2:SetJustifyH("LEFT")
		if PsychoUI.db.char.PFDisableMana == false then
		self:Tag(PowerText2, "[PsychoUI:MyPower]")
		end

		local PowerText3 = self.Power:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		PowerText3:SetPoint("CENTER", self, 0,-20) -- but anchor to the base element so it doesn't wiggle
		PowerText3:SetFont(LSM:Fetch("font", PsychoUI.db.char.ManaFont), PsychoUI.db.char.ManaFontSize, ThePowerFontOutline)
		PowerText3:SetJustifyH("CENTER")
		self:Tag(PowerText3, "[curpp]") -- oUF will automagically update it!
		PowerText3:SetAlpha(0)
				
		local function UltraFunction()
					if(select(2, UnitClass('player')) == 'WARRIOR') or (select(2, UnitClass('player')) == 'ROGUE') or (select(2, UnitClass('player')) == 'DRUID') or (select(2, UnitClass('player')) == 'DEATHKNIGHT') or (select(2, UnitClass('player')) == 'DEMONHUNTER')then
						if(select(2, UnitClass('player')) == 'DRUID') then
							local form = GetShapeshiftFormID()
							if (form == BEAR_FORM or form == CAT_FORM) then
								PowerText3:SetAlpha(1)
								self:Tag(PowerText3, "[curpp]")
								PowerText2:SetAlpha(0)
								PowerText:SetAlpha(0)
						
							end
						elseif(select(2, UnitClass('player')) == 'WARRIOR') then
							PowerText3:SetAlpha(1)
							PowerText2:SetAlpha(0)
							PowerText:SetAlpha(0)
						elseif(select(2, UnitClass('player')) == 'ROGUE') then
							PowerText3:SetAlpha(1)
							PowerText2:SetAlpha(0)
							PowerText:SetAlpha(0)
						elseif(select(2, UnitClass('player')) == 'DEATHKNIGHT') then
							PowerText3:SetAlpha(1)
							PowerText2:SetAlpha(0)
							PowerText:SetAlpha(0)
						elseif(select(2, UnitClass('player')) == 'DEMONHUNTER') then
							PowerText3:SetAlpha(1)
							PowerText2:SetAlpha(0)
							PowerText:SetAlpha(0)

						end
					else
						PowerText3:SetAlpha(0)
						PowerText2:SetAlpha(1)
						PowerText:SetAlpha(1)
					end
					if(select(2, UnitClass('player')) == 'DRUID') then
						local spec = GetSpecialization()
							if spec == 1 then
								PowerText3:SetAlpha(1)
								PowerText2:SetAlpha(0)
								PowerText:SetAlpha(0)
							end
					end
					if(select(2, UnitClass('player')) == 'PRIEST') then
						local spec = GetSpecialization()
							if spec == 3 then
								PowerText3:SetAlpha(1)
								PowerText2:SetAlpha(0)
								PowerText:SetAlpha(0)
								
							end
					end
					if(select(2, UnitClass('player')) == 'MONK') then
						local spec = GetSpecialization()
							if spec == 1 or spec == 3 then
								PowerText3:SetAlpha(1)
								PowerText2:SetAlpha(0)
								PowerText:SetAlpha(0)
								
							end
					end
					if(select(2, UnitClass('player')) == 'SHAMAN') then
						local spec = GetSpecialization()
							if spec ~= 3 then
								PowerText3:SetAlpha(1)
								PowerText2:SetAlpha(0)
								PowerText:SetAlpha(0)
							end
							
					end
				end
		local UltraEvent = CreateFrame("FRAME")
		UltraEvent:HookScript("OnUpdate", UltraFunction)

		----------------------
		--  Player Cast Bar --
		----------------------
		if PsychoUI.db.char.PFDisableCB == false then
		self.Castbar:SetSize(180, 20)
		self.Castbar:SetPoint('BOTTOMRIGHT', self.Health, 0, -80)
		end
		------------------
		--  Player Aura --
		------------------
		if PsychoUI.db.char.PFDisableAuras == false then
			if PsychoUI.db.char.PFDisablePortraitBG == true then
				local Auras = CreateFrame("Frame", nil, self, BackdropTemplateMixin and "BackdropTemplate")
				Auras:SetPoint("BOTTOMLEFT", self, "TOPLEFT", 0,40)
				Auras:SetPoint("BOTTOMRIGHT", self, "TOPRIGHT", 40, 40)
				Auras:SetHeight(25 + 4)
				Auras.disableMouse = false

				Auras.size = 25
				Auras.onlyShowPlayer = false
				Auras.gap = 2
				Auras.spacing = 2
				Auras.showStealableAuras = true
				Auras.disableCooldown = false
				Auras.num = 32

				Auras.PostCreateIcon = Aura_PostCreateIcon
				self.Auras = Auras
			else
				local Auras = CreateFrame("Frame", nil, self, BackdropTemplateMixin and "BackdropTemplate")
				Auras:SetPoint("BOTTOMLEFT", self, "TOPLEFT", -60,40)
				Auras:SetPoint("BOTTOMRIGHT", self, "TOPRIGHT", 20, 40)
				Auras:SetHeight(25 + 4)
				Auras.disableMouse = false

				Auras.size = 25
				Auras.onlyShowPlayer = false
				Auras.gap = 2
				Auras.spacing = 2
				Auras.showStealableAuras = true
				Auras.disableCooldown = false
				Auras.num = 32

				Auras.PostCreateIcon = Aura_PostCreateIcon
				self.Auras = Auras
			end
		end
		-------------------------
		--  Player Combat Icon --
		-------------------------

		  -- Position and size
    local CombatIndicator = self:CreateTexture(nil, 'OVERLAY')
    CombatIndicator:SetSize(40, 40)
    CombatIndicator:SetPoint("LEFT",self,"RIGHT",0,-10)

    -- Register it with oUF
    self.CombatIndicator = CombatIndicator
		-----------------------
		--  Player Rest Icon --
		-----------------------

    local RestingIndicator = self:CreateTexture(nil, 'OVERLAY')
    RestingIndicator:SetSize(32, 32)
	if PsychoUI.db.char.PFDisablePortrait == false then
    RestingIndicator:SetPoint("CENTER",self,"CENTER",-140,35)
	else
	RestingIndicator:SetPoint("CENTER",self,"CENTER",-80,35)
	end
    -- Register it with oUF
    self.RestingIndicator = RestingIndicator

		----------------------
		--  Player PVP Icon --
		----------------------

		local PVPFrame = CreateFrame("Frame")
		PVPFrame:SetSize(32, 32)
		PVPFrame:SetPoint("LEFT",self,15,10);
		PVPFrame:Hide()
		PVPFrame.Bg = PVPFrame:CreateTexture(nil, "BACKGROUND")
		PVPFrame.Bg:SetTexture("Interface\\Addons\\PsychoUI\\Textures\\Unit Frames\\pvp")
		local color = RAID_CLASS_COLORS[select(2, UnitClass("player"))]
				local MyRed = color.r
				local MyGreen = color.g
				local MyBlue = color.b
		if UnitClass("player") == "Shaman" then
		MyRed = color.r * 0
		MyGreen = color.g * 0.44
		MyBlue = color.b * 0.87
		end
		PVPFrame.Bg:SetVertexColor(MyRed, MyGreen, MyBlue, 0.75);
		PVPFrame.Bg:SetPoint("LEFT",self, -80,0);
		PVPFrame.Bg:SetSize(40, 40)
		----------------------
		--  Player PVP Text --
		----------------------
		
		local PVPText = self:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		PVPText:SetPoint("CENTER", self, 0,-43) -- but anchor to the base element so it doesn't wiggle
		PVPText:SetFont("Interface\\Addons\\PsychoUI\\Fonts\\Numbers.TTF",11,"OUTLINE")

		local function pvpTimerFormat(left)
			mins = math.floor(left / 60)
			secs = math.floor(left - (mins * 60))
			return string.format("%d:%02d", mins, secs)
		end
		
		function PlayerPVPMe()
			if UnitIsPVP("player") then
				PVPFrame:Show()
					local time = GetPVPTimer()
					if time < 301000 then
						PVPText:SetText("PVP: "..pvpTimerFormat(time / 1000))
					end
			else
				PVPFrame:Hide()
				PVPText:SetText("")
			end
		end
		local PlayerPVPMeframe = CreateFrame("Frame")
		PlayerPVPMeframe:HookScript("OnUpdate", PlayerPVPMe)

    local PvPClassificationIndicator = self:CreateTexture(nil, 'OVERLAY')
    PvPClassificationIndicator:SetSize(24, 24)
    PvPClassificationIndicator:SetPoint('CENTER')
    self.PvPClassificationIndicator = PvPClassificationIndicator
	oUF:RegisterInitCallback(addPvPTimer)

		---------------------------------
		--  Player Class Power  --
		---------------------------------

			local ClassPower = {}
			for index = 1, 10 do
			local Bar = CreateFrame('StatusBar', nil, self, BackdropTemplateMixin and "BackdropTemplate")
			Bar:SetStatusBarTexture(LSM:Fetch("statusbar", PsychoUI.db.char.PFStatusBarClassPower))
			CreateBackdrop(Bar)

        -- Position and size.
			Bar:SetSize(20, 13)
			Bar:SetPoint('BOTTOMLEFT', self, 'TOPLEFT', (index -1) * (Bar:GetWidth()+6), -78)

			ClassPower[index] = Bar
			end

		-- Register with oUF
		self.ClassPower = ClassPower
		

	
	--DK RUNES ---
	if(select(2, UnitClass('player')) == 'DEATHKNIGHT') then


	local Runes = {}
    for index = 1, 6 do
        local Rune = CreateFrame('StatusBar', nil, self, BackdropTemplateMixin and "BackdropTemplate")
		Rune:SetSize(100/ 6, 20)
		Rune:SetStatusBarTexture(LSM:Fetch("statusbar", PsychoUI.db.char.PFStatusBarPower))
		Rune:SetOrientation("VERTICAL")
		local spec = GetSpecialization()
		if spec == 1 then
		--print("Blood")
		Rune:SetStatusBarColor(170/255, 10/255, 10/255)
		end
		if spec == 2 then
		--print("Frost")
		Rune:SetStatusBarColor(10/255, 120/255, 235/255)
		end
		if spec == 3 then
		Rune:SetStatusBarColor(10/255, 170/255, 10/255)
		--print("Unholy")
		end

		Rune:SetReverseFill(true);
		CreateRuneBackdrop(Rune)
        
        Rune:SetPoint('TOPLEFT', self, 'BOTTOMLEFT', ((index * 110 / 6)* 1.15)-20, -10)
        Runes[index] = Rune
    end

    self.Runes = Runes
	 end

	--------------
	-- Rez Icon --
	--------------

	-- Position and sizew
	local ResurrectIcon = self.Health:CreateTexture(nil, 'OVERLAY')
	ResurrectIcon:SetSize(24, 24)
	ResurrectIcon:SetPoint('RIGHT', self,28,-24)

	self.ResurrectIcon = ResurrectIcon
	
	--------------------------
	-- Group Role Indicator --
	--------------------------
	
	  -- Position and size
    local GroupRoleIndicator = self:CreateTexture(nil, 'OVERLAY')
    GroupRoleIndicator:SetSize(24, 24)
    GroupRoleIndicator:SetPoint('RIGHT', self,28,24)
    self.GroupRoleIndicator = GroupRoleIndicator

	----------------
	-- Raid icons --
	----------------

	-- Position and size
	local RaidTargetIndicator = self.Health:CreateTexture(nil, 'OVERLAY')
	RaidTargetIndicator:SetSize(24, 24)
	RaidTargetIndicator:SetPoint('RIGHT', self,28,0)
	self.RaidTargetIndicator = RaidTargetIndicator
	
	
		---------------------------------
		--  Player Floating Combat Text--
		---------------------------------
		if PsychoUI.db.char.PlayerFloatingCombatText == true then
			local TheFCTFontOutline = "NONE"
			if PsychoUI.db.char.PFCFNameFontOutline == 1 then
			TheFCTFontOutline = "NONE"
			elseif PsychoUI.db.char.PFCFNameFontOutline == 2 then
			TheFCTFontOutline = "MONOCHROMEOUTLINE"
			elseif PsychoUI.db.char.PFCFNameFontOutline == 3 then
			TheFCTFontOutline = "THINOUTLINE"
			elseif PsychoUI.db.char.PFCFNameFontOutline == 4 then
			TheFCTFontOutline = "THICKOUTLINE"
			end
		
		local fcf = CreateFrame("Frame", nil, self, BackdropTemplateMixin and "BackdropTemplate")
		fcf:SetSize(32, 32)
		fcf:SetPoint("CENTER",0,150)
		for i = 1, 6 do
			-- give names to these font strings to avoid breaking /fstack and /tinspect
			fcf[i] = fcf:CreateFontString("$parentFCFText" .. i, "OVERLAY")
		end
		fcf.font = LSM:Fetch("font", PsychoUI.db.char.PFCFNameFont)
		fcf.fontHeight = PsychoUI.db.char.PFCFNameFontSize
		fcf.fontFlags = TheFCTFontOutline
		self.FloatingCombatFeedback = fcf
		end
	end,-- End Player
	
}
--UnitSpecific.arena = UnitSpecific.boss

local Shared = function(self, unit)
	if PsychoUI.db.char.PFDisable == true then return end
	self:SetScale(PsychoUI.db.char.PFScale)
	-- Shared layout code.
	local playerColor = RAID_CLASS_COLORS[select(2, UnitClass('player'))]
	-----------------
	--  Mouse Code --
	-----------------
	self:SetScript('OnEnter', UnitFrame_OnEnter)
	self:SetScript('OnLeave', UnitFrame_OnLeave)

	self:RegisterForClicks'AnyUp'
	------------------
	--  Health Bars --
	------------------

	local Health = CreateFrame("StatusBar", nil, self, BackdropTemplateMixin and "BackdropTemplate")
	Health:SetStatusBarTexture(LSM:Fetch("statusbar", PsychoUI.db.char.PFStatusBarHealth))
	Health:SetPoint('TOP')
	Health:SetPoint('LEFT')
	Health:SetPoint('RIGHT')
	Health:SetFrameLevel(2)
	CreateHealthBackdrop(Health)

	-- Options
	Health.frequentUpdates = true
	Health.colorTapping = true
	Health.colorDisconnected = true
	Health.colorClass = true
	Health.colorReaction = true
	Health.colorHealth = true
	self.Health = Health
	self.Health.bg = Healthbg
	
	if PsychoUI.db.char.PFNoBorder == false then
	Health:CreateBeautyBorder(PsychoUI.db.char.PFBorderSize)
	Health:SetBeautyBorderPadding(PsychoUI.db.char.PFBorderPadding)
	Health:SetBeautyBorderTexture("white")
		if PsychoUI.db.char.PFBlackBorder == true then
			Health:SetBeautyBorderColor(0, 0, 0, 1)
		else
			Health:SetBeautyBorderColor(playerColor.r, playerColor.g, playerColor.b)
		end
	end

    -----------------
	--  Power Bars --
	-----------------

	local Power = CreateFrame("StatusBar", nil, Health, BackdropTemplateMixin and "BackdropTemplate")
	Power:SetStatusBarTexture(LSM:Fetch("statusbar", PsychoUI.db.char.PFStatusBarPower))
	Power:SetPoint('BOTTOM',Health,'BOTTOM',0,-28)
	Power:SetPoint('LEFT')
	Power:SetPoint('RIGHT')
	Power:SetFrameLevel(1)
	CreatePowerBackdrop(Power)
	Power.frequentUpdates = true
	Power.colorPower = true 
	Power.colorClassNPC = false
	Power.colorClassPet = false 
	self.Power = Power
	if PsychoUI.db.char.PFNoBorder == false then
	Power:CreateBeautyBorder(PsychoUI.db.char.PFBorderSize)
	Power:SetBeautyBorderPadding(PsychoUI.db.char.PFBorderPadding)
	Power:SetBeautyBorderTexture("white")
		if PsychoUI.db.char.PFBlackBorder == true then
			Power:SetBeautyBorderColor(0, 0, 0, 1)
		else
			Power:SetBeautyBorderColor(playerColor.r, playerColor.g, playerColor.b)
		end
	end

	------------------
	--   Portrait --
	------------------
	-- 3D Portrait
	if PsychoUI.db.char.PFDisablePortrait == false then
	local Portrait = CreateFrame('PlayerModel', nil, self, BackdropTemplateMixin and "BackdropTemplate")
	if PsychoUI.db.char.PFNoBorder == false then
	Portrait:CreateBeautyBorder(PsychoUI.db.char.PFBorderSize)
	Portrait:SetBeautyBorderPadding(PsychoUI.db.char.PFBorderPadding)
	Portrait:SetBeautyBorderTexture("white")
		if PsychoUI.db.char.PFBlackBorder == true then
			Portrait:SetBeautyBorderColor(0, 0, 0, 1)
		else
			Portrait:SetBeautyBorderColor(playerColor.r, playerColor.g, playerColor.b)
		end
	end
		
	if PsychoUI.db.char.PFDisablePortraitBG == false then
		Portrait:SetBackdrop({bgFile = "Interface\\BUTTONS\\WHITE8X8",
		insets = {top = 0, left = 0, bottom = 0, right = 0}})
	  else
	  Portrait:SetBackdrop({bgFile = "",
      insets = {top = 0, left = 0, bottom = 0, right = 0}})
	  end
		if PsychoUI.db.char.PortraitBGBlackOut == true then
			Portrait:SetBackdropColor(0, 0, 0,1)
		else
			Portrait:SetBackdropColor(playerColor.r, playerColor.g, playerColor.b,0.7)
		end
	self.Portrait = Portrait
	end
	--------------
	-- Cast Bar --
	--------------

	-- Position and size
	if PsychoUI.db.char.PFDisableCB == false then
	local Castbar = CreateFrame("StatusBar", nil, self, BackdropTemplateMixin and "BackdropTemplate")
	Castbar:SetStatusBarTexture(LSM:Fetch("statusbar", PsychoUI.db.char.PFStatusBarCB))	
	if PsychoUI.db.char.PFNoBorder == false then
	Castbar:CreateBeautyBorder(PsychoUI.db.char.PFBorderSize)
	Castbar:SetBeautyBorderPadding(PsychoUI.db.char.PFBorderPadding)
	Castbar:SetBeautyBorderTexture("white")
		if PsychoUI.db.char.PFBlackBorder == true then
			Castbar:SetBeautyBorderColor(0, 0, 0, 1)
		else
			Castbar:SetBeautyBorderColor(playerColor.r*0.75, playerColor.g*0.75, playerColor.b*0.75,1)
		end
	end
	-- Add a background
	CreateBackdrop(Castbar)
	-- Add a spark
	local Spark = Castbar:CreateTexture(nil, "OVERLAY")
	Spark:SetSize(65, 8)
	Spark:SetBlendMode("ADD")
	-- Add a timer
	local Time = Castbar:CreateFontString(nil, "OVERLAY", "GameFontNormalSmall")
	Time:SetFont("Interface\\Addons\\PsychoUI\\Fonts\\Dialog.TTF", 10, "OUTLINE")
	Time:SetTextColor(0.95, 0.95, 0.95)
	Time:SetPoint("RIGHT", Castbar, -3, 1)
	-- Add spell text
	local Text = Castbar:CreateFontString(nil, "OVERLAY", "GameFontNormalSmall")
	Text:SetFont("Interface\\Addons\\PsychoUI\\Fonts\\Dialog.TTF", 11, "OUTLINE")
	Text:SetTextColor(0.95, 0.95, 0.95)
	Text:SetPoint("LEFT", Castbar, 3, 1)
	-- Add Shield
	local Shield = Castbar:CreateTexture(nil, "OVERLAY")
	Shield:SetSize(25, 15)
	Shield:SetPoint("CENTER", Castbar)
	local Icon = Castbar:CreateTexture(nil, 'OVERLAY')
    Icon:SetSize(26, 26)
    Icon:SetPoint('LEFT', Castbar, 'LEFT',-25,0)
	-- Add safezone
	local SafeZone = Castbar:CreateTexture(nil, "OVERLAY")
	self.Castbar = Castbar
	self.Castbar.bg = Background
	self.Castbar.Spark = Spark
	self.Castbar.Time = Time
	self.Castbar.Text = Text
	self.Castbar.SafeZone = SafeZone
	self.Castbar.Icon = Icon
	end
	-----------------
	-- Smooth Bars --
	-----------------
	self.Health.Smooth = true
		if self.Power then
			self.Power.Smooth = true
		end
		
		local AdditionalPower = CreateFrame('StatusBar', nil, self, BackdropTemplateMixin and "BackdropTemplate")
		AdditionalPower:SetStatusBarTexture(LSM:Fetch("statusbar", PsychoUI.db.char.PFStatusBarAltPower))
		AdditionalPower.colorPower = true
		AdditionalPower:SetFrameLevel(1)
		AdditionalPower:SetSize(20, 20)
		AdditionalPower:SetPoint('BOTTOM',0,-29)
		AdditionalPower:SetPoint('LEFT')
		AdditionalPower:SetPoint('RIGHT')
		CreateBackdrop(AdditionalPower)
		if PsychoUI.db.char.PFNoBorder == false then
		AdditionalPower:CreateBeautyBorder(PsychoUI.db.char.PFBorderSize)
		AdditionalPower:SetBeautyBorderPadding(PsychoUI.db.char.PFBorderPadding)
		AdditionalPower:SetBeautyBorderTexture("white")
			if PsychoUI.db.char.PFBlackBorder == true then
				AdditionalPower:SetBeautyBorderColor(0, 0, 0, 1)
			else
				AdditionalPower:SetBeautyBorderColor(playerColor.r, playerColor.g, playerColor.b,1)
			end
		end
		
		self.AdditionalPower = AdditionalPower
		local MyMana = UnitPower(unit, Enum.PowerType.Mana)
		local ManaText = AdditionalPower:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		ManaText:SetPoint("CENTER", AdditionalPower, 0,0) -- but anchor to the base element so it doesn't wiggle
		ManaText:SetFont("Interface\\Addons\\PsychoUI\\Fonts\\Numbers.TTF", 11, "OUTLINE")
		ManaText:SetJustifyH("LEFT")
		self:Tag(ManaText,"[curmana]".." K")

		
	if(UnitSpecific[unit]) then
		return UnitSpecific[unit](self)
	end
end

oUF:RegisterStyle("PsychoPlayer", Shared)
oUF:Factory(function(self)
if PsychoUI.db.char.PFDisable == true then return end
		-- local PlayerX = -235
		-- local PlayerY = -250
		PlayerX = PsychoUI.db.char.PlayerX
		PlayerY = PsychoUI.db.char.PlayerY
	-----------------
	-- Unit Set Up --
	-----------------
     self:SetActiveStyle("PsychoPlayer")
     self:Spawn("player"):SetPoint("CENTER",UIParent,"CENTER",PlayerX,PlayerY)
	 

	
end)
