--[[
##################
PsychoUI: keivamp#
##################
]]--
local PsychoUI = LibStub("AceAddon-3.0"):GetAddon("PsychoUI")
local LSM = LibStub and LibStub:GetLibrary("LibSharedMedia-3.0", true)

local _, ns = ...
local oUF = ns.oUF
local _, playerClass = UnitClass("player")
local addonName, addon = ...

-----------------------------
-- functions
-----------------------------
-- Backdrop function, this is also how we cheese borders on things
local function CreateBackdrop(frame)
   frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
        insets = {top = 0, left = 0, bottom = 0, right = 0}})
		frame:SetBackdropColor(0,0,0,0.75)
	
end
local function CreateRaidBackdrop(frame)
   frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
        insets = {top = -2, left = -2, bottom = -2, right = -2}})
		frame:SetBackdropColor(0,0,0,0.75)
		frame:SetBackdropBorderColor(0,0,0,1)
end
local function CreatePowerBackdrop(frame)
   frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
        insets = {top = 0, left = 0, bottom = 0, right = 0}})
		frame:SetBackdropColor(0.25,0.25,0.25,0.75)
	
end


local function CreateMoverBackdrop(frame)
		frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
        insets = {top = -2, left = -2, bottom = -2, right = -2}})
		frame:SetBackdropColor(0,0.55,0.95,0.45)
		frame:SetBackdropBorderColor(0,0,0,1)
	end
	local Mover = CreateFrame("Frame","FTDrag",UIParent, BackdropTemplateMixin and "BackdropTemplate")
	
	Mover:SetSize(300,400)
	Mover:SetPoint('TOPLEFT', UIParent,'TOPLEFT', 30, -120)
	Mover:SetClampedToScreen(true)
	Mover:SetClampRectInsets(0, 0, 0,0)
	local MoverText  = Mover:CreateFontString(nil, "OVERLAY")
	MoverText:SetFont("Interface\\Addons\\PsychoUI\\Fonts\\Dialog.TTF", 13, "OUTLINE")
	MoverText:SetPoint("CENTER",Mover,"CENTER", 0,0); 
	MoverText:SetText("")
	--CreateMoverBackdrop(Mover)
	
	local RaidX = 30
	local RaidY = -120


local function DatabaseCheck()
		if PsychoUI.db.char.lockframes == false then 
			RaidX = PsychoUI.db.char.RaidX
			RaidY = PsychoUI.db.char.RaidY
		
			Mover:SetPoint('TOPLEFT', UIParent,'TOPLEFT',RaidX,RaidY)
			MoverText:SetText("RAID")
			Mover:Show()
			CreateMoverBackdrop(Mover)
		
		end
		if PsychoUI.db.char.ResetBox == true then 
			RaidX = 90
			RaidY = -150
			Mover:ClearAllPoints()
			Mover:SetPoint('TOPLEFT', UIParent,'TOPLEFT',30,-120)
		end

	end
	local DB_Check_Frame = CreateFrame("Frame")	
	DB_Check_Frame:HookScript("OnUpdate", DatabaseCheck)

------------------------------------------------------------------
-- Shared settings
------------------------------------------------------------------------
local function Shared(self, unit, isSingle)
if PsychoUI.db.char.EnableRaid == false then return end
		
	unit = gsub(unit, "%d", "")

	self:SetScript('OnEnter', UnitFrame_OnEnter)
	self:SetScript('OnLeave', UnitFrame_OnLeave)

	self:RegisterForClicks'AnyUp'
	
	--self:SetWidth(120)
	--self:SetHeight(50)
	--CreateRaidBackdrop(self)

	
	local Health = CreateFrame("StatusBar", nil, self, BackdropTemplateMixin and "BackdropTemplate")
	Health:SetStatusBarTexture("Interface\\Addons\\PsychoUI\\Textures\\Unit Frames\\DEFAULT_Status")
	

	Health:SetPoint('TOP')
	Health:SetPoint('LEFT')
	Health:SetPoint('RIGHT')
	Health:SetHeight(20)
	Health:SetFrameLevel(2)

	CreateBackdrop(Health)
	-- Options
	Health.frequentUpdates = true
	Health.colorTapping = true
	Health.colorDisconnected = true
	Health.colorClass = true
	Health.colorReaction = true
	Health.colorHealth = true
	-- Register it with oUF
	self.Health = Health
	
	--end
	 local Power = CreateFrame("StatusBar", nil, Health, BackdropTemplateMixin and "BackdropTemplate")
	Power:SetStatusBarTexture("Interface\\Addons\\PsychoUI\\Textures\\Unit Frames\\DEFAULT_Status")
	Power:SetHeight(10)
	Power:SetPoint('BOTTOM',Health,'BOTTOM',0,-10)
	Power:SetPoint('LEFT')
	Power:SetPoint('RIGHT')
	Power:SetFrameLevel(1)
	
	CreatePowerBackdrop(Power)
	-- Options
	Power.frequentUpdates = true
	Power.colorPower = true -- powertype colored bar
	Power.colorClassNPC = false -- color power based on NPC 
	Power.colorClassPet = false -- color power based on pet type
	-- Register it with oUF
	self.Power = Power
	self.Power.bg = Powerbg
	
	-----------------------------
	--Text

	--Name
	local NameText = Health:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
	NameText:SetPoint("TOP",Health,0,0) -- but anchor to the base element so it doesn't wiggle
	NameText:SetFont("Interface\\Addons\\PsychoUI\\Fonts\\Dialog.TTF", 11, "OUTLINE")
	NameText:SetJustifyH("CENTER")
	NameText:SetWidth(65)
	self:Tag(NameText, "[name]") -- oUF will automagically update it!
	Health.text = NameText
	--Health Percent
	local HealthText = Health:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
	HealthText:SetPoint("CENTER",Health,0,-10) -- but anchor to the base element so it doesn't wiggle
	HealthText:SetFont("Interface\\Addons\\PsychoUI\\Fonts\\Numbers.TTF", 10, "OUTLINE")
	HealthText:SetJustifyH("CENTER")
	self:Tag(HealthText, "[perhp]") -- oUF will automagically update it!
	Health.text = HealthText

	-----------------------------
	-- Rez Icon
	-- Position and sizew
	local ResurrectIcon = self.Health:CreateTexture(nil, 'OVERLAY')
	ResurrectIcon:SetSize(24, 24)
	ResurrectIcon:SetPoint('TOP', self, 'BOTTOM',40,-10)
   
	-- Register it with oUF
	self.ResurrectIcon = ResurrectIcon
	
	-----------------------------
	-- Raid icons
	-- Position and size
	local RaidTargetIndicator = self.Health:CreateTexture(nil, 'OVERLAY')
	RaidTargetIndicator:SetSize(24, 24)
	RaidTargetIndicator:SetPoint('RIGHT', self.Health,23,0)
	
	-- Register it with oUF
	self.RaidTargetIndicator = RaidTargetIndicator
	
	-----------------------------
	--Group roles
	 -- Position and size
    local GroupRoleIndicator = self:CreateTexture(nil, 'OVERLAY')
    GroupRoleIndicator:SetSize(24, 24)
    GroupRoleIndicator:SetPoint('RIGHT', self.Health,23,24)

    -- Register it with oUF
    self.GroupRoleIndicator = GroupRoleIndicator
	-- Raid Roles
	
	-- Position and size
	local RaidRoleIndicator = self.Health:CreateTexture(nil, 'OVERLAY')
	RaidRoleIndicator:SetSize(24, 24)
	RaidRoleIndicator:SetPoint('RIGHT', self.Health,23,-24)
   
	-- Register it with oUF
	self.RaidRoleIndicator = RaidRoleIndicator
	
	  -- Position and size
    local LeaderIndicator = self:CreateTexture(nil, 'OVERLAY')
    LeaderIndicator:SetSize(24, 24)
    LeaderIndicator:SetPoint('TOP', self,0,10)
	

    -- Register it with oUF
    self.LeaderIndicator = LeaderIndicator
	
	    -- Position and size
    local ReadyCheckIndicator = self:CreateTexture(nil, 'OVERLAY')
    ReadyCheckIndicator:SetSize(24, 24)
    ReadyCheckIndicator:SetPoint('BOTTOM', self, 'TOP',-30,0)

    -- Register with oUF
    self.ReadyCheckIndicator = ReadyCheckIndicator
	
	
	
   	------------------------
	-- Plugin: oUF_Smooth --
	------------------------
	
		self.Health.Smooth = true
		if self.Power then
			self.Power.Smooth = true
		end
	
   
   	----------------------------
	-- Plugin: oUF_SpellRange --
	----------------------------
	
	self.SpellRange = {
			insideAlpha = 1,
			outsideAlpha = 0.5,
		}
	--Range
	if unit == "pet" or unit == "party" or unit == "partypet" then
		self.Range = {
			insideAlpha = 1,
			outsideAlpha = 0.5,
		}
	end
	----------------------------
	-- Plugin: oUF_RaidDebuff --
	----------------------------
	
	local dbh = self:CreateTexture(nil, "OVERLAY")
	dbh:SetAllPoints(self)
	dbh:SetTexture("cfg.statusbar_texture")
	dbh:SetBlendMode("ADD")
	dbh:SetVertexColor(0,0,0,0) -- set alpha to 0 to hide the texture
	self.DebuffHighlightBackdrop = true
	self.DebuffHighlight = dbh
	
	
	
end

--Spawn Frames
oUF:RegisterStyle('PsychoRaid', Shared)
oUF:Factory(function(self)
if PsychoUI.db.char.EnableRaid == false then return end
	self:SetActiveStyle'PsychoRaid'
	RaidX = PsychoUI.db.char.RaidX
	RaidY = PsychoUI.db.char.RaidY
	
		local raid = self:SpawnHeader(nil, nil, 'raid,party,solo',
      'showRaid', true,
       'showSolo', PsychoUI.db.char.SoloRaid,
       'showPlayer', true,
       'showParty', false,
       'yOffset', -5,
	    'oUF-initialConfigFunction', [[
        self:SetHeight(30)
        self:SetWidth(65)
    ]],      
	'maxColumns', 5,
    'unitsperColumn', 1,
    'columnSpacing', 5,
    'columnAnchorPoint', "TOP"
	):SetPoint('TOPLEFT', UIParent,'TOPLEFT', RaidX, RaidY)




end)