--[[
##################
PsychoUI: keivamp#
##################
]]--
local PsychoUI = LibStub("AceAddon-3.0"):GetAddon("PsychoUI")
local LSM = LibStub and LibStub:GetLibrary("LibSharedMedia-3.0", true)
local _, ns = ...
local oUF = ns.oUF
local addonName, addon = ...
local InCombatLockdown      = _G.InCombatLockdown;

--LSM:Fetch("statusbar", PsychoUI.db.char.RepStatusBar)
	--LSM:Fetch("font", PsychoUI.db.char.RepFontKey)

local function CreateHealthBackdrop(frame)
    frame:SetBackdrop({bgFile = "Interface\\TargetingFrame\\UI-StatusBar"})
    frame:SetBackdropColor(0.35,0.1,0.1,0.85)
	frame:SetBackdropBorderColor(0,0,0,1)
end

local function CreatePowerBackdrop(frame)
      frame:SetBackdrop({bgFile = "Interface\\TargetingFrame\\UI-StatusBar",
	   insets = {top = -2, left = -2, bottom = -2, right = -2}})
		frame:SetBackdropColor(0,0,0,1)
	frame:SetBackdropBorderColor(0,0,0,1)
end

local function CreateBackdrop(frame)
      frame:SetBackdrop({bgFile = "Interface\\TargetingFrame\\UI-StatusBar"})
		frame:SetBackdropColor(0,0,0,0.75)
		frame:SetBackdropBorderColor(0,0,0,0)
end
local function CreateMoverBackdrop(frame)
   frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
        insets = {top = -2, left = -2, bottom = -2, right = -2}})
		frame:SetBackdropColor(0,0.55,0.95,0.45)
		frame:SetBackdropBorderColor(0,0,0,1)
end
	local Mover = CreateFrame("Frame","TargetDrag",UIParent, BackdropTemplateMixin and "BackdropTemplate")
	Mover:SetSize(123,55)
	Mover:SetPoint("CENTER",UIParent,"CENTER",35,-250)
	Mover:SetClampedToScreen(true)
	Mover:SetClampRectInsets(0, 0, 0,0)
	local MoverText  = Mover:CreateFontString(nil, "OVERLAY")
	MoverText:SetFont("Interface\\Addons\\PsychoUI\\Fonts\\Dialog.TTF", 18, "OUTLINE")
	MoverText:SetPoint("CENTER",Mover,"CENTER", 0,0); 
	MoverText:SetText("")
	
	local TargetX = 35
	local TargetY = -250

local UnitSpecific = {
	
	target = function(self)
if PsychoUI.db.char.TargetFrameDisable == true then return end
local function DatabaseCheck()
		if PsychoUI.db.char.lockframes == false then 
			TargetX = PsychoUI.db.char.TargetX
			TargetY = PsychoUI.db.char.TargetY
			Mover:SetPoint("CENTER",UIParent,"CENTER",TargetX,TargetY)
			MoverText:SetText("Target")
			Mover:Show()
			CreateMoverBackdrop(Mover)
		else
		
		end
		if PsychoUI.db.char.ResetBox == true then 
			TargetX = -235
			TargetY = -250
			Mover:ClearAllPoints()
			Mover:SetPoint("CENTER",UIParent,"CENTER",35,-250)
		end
	end
local DB_Check_Frame = CreateFrame("Frame")	
DB_Check_Frame:HookScript("OnUpdate", DatabaseCheck)
		--------------------
		--  Target Set Up --
		--------------------
		local TargetWidth = 123;
		local TargetHeight = 55;
		local PortraitWidth = 55;
		local PortraitHeight = 59;
		self:SetSize(TargetWidth,TargetHeight)

		-------------------------------------
		--  Adjust Target Health and Power --
		-------------------------------------

		self.Health:SetHeight(31)
		self.Power:SetHeight(22)

		-------------------------
		--  Target Level Value --
		-------------------------
		--LSM:Fetch("statusbar", PsychoUI.db.char.RepStatusBar)
		--LSM:Fetch("font", PsychoUI.db.char.RepFontKey)
		local TheLevelFontOutline = "NONE"
		if PsychoUI.db.char.TargetFrameLevelFontOutline == 1 then
		TheLevelFontOutline = "NONE"
		elseif PsychoUI.db.char.TargetFrameLevelFontOutline == 2 then
		TheLevelFontOutline = "MONOCHROMEOUTLINE"
		elseif PsychoUI.db.char.TargetFrameLevelFontOutline == 3 then
		TheLevelFontOutline = "THINOUTLINE"
		elseif PsychoUI.db.char.TargetFrameLevelFontOutline == 4 then
		TheLevelFontOutline = "THICKOUTLINE"
		end

		local LevelText = self:CreateFontString(nil, "OVERLAY", "TextStatusBarText")
		if PsychoUI.db.char.TargetFrameDisablePortrait == true then
		LevelText:SetPoint("RIGHT", self, 60,0) 
		else
		LevelText:SetPoint("RIGHT", self, 114,20) 
		end
		LevelText:SetFont(LSM:Fetch("font", PsychoUI.db.char.TargetFrameLevelFont), PsychoUI.db.char.TargetFrameLevelFontSize, TheLevelFontOutline)
		LevelText:SetWidth(50)
		LevelText:SetJustifyH("LEFT")
		if PsychoUI.db.char.TargetFrameDisableLevel == false then
		self:Tag(LevelText, "[level]")
		end

		-------------------------
		--  Target Name Value --
		-------------------------
		local TheNameFontOutline = "NONE"
		if PsychoUI.db.char.TargetFrameNameFontOutline == 1 then
		TheNameFontOutline = "NONE"
		elseif PsychoUI.db.char.TargetFrameNameFontOutline == 2 then
		TheNameFontOutline = "MONOCHROMEOUTLINE"
		elseif PsychoUI.db.char.TargetFrameNameFontOutline == 3 then
		TheNameFontOutline = "THINOUTLINE"
		elseif PsychoUI.db.char.TargetFrameNameFontOutline == 4 then
		TheNameFontOutline = "THICKOUTLINE"
		end

		local NameText = self:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		NameText:SetPoint("TOPLEFT", self, 0,20) -- but anchor to the base element so it doesn't wiggle
		NameText:SetJustifyH("LEFT")
		NameText:SetFont(LSM:Fetch("font", PsychoUI.db.char.TargetFrameNameFont), PsychoUI.db.char.TargetFrameNameFontSize, TheNameFontOutline)
		NameText:SetWidth(400)
		if PsychoUI.db.char.TargetFrameDisableName == false then
		self:Tag(NameText, "[name]")
		end

		-------------------------
		--  Target Power Value --
		-------------------------
		local ThePowerFontOutline = "NONE"
		if PsychoUI.db.char.TargetFrameManaFontOutline == 1 then
		ThePowerFontOutline = "NONE"
		elseif PsychoUI.db.char.TargetFrameManaFontOutline == 2 then
		ThePowerFontOutline = "MONOCHROMEOUTLINE"
		elseif PsychoUI.db.char.TargetFrameManaFontOutline == 3 then
		ThePowerFontOutline = "THINOUTLINE"
		elseif PsychoUI.db.char.TargetFrameManaFontOutline == 4 then
		ThePowerFontOutline = "THICKOUTLINE"
		end

		local PowerText = self:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		if PsychoUI.db.char.TargetFrameDisableMana == true then
			PowerText:SetPoint("CENTER", self, 0,-20)
			else
			PowerText:SetPoint("LEFT", self, 5,-20)
			end
		PowerText:SetFont(LSM:Fetch("font", PsychoUI.db.char.TargetFrameManaFont), PsychoUI.db.char.TargetFrameManaFontSize, ThePowerFontOutline)
		if PsychoUI.db.char.TargetFrameDisableManaPercent == false then
		self:Tag(PowerText, "[perpp]".." %")
		end

		local PowerText2 = self:CreateFontString(nil, "OVERLAY", "TextStatusBarText")
		if PsychoUI.db.char.TargetFrameDisableManaPercent == true then
			PowerText2:SetPoint("CENTER", self, 0,-20)
			else
			PowerText2:SetPoint("RIGHT", self, -2,-20)
			end
		PowerText2:SetFont(LSM:Fetch("font", PsychoUI.db.char.TargetFrameManaFont), PsychoUI.db.char.TargetFrameManaFontSize, ThePowerFontOutline)
		if PsychoUI.db.char.TargetFrameDisableMana == false then
		self:Tag(PowerText2, "[PsychoUI:MyPower]")
		end

		--------------------------
		--  Target Health Value --
		--------------------------
		local TheHealthFontOutline = "NONE"
		if PsychoUI.db.char.TargetFrameHealthFontOutline == 1 then
		TheHealthFontOutline = "NONE"
		elseif PsychoUI.db.char.TargetFrameHealthFontOutline == 2 then
		TheHealthFontOutline = "MONOCHROMEOUTLINE"
		elseif PsychoUI.db.char.TargetFrameHealthFontOutline == 3 then
		TheHealthFontOutline = "THINOUTLINE"
		elseif PsychoUI.db.char.TargetFrameHealthFontOutline == 4 then
		TheHealthFontOutline = "THICKOUTLINE"
		end

		local HealthText = self:CreateFontString(nil, "OVERLAY", "TextStatusBarText")
		if PsychoUI.db.char.TargetFrameDisableHealth == true then
			HealthText:SetPoint("CENTER", self, 0,12)
			else
			HealthText:SetPoint("LEFT", self, 5,12)
			end
		
		HealthText:SetFont(LSM:Fetch("font", PsychoUI.db.char.TargetFrameHealthFont), PsychoUI.db.char.TargetFrameHealthFontSize, TheHealthFontOutline)
		if PsychoUI.db.char.TargetFrameDisableHealthPercent == false then
		self:Tag(HealthText, "[perhp]".." %")
		end

		local HealthText2 = self:CreateFontString(nil, "OVERLAY", "TextStatusBarText")
		if PsychoUI.db.char.TargetFrameDisableHealthPercent == true then
			HealthText2:SetPoint("CENTER", self, 0,12)
			else
			HealthText2:SetPoint("RIGHT", self, -5,12)
			end
		
		HealthText2:SetFont(LSM:Fetch("font", PsychoUI.db.char.TargetFrameHealthFont), PsychoUI.db.char.TargetFrameHealthFontSize, TheHealthFontOutline)
		if PsychoUI.db.char.TargetFrameDisableHealth == false then
		self:Tag(HealthText2, "[PsychoUI:MyHealth]")
		end
		
		
		--------------------
		--  Elite Units   --
		--------------------
		local EliteText = self:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		EliteText:SetPoint("BOTTOM", self, 0,-25) -- but anchor to the base element so it doesn't wiggle
		EliteText:SetFont(LSM:Fetch("font", PsychoUI.db.char.TargetFrameHealthFont),PsychoUI.db.char.TargetFrameHealthFontSize + 4,TheHealthFontOutline)
		EliteText:SetJustifyH("LEFT")--classification
		self:Tag(EliteText, "[classification]")

		----------------------
		--  Target Portrait --
		----------------------
		if PsychoUI.db.char.TargetFrameDisablePortrait == false then
		self.Portrait:SetPoint('LEFT', self, 'RIGHT',5,-2)
		self.Portrait:SetSize(PortraitWidth, PortraitHeight)
		end
		-----------------------
		--  Target Cast bar --
		-----------------------
		if PsychoUI.db.char.TargetFrameDisableCB == false then
		self.Castbar:SetSize(180, 20)
		self.Castbar:SetPoint('BOTTOMLEFT', self.Health, 2, -65)
		end
		-----------------------------
		-- Target Auras
		-----------------------------
		if PsychoUI.db.char.TargetFrameDisableAuras == false then
		local Auras = CreateFrame("Frame", nil, self, BackdropTemplateMixin and "BackdropTemplate")
		Auras:SetPoint("BOTTOMLEFT", self, "TOPLEFT", 0,40)
		Auras:SetPoint("BOTTOMRIGHT", self, "TOPRIGHT", 60, 40)
		Auras:SetHeight(25)
		Auras:SetHeight(25 + 4)

		Auras.size = 25
		Auras.onlyShowPlayer = false
		Auras.gap = 2
		Auras.spacing = 2
		Auras.showStealableAuras = true
		Auras.disableCooldown = false
		Auras.num = 32

		Auras.PostCreateIcon = Aura_PostCreateIcon
		self.Auras = Auras
		end
	--	end
		-----------------
		--  Target Floating Combat Text--
		-----------------
		if PsychoUI.db.char.TargetFrameFloatingCombatText == true then
			local TheFCTFontOutline = "NONE"
			if PsychoUI.db.char.TargetFrameFCFNameFontOutline == 1 then
			TheFCTFontOutline = "NONE"
			elseif PsychoUI.db.char.TargetFrameFCFNameFontOutline == 2 then
			TheFCTFontOutline = "MONOCHROMEOUTLINE"
			elseif PsychoUI.db.char.TargetFrameFCFNameFontOutline == 3 then
			TheFCTFontOutline = "THINOUTLINE"
			elseif PsychoUI.db.char.TargetFrameFCFNameFontOutline == 4 then
			TheFCTFontOutline = "THICKOUTLINE"
			end
		
		local fcf = CreateFrame("Frame", nil, self, BackdropTemplateMixin and "BackdropTemplate")
		fcf:SetSize(32, 32)
		fcf:SetPoint("CENTER",0,150)

		for i = 1, 6 do
			-- give names to these font strings to avoid breaking /fstack and /tinspect
			fcf[i] = fcf:CreateFontString("$parentFCFText" .. i, "OVERLAY")
		end

		fcf.font = LSM:Fetch("font", PsychoUI.db.char.TargetFrameFCFNameFont)
		fcf.fontHeight = PsychoUI.db.char.TargetFrameFCFNameFontSize
		fcf.fontFlags = TheFCTFontOutline

		self.FloatingCombatFeedback = fcf
		end
		-----------------
		--  Target PVP --
		-----------------

		local TargetPVPFrame = CreateFrame("Frame", BackdropTemplateMixin and "BackdropTemplate")
		TargetPVPFrame:SetSize(32, 32)
		TargetPVPFrame:SetPoint("RIGHT", self, 35,-45);
		TargetPVPFrame:Hide()
		TargetPVPFrame.Bg = TargetPVPFrame:CreateTexture(nil, "BACKGROUND")
			local color = RAID_CLASS_COLORS[select(2, UnitClass("player"))]
				local MyRed = color.r
				local MyGreen = color.g
				local MyBlue = color.b
			
		TargetPVPFrame.Bg:SetVertexColor(MyRed, MyGreen, MyBlue, 0.95);
		TargetPVPFrame.Bg:SetTexture("Interface\\Addons\\PsychoUI\\Textures\\Unit Frames\\pvp")
		TargetPVPFrame.Bg:SetPoint("RIGHT", self, 72,-10);
		TargetPVPFrame.Bg:SetSize(32, 32)
		function PVPMe()
			if UnitIsPVP("target") then
				TargetPVPFrame:Show()
			else
				TargetPVPFrame:Hide()
			end

		end
		local PVPMeframe = CreateFrame("Frame")
		PVPMeframe:HookScript("OnUpdate", PVPMe)
		
		--------------
	-- Rez Icon --
	--------------

	-- Position and sizew
	local ResurrectIcon = self.Health:CreateTexture(nil, 'OVERLAY')
	ResurrectIcon:SetSize(24, 24)
	ResurrectIcon:SetPoint('LEFT', self,-28,-24)

	-- Register it with oUF
	self.ResurrectIcon = ResurrectIcon
	
	--------------------------
	-- Group Role Indicator --
	--------------------------
	
	  -- Position and size
    local GroupRoleIndicator = self:CreateTexture(nil, 'OVERLAY')
    GroupRoleIndicator:SetSize(24, 24)
    GroupRoleIndicator:SetPoint('LEFT', self,-28,24)

    -- Register it with oUF
    self.GroupRoleIndicator = GroupRoleIndicator

	----------------
	-- Raid icons --
	----------------

	-- Position and size
	local RaidTargetIndicator = self.Health:CreateTexture(nil, 'OVERLAY')
	RaidTargetIndicator:SetSize(24, 24)
	RaidTargetIndicator:SetPoint('LEFT', self,-28,0)

	-- Register it with oUF
	self.RaidTargetIndicator = RaidTargetIndicator

	end, -- End Target
	

}
	--UnitSpecific.arena = UnitSpecific.boss

local Shared = function(self, unit)
if PsychoUI.db.char.TargetFrameDisable == true then return end
self:SetScale(PsychoUI.db.char.TargetFrameScale)
	-- Shared layout code.
	-----------------
	--  Mouse Code --
	-----------------
	self:SetScript('OnEnter', UnitFrame_OnEnter)
	self:SetScript('OnLeave', UnitFrame_OnLeave)

	self:RegisterForClicks'AnyUp'
	------------------
	--  Health Bars --
	------------------

	local Health = CreateFrame("StatusBar", nil, self, BackdropTemplateMixin and "BackdropTemplate")
	Health:SetStatusBarTexture(LSM:Fetch("statusbar", PsychoUI.db.char.TargetFrameStatusBarHealth))
	Health:SetPoint('TOP')
	Health:SetPoint('LEFT')
	Health:SetPoint('RIGHT')
	Health:SetReverseFill(true);
	CreateHealthBackdrop(Health)

	-- Options
	Health.frequentUpdates = true
	Health.colorTapping = true
	Health.colorDisconnected = true
	Health.colorClass = true
	Health.colorReaction = true
	Health.colorHealth = true
	-- Register it with oUF
	self.Health = Health
	self.Health.bg = Healthbg
	Health:SetFrameLevel(2)
	if PsychoUI.db.char.TargetFrameNoBorder == false then
	Health:CreateBeautyBorder(PsychoUI.db.char.TargetFrameBorderSize)
	Health:SetBeautyBorderPadding(PsychoUI.db.char.TargetFrameBorderPadding)
	Health:SetBeautyBorderTexture("white")
	Health:SetBeautyBorderColor(0.45, 0.45, 0.45,1)
	end
					
		

    -----------------
	--  Power Bars --
	-----------------

	local Power = CreateFrame("StatusBar", nil, Health, BackdropTemplateMixin and "BackdropTemplate")
	Power:SetStatusBarTexture(LSM:Fetch("statusbar", PsychoUI.db.char.TargetFrameStatusBarPower))
	Power:SetPoint('BOTTOM',Health,'BOTTOM',0,-28)
	Power:SetPoint('LEFT')
	Power:SetPoint('RIGHT')
	Power:SetReverseFill(true);
	Power:SetFrameLevel(1)
	if PsychoUI.db.char.TargetFrameNoBorder == false then
	Power:CreateBeautyBorder(PsychoUI.db.char.TargetFrameBorderSize)
	Power:SetBeautyBorderPadding(PsychoUI.db.char.TargetFrameBorderPadding)
	Power:SetBeautyBorderTexture("white")
	Power:SetBeautyBorderColor(0.45, 0.45, 0.45,1)
	end
					
	
	CreatePowerBackdrop(Power)
	-- Options
	Power.frequentUpdates = true
	Power.colorPower = true 
	Power.colorClassNPC = false 
	Power.colorClassPet = false 
	-- Register it with oUF
	self.Power = Power


	------------------
	--   Portrait --
	------------------
	if PsychoUI.db.char.TargetFrameDisablePortrait == false then
	-- 3D Portrait
	local Portrait = CreateFrame('PlayerModel', nil, self, BackdropTemplateMixin and "BackdropTemplate")

	CreateBackdrop(Portrait)
	Portrait:SetBackdrop({bgFile = "Interface\\Addons\\PsychoUI\\Textures\\Buttons\\UNIT-BG13",
    insets = {top = 0, left = 0, bottom = 0, right = 0}})
	Portrait:SetBackdropColor(0,0,0,1)
	if PsychoUI.db.char.TargetFrameNoBorder == false then
	Portrait:CreateBeautyBorder(PsychoUI.db.char.TargetFrameBorderSize)
	Portrait:SetBeautyBorderPadding(PsychoUI.db.char.TargetFrameBorderPadding)
	Portrait:SetBeautyBorderTexture("white")
	Portrait:SetBeautyBorderColor(0.45, 0.45, 0.45,1)
	end
					
		

	-- Register it with oUF
	self.Portrait = Portrait
	end

	--------------
	-- Cast Bar --
	--------------
	if PsychoUI.db.char.TargetFrameDisableCB == false then
	-- Position and size
	local Castbar = CreateFrame("StatusBar", nil, self, BackdropTemplateMixin and "BackdropTemplate")
	Castbar:SetStatusBarTexture(LSM:Fetch("statusbar", PsychoUI.db.char.TargetFrameStatusBarCB))
	Castbar:SetReverseFill(true);
	Castbar:SetStatusBarColor(0.95, 0.25, 0.25, 0.95)
	if PsychoUI.db.char.TargetFrameNoBorder == false then
	Castbar:CreateBeautyBorder(PsychoUI.db.char.TargetFrameBorderSize)
	Castbar:SetBeautyBorderPadding(PsychoUI.db.char.TargetFrameBorderPadding)
	Castbar:SetBeautyBorderTexture("white")
	Castbar:SetBeautyBorderColor(0.45, 0.45, 0.45,1)
	end
	
	-- Add a background
	CreateBackdrop(Castbar)
	-- Add a spark
	local Spark = Castbar:CreateTexture(nil, "OVERLAY")
	Spark:SetSize(40, 12)
	Spark:SetBlendMode("ADD")

	-- Add a timer
	local Time = Castbar:CreateFontString(nil, "OVERLAY", "GameFontNormalSmall")
	Time:SetFont("Interface\\Addons\\PsychoUI\\Fonts\\Dialog.TTF", 10, "OUTLINE")
	Time:SetTextColor(0.99, 0.99, 0.99)
	Time:SetPoint("LEFT", Castbar, 3, 1)

	-- Add spell text
	local Text = Castbar:CreateFontString(nil, "OVERLAY", "GameFontNormalSmall")
	Text:SetFont("Interface\\Addons\\PsychoUI\\Fonts\\Dialog.TTF", 11, "OUTLINE")
	Text:SetTextColor(0.99, 0.99, 0.99)
	Text:SetPoint("RIGHT", Castbar, -3, 1)

	-- Add Shield
	local Shield = Castbar:CreateTexture(nil, "OVERLAY")
	Shield:SetSize(25, 15)
	Shield:SetPoint("CENTER", Castbar)

	local Icon = Castbar:CreateTexture(nil, 'OVERLAY')
    Icon:SetSize(26, 26)
    Icon:SetPoint('LEFT', Castbar, 'RIGHT', 0,0)
	-- Add safezone
	local SafeZone = Castbar:CreateTexture(nil, "OVERLAY")

	-- Register it with oUF
	self.Castbar = Castbar
	self.Castbar.bg = Background
	self.Castbar.Spark = Spark
	self.Castbar.Time = Time
	self.Castbar.Text = Text
	self.Castbar.SafeZone = SafeZone
	self.Castbar.Icon = Icon
	end
	-----------------
	-- Smooth Bars --
	-----------------

	self.Health.Smooth = true
		if self.Power then
			self.Power.Smooth = true
		end

	if(UnitSpecific[unit]) then
		return UnitSpecific[unit](self)
	end
end

oUF:RegisterStyle("PsychoTarget", Shared)
oUF:Factory(function(self)
if PsychoUI.db.char.TargetFrameDisable == true then return end
	TargetX = PsychoUI.db.char.TargetX
	TargetY = PsychoUI.db.char.TargetY
	-----------------
	-- Unit Set Up --
	-----------------
     self:SetActiveStyle("PsychoTarget")
	 self:Spawn("target"):SetPoint("CENTER",UIParent,"CENTER",TargetX,TargetY);


end)
