--[[
##################
PsychoUI: keivamp#
##################
]]--
local PsychoUI = LibStub("AceAddon-3.0"):GetAddon("PsychoUI")
local LSM = LibStub and LibStub:GetLibrary("LibSharedMedia-3.0", true)

local _, ns = ...
local oUF = ns.oUF
local addonName, addon = ...
local InCombatLockdown      = _G.InCombatLockdown;

local function CreateHealthBackdrop(frame)
    frame:SetBackdrop({bgFile = "Interface\\TargetingFrame\\UI-StatusBar"})
    frame:SetBackdropColor(0.35,0.1,0.1,0.85)
	frame:SetBackdropBorderColor(0,0,0,1)
end

local function CreatePowerBackdrop(frame)
      frame:SetBackdrop({bgFile = "Interface\\TargetingFrame\\UI-StatusBar"})
		frame:SetBackdropColor(0.25,0.25,0.75,0.75)
	frame:SetBackdropBorderColor(0,0,0,1)
end

local function CreateMoverBackdrop(frame)
   frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
        insets = {top = -2, left = -2, bottom = -2, right = -2}})
		frame:SetBackdropColor(0,0.55,0.95,0.45)
		frame:SetBackdropBorderColor(0,0,0,1)
end
local Mover = CreateFrame("Frame","ToTDrag",UIParent, BackdropTemplateMixin and "BackdropTemplate")

	Mover:SetSize(95,35)
	Mover:SetPoint("CENTER",UIParent,"CENTER",235,-335)
	Mover:SetClampedToScreen(true)
	Mover:SetClampRectInsets(0, 0, 0,0)

	local MoverText  = Mover:CreateFontString(nil, "OVERLAY")
	MoverText:SetFont("Interface\\Addons\\PsychoUI\\Fonts\\Dialog.TTF", 13, "OUTLINE")
	MoverText:SetPoint("CENTER",Mover,"CENTER", 0,0); 
	MoverText:SetText("")
	
	local TotX = 235
	local TotY = -335


local UnitSpecific = {

	targettarget = function(self)
	if PsychoUI.db.char.ToTFrameDiable == true then return end
	local function DatabaseCheck()
		if PsychoUI.db.char.lockframes == false then 
			TotX = PsychoUI.db.char.TotX
			TotY = PsychoUI.db.char.TotY
		
			Mover:SetPoint("CENTER",UIParent,"CENTER",TotX,TotY)
			MoverText:SetText("Target of Target")
			Mover:Show()
			CreateMoverBackdrop(Mover)
		else
		
		end
		if PsychoUI.db.char.ResetBox == true then 
			TotX = 235
			TotY = -335
			Mover:ClearAllPoints()
			Mover:SetPoint("CENTER",UIParent,"CENTER",235,-335)
		end
		
	end
	local DB_Check_Frame = CreateFrame("Frame")	
	DB_Check_Frame:HookScript("OnUpdate", DatabaseCheck)
	
		local ToTTargetWidth = 95;
		local ToTTargetHeight = 35;
		self:SetSize(ToTTargetWidth,ToTTargetHeight)

		---------------------------------
		-- Target of Target Neame Text --
		---------------------------------
		local TheNameFontOutline = "NONE"
		if PsychoUI.db.char.ToTFrameNameFontOutline == 1 then
		TheNameFontOutline = "NONE"
		elseif PsychoUI.db.char.ToTFrameNameFontOutline == 2 then
		TheNameFontOutline = "MONOCHROMEOUTLINE"
		elseif PsychoUI.db.char.ToTFrameNameFontOutline == 3 then
		TheNameFontOutline = "THINOUTLINE"
		elseif PsychoUI.db.char.ToTFrameNameFontOutline == 4 then
		TheNameFontOutline = "THICKOUTLINE"
		end

		local NameText = self:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		NameText:SetPoint("TOPLEFT", self, 0,15) -- but anchor to the base element so it doesn't wiggle
		NameText:SetJustifyH("LEFT")
		NameText:SetFont(LSM:Fetch("font", PsychoUI.db.char.ToTFrameNameFont), PsychoUI.db.char.ToTFrameNameFontSize, TheNameFontOutline)
		NameText:SetWidth(300)
		if PsychoUI.db.char.ToTFrameDisableName == false then
		self:Tag(NameText, "[name]") 
		end

		----------------------------------
		-- Target of Target Power Value --
		----------------------------------
		local ThePowerFontOutline = "NONE"
		if PsychoUI.db.char.ToTFrameManaFontOutline == 1 then
		ThePowerFontOutline = "NONE"
		elseif PsychoUI.db.char.ToTFrameManaFontOutline == 2 then
		ThePowerFontOutline = "MONOCHROMEOUTLINE"
		elseif PsychoUI.db.char.ToTFrameManaFontOutline == 3 then
		ThePowerFontOutline = "THINOUTLINE"
		elseif PsychoUI.db.char.ToTFrameManaFontOutline == 4 then
		ThePowerFontOutline = "THICKOUTLINE"
		end

		local PowerText = self:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		PowerText:SetPoint("CENTER", self, 0,-23) -- but anchor to the base element so it doesn't wiggle
		PowerText:SetFont(LSM:Fetch("font", PsychoUI.db.char.ToTFrameManaFont), PsychoUI.db.char.ToTFrameManaFontSize, ThePowerFontOutline)
		if PsychoUI.db.char.ToTFrameDisableMana == false then
		self:Tag(PowerText, "[perpp]".." %") -- oUF will automagically update it!
		end
		--PowerText:SetAlpha(1)
		


		-----------------------------------
		-- Target of Target Health Value --
		-----------------------------------
		local TheHealthFontOutline = "NONE"
		if PsychoUI.db.char.ToTFrameHealthFontOutline == 1 then
		TheHealthFontOutline = "NONE"
		elseif PsychoUI.db.char.ToTFrameHealthFontOutline == 2 then
		TheHealthFontOutline = "MONOCHROMEOUTLINE"
		elseif PsychoUI.db.char.ToTFrameHealthFontOutline == 3 then
		TheHealthFontOutline = "THINOUTLINE"
		elseif PsychoUI.db.char.ToTFrameHealthFontOutline == 4 then
		TheHealthFontOutline = "THICKOUTLINE"
		end

		local HealthText = self:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		HealthText:SetPoint("CENTER", self, 0,4) -- but anchor to the base element so it doesn't wiggle
		HealthText:SetFont(LSM:Fetch("font", PsychoUI.db.char.ToTFrameHealthFont), PsychoUI.db.char.ToTFrameHealthFontSize, TheHealthFontOutline)
		if PsychoUI.db.char.ToTFrameDisableHealth == false then
		self:Tag(HealthText, "[perhp]".." %") 
		end


		-------------------------------------------------------
		-- Target of Target Health and Power Bar Adjustments --
		-------------------------------------------------------

		self.Health:SetHeight(25)
		self.Power:SetHeight(20)


	end, -- End Target of Target
	
}
	--UnitSpecific.arena = UnitSpecific.boss

local Shared = function(self, unit)
	if PsychoUI.db.char.ToTFrameDiable == true then return end
	self:SetScale(PsychoUI.db.char.ToTFrameScale)
	-- Shared layout code.

	-----------------
	--  Mouse Code --
	-----------------
	self:SetScript('OnEnter', UnitFrame_OnEnter)
	self:SetScript('OnLeave', UnitFrame_OnLeave)

	self:RegisterForClicks'AnyUp'
	------------------
	--  Health Bars --
	------------------

	local Health = CreateFrame("StatusBar", nil, self, BackdropTemplateMixin and "BackdropTemplate")
	Health:SetStatusBarTexture(LSM:Fetch("statusbar", PsychoUI.db.char.ToTFrameStatusBarHealth))
	Health:SetPoint('TOP')
	Health:SetPoint('LEFT')
	Health:SetPoint('RIGHT')
	Health:SetFrameLevel(2)
	CreateHealthBackdrop(Health)
	if PsychoUI.db.char.ToTFrameNoBorder == false then
	Health:CreateBeautyBorder(PsychoUI.db.char.ToTFrameBorderSize)
	Health:SetBeautyBorderPadding(PsychoUI.db.char.ToTFrameBorderPadding)
	Health:SetBeautyBorderTexture("white")
	Health:SetBeautyBorderColor(0.45, 0.45, 0.45,1)
	end


	-- Options
	Health.frequentUpdates = true
	Health.colorTapping = true
	Health.colorDisconnected = true
	Health.colorClass = true
	Health.colorReaction = true
	Health.colorHealth = true
	-- Register it with oUF
	self.Health = Health
	self.Health.bg = Healthbg


    -----------------
	--  Power Bars --
	-----------------

	local Power = CreateFrame("StatusBar", nil, Health, BackdropTemplateMixin and "BackdropTemplate")
	Power:SetStatusBarTexture(LSM:Fetch("statusbar", PsychoUI.db.char.ToTFrameStatusBarPower))
	Power:SetPoint('BOTTOM',Health,'BOTTOM',0,-25)
	Power:SetPoint('LEFT')
	Power:SetPoint('RIGHT')
	Power:SetFrameLevel(1)
	CreatePowerBackdrop(Power)
	if PsychoUI.db.char.ToTFrameNoBorder == false then
	Power:CreateBeautyBorder(PsychoUI.db.char.ToTFrameBorderSize)
	Power:SetBeautyBorderPadding(PsychoUI.db.char.ToTFrameBorderPadding)
	Power:SetBeautyBorderTexture("white")
	Power:SetBeautyBorderColor(0.45, 0.45, 0.45,1)
	end

	-- Options
	Power.frequentUpdates = true
	Power.colorPower = true -- powertype colored bar
	Power.colorClassNPC = false -- color power based on NPC
	Power.colorClassPet = false -- color power based on pet type
	-- Register it with oUF
	self.Power = Power
	self.Power.bg = Powerbg


	-----------------
	-- Smooth Bars --
	-----------------

	self.Health.Smooth = true
		if self.Power then
			self.Power.Smooth = true
		end


	if(UnitSpecific[unit]) then
		return UnitSpecific[unit](self)
	end
end

oUF:RegisterStyle("PsychoTargetTarget", Shared)
oUF:Factory(function(self)
if PsychoUI.db.char.ToTFrameDiable == true then return end
	TotX = PsychoUI.db.char.TotX
	TotY = PsychoUI.db.char.TotY
	-----------------
	-- Unit Set Up --
	-----------------
	self:SetActiveStyle("PsychoTargetTarget")
	self:Spawn("targettarget"):SetPoint("CENTER",UIParent,"CENTER",TotX,TotY);


end)
